<?php defined('BASEPATH') OR exit('No direct script access allowed');

class Agent_model extends CI_Model {

	private $_agent;
    private $_id;

    public function __construct()
    {
        parent::__construct();
        $this->load->database();
		$this->load->add_package_path(APPPATH.'third_party/ion_auth/');
		$this->load->library(array('ion_auth'));        
    }

    public function get_agent($id = NULL)
    {
        // Get client from db
        $this->_agent = $this->db
            ->where('id',$id)
            ->limit(1)
            ->get('users')->row();

        return $this->_agent;

    }    
    public function get_agents()
    {
        // Get client from db
        $this->_agent = $this->db
            ->get('users')->result();
        return $this->_agent;
    } 
    public function get_agents_term($term="")
    {   //echo $term;
        // Get client from db
        $this->db->like('email',$term);
        $this->db->or_like('first_name',$term);
        $this->db->or_like('middle_name',$term);
        $this->db->or_like('last_name',$term);
        $this->_agent = $this->db
            ->get('users')->result();
        return $this->_agent;
    }    
    public function get_agent_byemail($email = NULL)
    {
        // Get client from db
        $this->_agent = $this->db
            ->where('email',$email)
            ->limit(1)
            ->get('users');

        return $this->_agent;

    }

    public function update_agent_subscription($agentid)
    {
        $today = date('Y-m-d');

    	$update = array(
            "subscription" => "success",
    		"subscription_expire" => strtotime($today. ' + 365 days')
    	);

        $this->db->where('email',$agentid);
    	$this->db->update('users', $update);
    	return true;
    }
    public function update_agent($data)
    {
        $this->db->where('id',$this->session->userdata('user_id'));
    	$this->db->update('users', $data);
    	return true;
    }
    public function update_admin($data)
    {
        $this->db->where('email',"admin@gmail.com");
    	$this->db->update('users', $data);
    	return true;
    }
    public function update_client_flow($data)
    {
        $this->db->where('user_id',$this->session->userdata('user_id'));
        $this->db->where('client_id',$data['client_id']);
        $this->db->where('contract_id',$data['contract_id']);
        $row_val=$this->db->get('contract_flow_rel')->row();
        if($row_val){
            $this->db->where('id', $row_val->id);
            $this->db->update('contract_flow_rel', $data);
        }else{
            $this->db->insert('contract_flow_rel', $data);
        }
    	
    	return true;
    }
    public function get_agreement_flow($data){

        $this->db->where($data);
        return $row_val=$this->db->get('contract_flow_rel')->row();
    
    }
    public function create_link($data){
        return $row_val=$this->db->insert('shared_docs',$data);    
    }
    public function update_link($data,$where_clause=null){
        $this->db->where($where_clause);
        return $row_val=$this->db->update('shared_docs',$data);    
    }    
    public function get_link($where_clause){
        $this->db->where($where_clause);
        return $row_val=$this->db->get('shared_docs')->row();    
    }
}