<?php
/**
 * Stripe - Payment Gateway integration (Stripe Checkout)
 * ==============================================================================
 * 
 * @version v1.0: subscribe.php
 * @copyright Copyright (c) 2018, http://www.unleadedgroup
 * @author 
 * 
 * ==============================================================================
 *
 */

// Stripe library
require APPPATH.('/libraries/stripe/Stripe.php');

$params = array(
	"testmode"   => "on",
	"private_live_key" => "sk_live_xxxxxxxxxxxxxxxxxxxxx",
	"public_live_key"  => "pk_live_xxxxxxxxxxxxxxxxxxxxx",
	"private_test_key" => "sk_test_7dcADeUSxjLYRBTf5nvh2DST",
	"public_test_key"  => "pk_test_AoXbdP1Pvh6Majrcud6tZ0u8"
);

if ($params['testmode'] == "on") {
	Stripe::setApiKey($params['private_test_key']);
	$pubkey = $params['public_test_key'];
} else {
	Stripe::setApiKey($params['private_live_key']);
	$pubkey = $params['public_live_key'];
}


if(isset($_POST['stripeToken']))
{
	$amount_cents = str_replace(".","",$amount);  // Chargeble amount
	$invoiceid = time();                      // Invoice ID
	$description = "Invoice #" . $invoiceid . " - " . $invoiceid;

	try {
		$charge = Stripe_Charge::create(array(		 
			  "amount" => $amount_cents,
			  "currency" => "usd",
			  "source" => $_POST['stripeToken'],
			  "description" => $description)			  
		);

		/*if ($charge->card->address_zip_check == "fail") {
			throw new Exception("zip_check_invalid");
		} else if ($charge->card->address_line1_check == "fail") {
			throw new Exception("address_check_invalid");
		} else if ($charge->card->cvc_check == "fail") {
			throw new Exception("cvc_check_invalid");
		}*/
		// Payment has succeeded, no exceptions were thrown or otherwise caught				

        $result = "success";
        

	} catch(Stripe_CardError $e) {			

    $error = $e->getMessage();
    
		$result = $error;

	} catch (Stripe_InvalidRequestError $e) {
		$result = $e->getMessage();		  
	} catch (Stripe_AuthenticationError $e) {
		$result = $e->getMessage();
	} catch (Stripe_ApiConnectionError $e) {
		$result = $e->getMessage();
	} catch (Stripe_Error $e) {
		$result = $e->getMessage();
	} catch (Exception $e) {
			  
    }
	
	if ($result == "success")
	{
		redirect('Account/mypage');
	}
		

    //print_r($result);
	 //print_r($charge['name']);
	//echo "<BR>Stripe Payment Status : ".$result;
	
	//echo "<BR>Stripe Response : ";
	
	//print_r($charge); exit;
}
?>
<!DOCTYPE html>
<html lang="en">
<head>
<meta charset="UTF-8">
<title>Egent</title>
<link rel="shortcut icon" href="/assets/img/favicon.ico?v=134p38rfwef">
<link href="https://fonts.googleapis.com/css?family=Lato:300,400,700" rel="stylesheet">
        <link rel="stylesheet" href="//cdn.materialdesignicons.com/2.0.46/css/materialdesignicons.min.css" crossorigin="anonymous">
        <link rel="stylesheet" href="//cdnjs.cloudflare.com/ajax/libs/normalize/7.0.0/normalize.css" crossorigin="anonymous">
        <script src="https://js.stripe.com/v3/"></script>
        <?php echo $header_assets;?>
</head>
<body class='login'>
        <header>
            <a href="/" class="logo"><img src="<?php echo base_url().'assets/img/logo.svg'?>" alt="eGent" /></a>
        </header>
<div class="container pad">
<h2 class="bt_title" align="center">Egent Subscription Fee Payment</h2>

<div align="center">
<form action="" method="POST">
  <script
    src="https://checkout.stripe.com/checkout.js" class="stripe-button"
    data-key="<?php echo $params['public_test_key']; ?>"
    data-amount="<?php echo $amount; ?>"
    data-name="Egent"
    data-description="Subsription Payment"
    data-image="<?php echo base_url().'assets/img/logosmall.jpg' ?>"
    data-allow-remember-me="false"
    data-email="<?php echo $this->session->userdata('email'); ?>">
  </script>

</form>
<br/>

<a href="<?php echo base_url();?>" style="font-size: 16px;margin: 0px;font-weight: 600;display:flex;color: #0999e9;">Cancel</button>

</div>

</div>

<script src="https://code.jquery.com/jquery-3.1.1.min.js" crossorigin="anonymous"></script>
        <?php echo $footer_assets;?>
</body>

</html>