<?php defined('BASEPATH') OR exit('No direct script access allowed');

class Client extends MX_Controller {

	public function __construct()
	{
		parent::__construct();
		$this->load->database();
		$this->load->add_package_path(APPPATH.'third_party/ion_auth/');
		$this->load->library(array('ion_auth','framework','form_validation'));
		$this->load->model(array('client_model'));
	}

	public function dashboard()
	{

		if (!$this->ion_auth->logged_in()):
			// redirect them to the login page
			redirect(base_url());
		endif;
		$filter_data=array('search_string'=>'');
		$where_clause=[];
		if(isset($_POST['search_string']) || !empty($this->uri->segment(4)))
		{
			if(isset($_POST['search_string']))
			{
				$filter_data['search_string']=$_POST['search_string'];
				$this->session->set_userdata('search_string',$filter_data);	
			}
			if($this->session->userdata('search_string'))
			{
				$filter_data['search_string']=$this->session->userdata('search_string')['search_string'];
			}
			
		}
		else
		{
			$this->session->set_userdata('search_string',$filter_data);	
		}
		if(!empty($filter_data['search_string']))
		{
				$where_clause= "clients.email like '%".$filter_data['search_string']."%' and client_rel.user_id=".$this->session->userdata('user_id')." and clients.is_deleted=0
				 or clients.first_name like '%".$filter_data['search_string']."%' and client_rel.user_id=".$this->session->userdata('user_id')." and clients.is_deleted=0
				 or clients.middle_name like '%".$filter_data['search_string']."%' and client_rel.user_id=".$this->session->userdata('user_id')." and clients.is_deleted=0
				 or clients.last_name like '%".$filter_data['search_string']."%' and client_rel.user_id=".$this->session->userdata('user_id')." and clients.is_deleted=0";		
		}
		$user_id =$this->session->userdata("user_id");
		// Get countries
		$country = $this->client_model->get_country();
		$order_st = 'DESC';
		if($this->uri->segment(3)){
			$order_st =$this->uri->segment(3);
		}
		$config = array();
        $config["base_url"] = base_url() . "Client/dashboard/".$order_st."/";
        $total_row =  $this->client_model->count_clients_list($where_clause);
        $config["total_rows"] = $total_row; 
        $config["per_page"] = 5;
        $config['use_page_numbers'] = TRUE;
        $config['num_links'] = 10;
        $config['cur_tag_open'] = '&nbsp;<a class="current">';
        $config['cur_tag_close'] = '</a>';
        $config['next_link'] = 'Next';
        $config['prev_link'] = 'Previous';
        $config["uri_segment"] = 4;
    
        $this->pagination->initialize($config);
        if($this->uri->segment(4))
        {
            $offset = ($this->uri->segment(4));
        }
        else
        {
            $offset = 1;
        }				

		//Show client on dashboard in ascending or decending order
		$ordertype = "";
		$ordertype = $this->uri->segment(3);
		$active_client_out_of = $this->db->where('user_id',$this->session->userdata('user_id'))->from("client_rel")->count_all_results();
		$active_client = $this->db->where('client_rel.user_id',$this->session->userdata('user_id'))
		->where('clients.active',1)
		->join("clients", 'client_rel.client_id = clients.client_id')
		->from("client_rel")->count_all_results();

		if($ordertype == "DESC" || $ordertype == ""):
			//count number of clients
			$clients = $this->client_model->get_clients_list($ordertype,$where_clause,$config["per_page"], ($offset-1)*$config["per_page"]);
			$data = array(
				'session'   => $_SESSION,
				'v' => "dashboard.twig",
				'clients' => $clients,
				'ordertype' => "DESC",
				'active_client' => $active_client,
				'active_client_out_of' => $active_client_out_of
			);
		else:
			//count number of clients
			$clients = $this->client_model->get_clients_list($ordertype,$where_clause,$config["per_page"], ($offset-1)*$config["per_page"]);
			$data = array(
				'session'   => $_SESSION,
				'v' => "dashboard.twig",
				'clients' => $clients,
				'ordertype' => "ASC",
				'active_client' => $active_client,
				'active_client_out_of' => $active_client_out_of
			);
		endif;
		$active_contract = $this->client_model->get_clientactive_contract();
		$total_contract = $this->client_model->count_client_agreement($this->session->userdata("user_id"));
		$data["active_contract"] = $active_contract;
		$data["total_contract"] = $total_contract;
		$data["pagination"] =$this->pagination->create_links();
		$this->framework->init($data,false);

	}

	public function view($client_id = NULL)
	{

		if (!$this->ion_auth->logged_in()):
			// redirect them to the login page
			redirect(base_url());
		endif;

		if($client_id === NULL):
			redirect('Client/dashboard');
		endif;

		if(!$this->client_model->check_client($client_id)):
			redirect('Client/dashboard');
		endif;

		$filter_data=array('search_string'=>'');
		$where_clause=[];
		if(isset($_POST['search_string']) || !empty($this->uri->segment(4)))
		{
			if(isset($_POST['search_string']))
			{
				$filter_data['search_string']=$_POST['search_string'];
				$this->session->set_userdata('search_string',$filter_data);	
			}
			if($this->session->userdata('search_string'))
			{
				$filter_data['search_string']=$this->session->userdata('search_string')['search_string'];
			}
			
		}
		else
		{
			$this->session->set_userdata('search_string',$filter_data);	
		}
		if(!empty($filter_data['search_string']))
		{
				$where_clause=$filter_data['search_string'];		
		}
		$where_clause['sender_id'] = $this->session->userdata("user_id");
		$user_id =$this->session->userdata("user_id");
		// Get countries
		$country = $this->client_model->get_country();
		$config = array();
        $config["base_url"] = base_url() . "Client/view/".$this->uri->segment(3)."/";
        $total_row =  $this->client_model->count_notification($client_id,$where_clause);
        $config["total_rows"] = $total_row; 
        $config["per_page"] = 3;
        $config['use_page_numbers'] = TRUE;
        $config['num_links'] = 10;
        $config['cur_tag_open'] = '&nbsp;<a class="current">';
        $config['cur_tag_close'] = '</a>';
        $config['next_link'] = 'Next';
        $config['prev_link'] = 'Previous';
        $config["uri_segment"] = 4;
    
        $this->pagination->initialize($config);
        if($this->uri->segment(4) && $this->uri->segment(4) !="agreement")
        {
            $offset = ($this->uri->segment(4));
        }
        else
        {
            $offset = 1;
        }				
		//Get notifications
		$notification = $this->client_model->get_notification($client_id,$where_clause,$config["per_page"], ($offset-1)*$config["per_page"]);

		// Get contracts from Admin
		//$agreement = $this->client_model->get_client_contracts();
		//'clientagreement' => $agreement,
		$active_contract = $this->client_model->get_clientactive_contract(array("receiver_id"=>$client_id));
		$data = array(
			'session'   => $_SESSION,
			'v' => "view.twig",
			'country' => $country,			
			'client' => $this->client_model->get_client($client_id),
			'notification' => $notification,
			'active_contract' => $active_contract,
		);
		//$data["pagination"] =$this->pagination->create_links();
//all agreements
$where_clause =array();
$where_clause['client_id'] = $this->uri->segment(3); 
$config1 = array();
$config1["base_url"] = base_url() . "Client/view/".$this->uri->segment(3)."/agreement/";
$total_row =  $this->client_model->count_client_agreement($user_id,$where_clause);
$config1["total_rows"] = $total_row; 
$config1["per_page"] = 5;
$config1['use_page_numbers'] = TRUE;
$config1['num_links'] = 10;
$config1['cur_tag_open'] = '&nbsp;<a class="current">';
$config1['cur_tag_close'] = '</a>';
$config1['next_link'] = 'Next';
$config1['prev_link'] = 'Previous';
$config1["uri_segment"] = 5;

$this->pagination->initialize($config1);
$agreement_page =$this->uri->segment(4);
if($this->uri->segment(5) &&  $agreement_page=="agreement")
{
	$offset = ($this->uri->segment(5));
}
else
{
	$offset = 1;
}				
$data["all_agreement"] = $this->client_model->get_client_agreements($user_id,$where_clause,$config1["per_page"], ($offset-1)*$config1["per_page"]);
//print_r($data["all_agreement"]);
$data["company"] = array();
$data["seller"] = array();
$data["contract_list"] = array();
$data["admin_form"] = array();
foreach($data["all_agreement"] as $key=>$val){
	$seller = $this->client_model->get_agreement_seller($val->id);
	$company = $this->client_model->get_agreement_companies($val->id);
	$contract_list = $this->client_model->get_agreement_list($val->id);
	// if($val->type == "buy"){
	//     $data['buyer_compensation']= $this->client_model->get_contract_attach_detail("buyer_compensation",array("contract_pid"=>$val->id));
	// }
	// if($val->type == "sell"){
	//     $data['sell_compensation']= $this->client_model->get_contract_attach_detail("sell_compensation",array("contract_pid"=>$val->id));
	//     $data['sell_price_term']= $this->client_model->get_contract_attach_detail("sell_price_term",array("contract_pid"=>$val->id));
	// }
	// if($val->type == "tenant"){
	//     $data['tenant_compensation']= $this->client_model->get_contract_attach_detail("sell_compensation",array("contract_pid"=>$val->id));
	// }
	// if($val->type == "lease"){
	//     $data['lease_compensation']= $this->client_model->get_contract_attach_detail("sell_compensation",array("contract_pid"=>$val->id));
	// }
	$data["admin_form"][]= $this->Admin_login->get_contract_file_version($val->contract_id);
	$data["company"][]= $company;
	$data["seller"][]= $seller;
	$data["contract_list"][]= $contract_list;
}
// echo '<pre>';
// print_r($data);
$data["agreement_pagination"] =$this->pagination->create_links($config1);
// $res =$this->all_agreements();

// $data = array_merge($data, $res);
		//print_r($data["pagination"]); exit;
		$this->framework->init($data,false);

	}
public function all_agreements(){
	
return $data;
}
	public function mynew()
	{

		if (!$this->ion_auth->logged_in()):
			// redirect them to the login page
			redirect(base_url());
		endif;

		// Get countries
		$country = $this->client_model->get_country();

		$data = array(
			'session'   => $_SESSION,
			'v' => "new.twig",
			'country' => $country,
			'create' => false
		);
		$this->framework->init($data,false);

	}
public function attached_client(){
	
}
	public function create()
	{
// print_r($_POST); exit;
		if (!$this->ion_auth->logged_in()):
			// redirect them to the login page
			redirect(base_url());
		endif;

		// Get countries
		$country = $this->client_model->get_country();

		// Check if searching for client or creating new client
		switch ($this->input->post('check')) {

			// Checking for existing client
			case 1:
				
				// Validate input
				$this->form_validation->set_rules('email', 'Email Address', 'required|valid_email|is_unique[clients.email]');
				if($this->input->post('is_company')){
					$this->form_validation->set_rules('company', 'Company Name', 'required');
				}				
				$this->form_validation->set_rules('first_name', 'First Name', 'required');
				$this->form_validation->set_rules('last_name', 'Last Name', 'required');
				$this->form_validation->set_rules('phone', 'Phone Number', 'required');
				$this->form_validation->set_rules('type', 'Type', 'required');
				$this->form_validation->set_rules('address1', 'First Address', 'required');
				$this->form_validation->set_rules('pincode', 'Zip Code', 'required');
				$attached_client = $this->client_model->get_clients_term($this->input->post('email'));
				//print_r($attached_client); exit;
				if(empty($attached_client)){
					$this->form_validation->set_message('is_unique', 'The %s client email is already taken.You can attach this from `Create New Client`\'s first step in your list.' );
				}else{
					$this->form_validation->set_message('is_unique', 'The %s client email is already taken. And attached in your client list.' );
				}
				$is_company = '';
				if($this->input->post('is_company')){
					$is_company = $this->input->post('is_company');
				}
                
				//Validation Failed
				if ($this->form_validation->run() == FALSE):										

					// Return to form
					$data = array(
						'session'   => $_SESSION,
						'v' => "new.twig",
						'create' => true,
						'errors' => $this->form_validation->error_array(),
						'email' => set_value('email'),
						'company' => set_value('company'),
						'country' => $country,
						'selected_country' => set_value('country'),
						'first_name' => set_value('first_name'),
						'middle_name' => set_value('middle_name'),
						'last_name' => set_value('last_name'),
						'phone' => set_value('phone'),
						'type' => set_value('type'),
						'city' => set_value('city'),
						'address1' => set_value('address1'),
						'address2' => set_value('address2'),
						'pincode' => set_value('pincode'),
						'is_company' => $is_company						
					);
					$this->framework->init($data,false);

				// Validation Succeeed
				else:

					// Create Client
					$_client = $this->client_model->create_client();

					if($_client):
						redirect('Client/dashboard');
					else: 
						redirect('Client/mynew');
					endif;

				endif;

				break;
			
			// Creating new client
			default:
				
				// Validate input
				$this->form_validation->set_rules('email', 'Email Address', 'required|valid_email');

				//Validation Failed
				if ($this->form_validation->run() == FALSE):

					// Return to form
					$data = array(
						'session'   => $_SESSION,
						'v' => "new.twig",
						'create' => false,
						'errors' => $this->form_validation->error_array(),
						'email' => set_value('email'),
						'country' => $country
					);
					$this->framework->init($data,false);

				// Validation Succeeed
				else:

					// Get client from database
					$_client = $this->client_model->existing_client($this->input->post('email'));

					if($_client === NULL):
						// Return to form
						$data = array(
							'session'   => $_SESSION,
							'v' => "new.twig",
							'create' => true,
							'email' => set_value('email'),
							'country' => $country							
						);
						$this->framework->init($data,false);
					else:						
						if(!$this->client_model->check_client($_client->client_id)) {
							$_client = $this->client_model->associate_client($_client->client_id);
						}

						if($_client):
							$data = array(
								'session'   => $_SESSION,
								'v' => "new.twig",
								'create' => false,
								'errs' => "Client already exists with this email address. Client is added to your list.",
								'email' => set_value('email'),
								'country' => $country
							);
							$this->framework->init($data,false);
							
							//redirect('Client/dashboard');
						else: 
							redirect('Client/mynew');
						endif;
					endif;
				endif;
				break;

		}

	}

	// Client De-activated or blocked
	public function deactivate($client_id = '') 
	{
	    if (!$this->ion_auth->logged_in()):
			//redirect them to the login page
			redirect(base_url());
		endif;
		
		//Get client id
		$client_id = $this->uri->segment(3); 
			
	   if($client_id != '')
	   {      	     
	   $data = array(
				   'active' => 0
				   );
		//client de-activated and blocked	   
	   $result = $this->client_model->client_active($client_id,$data);

	   $this->session->set_flashdata('msg', 'Client has been de-activated successfully.');
			
	   redirect('Client/dashboard');
	   }
	   else
	   {
		   redirect('Client/dashboard');
	   }
    }
	// Client De-activated or blocked
	public function activate($client_id = '') 
	{
	    if (!$this->ion_auth->logged_in()):
			//redirect them to the login page
			redirect(base_url());
		endif;
		
		//Get client id
		$client_id = $this->uri->segment(3); 
			
	   if($client_id != '')
	   {      	     
	   $data = array(
				   'active' => 1
				   );
		//client de-activated and blocked	   
	   $result = $this->client_model->client_active($client_id,$data);

	   $this->session->set_flashdata('msg', 'Client has been de-activated successfully.');
			
	   redirect('Client/dashboard');
	   }
	   else
	   {
		   redirect('Client/dashboard');
	   }
    }   
	// Client Blocked
	public function deleted($client_id = '') 
	{
	    if (!$this->ion_auth->logged_in()):
			//redirect them to the login page
			redirect(base_url());
		endif;
		
		//Get client id
		$client_id = $this->uri->segment(3); 
			
	   if($client_id != '')
	   {      	     
	   $data = array(
		   			'is_deleted' => 1
				   );
		//client de-activated and blocked	   
	//    $result = $this->client_model->client_active($client_id,$data);
	$result = $this->client_model->client_remove($client_id);
	   $this->session->set_flashdata('msg', 'Client has been deleted successfully.');
		
	   redirect('Client/dashboard');

	   }
	   else
	   {
		   redirect('Client/dashboard');
	   }
	}
	
	public function updateclient()
	{

		if (!$this->ion_auth->logged_in()):
			// redirect them to the login page
			//redirect(base_url());
			exit;
		endif;
		$resultant = $this->client_model->existing_client($this->input->post('email'));
		if(empty($resultant) || $resultant->client_id == $this->input->post('client_id')){
		
		// Update Client
		$clientid = $this->input->post('client_id');

		$_client = $this->client_model->update_client($clientid);

		if($_client):
			echo json_encode(array("msg"=>"Client update successfully.")); exit;
			//redirect('Client/view/'.$clientid);
		endif;
	}else{
echo json_encode(array("msg"=>"Client already exist with this Email Id.You can attach from `Create New Client`\'s first step in your list.")); exit;
	}

	}
	
	/**
	 * Generate clients json
	 */
    public function clientsJson()
    {
		$term ="";
        if(isset($_GET['term'])){
            $term = $_GET['term'];
        } 
        $agent_clients = $this->client_model->get_clients_term($term);
        echo   json_encode($agent_clients);
	}
	public function clientDocument($contract_id){
		$data = array(
			// 'session'   => $_SESSION,
			//'v' => "document_view.twig"
			"id"=>$contract_id
		);
		//$this->framework->init($data,false);
		$this->load->view("document_view.php",$data);
	}
	public function updatedOnPanda(){
		print_r($_POST);
		if($this->input->server('REQUEST_METHOD')=="POST"){
			$decoded_data = json_decode($_POST);
			$posted_data = $decoded_data[0]->data;
			$where_clause = array("pandadoc_id"=>$posted_data->id);
			$set_data["panda_status"] =$posted_data->status;
			$this->Client_model->update_contract($set_data,$where_clause);
			$contract_rel = $this->Client_model->get_contract_rel($where_clause);
			$where_clause["contract_pid"] = $contract_rel[0]->id;
			foreach($posted_data->recipients as $key=>$val){
				$set_data["email_id"] =$val->email;
				$set_data["status"] =$val->has_completed;
				$set_data["sender_email"] =$$posted_data->sent_by->email;

				$where_clause["email_id"] = $val->email;
				$where_clause["sender_email"] = $posted_data->sent_by->email;
				$this->Client_model->update_recipients_panda($set_data,$where_clause);
			}
			
		}
		exit;

	}
	public function updates_docs(){

		$decoded_data = json_decode('[
			{
			  "event": "document_state_changed",
			  "data": {
				"id": "5Cuw5eVdLyvrnoqejMFKLn",
				"name": "Contract To Buy And Sell",
				"date_created": "2018-03-26T08:28:41.806872Z",
				"date_modified": "2018-03-26T08:57:01.445098Z",
				"created_by": {
				  "id": "Pw8wDcXTLHfUYfgpPMPKGX",
				  "email": "ian+egentapi@unleadedgroup.com",
				  "first_name": "eGent",
				  "last_name": "API",
				  "avatar": "https:\/\/pd-live-media.s3.amazonaws.com:443\/users\/Pw8wDcXTLHfUYfgpPMPKGX\/avatar.jpg"
				},
				"tags": [
				  
				],
				"status": "document.sent",
				"recipients": [
				  {
					"id": "bDSsnwSKfa9voFLaiTvipN",
					"first_name": "test",
					"last_name": "check",
					"email": "tim.quickfix@gmail.com",
					"recipient_type": "CC",
					"has_completed": true,
					"role": ""
				  }
				],
				"sent_by": {
				  "id": "Pw8wDcXTLHfUYfgpPMPKGX",
				  "email": "ian+egentapi@unleadedgroup.com",
				  "first_name": "eGent",
				  "last_name": "API",
				  "avatar": "https:\/\/pd-live-media.s3.amazonaws.com:443\/users\/Pw8wDcXTLHfUYfgpPMPKGX\/avatar.jpg"
				}
			  }
			}
		  ]');
echo '<pre>';
print_r($decoded_data[0]->data->status);
exit;
	}
	
}