<?php
defined('BASEPATH') OR exit('No direct script access allowed');
// include_once FCPATH."application/third_party/EmailReplyParser-master/src/autoload.php";
// use EmailReplyParser\Parser\EmailParser;

class Message extends MX_Controller
{

	public function __construct()
	{
		parent::__construct();	
		$this->load->database();
		$this->load->add_package_path(APPPATH.'third_party/ion_auth/');
		$this->load->library(array('ion_auth','framework','form_validation'));			
		$this->load->library('messages');    
		$this->load->library('pagination');   
		$this->load->model('Message_model');   
		$this->load->model('Client_model');
		$this->load->model('Agent_model');
		$this->load->model('Admin_login');
	}
	
	public function index($offset = 0)
	{		
		if (!$this->ion_auth->logged_in()):
			// redirect them to the login page
			redirect(base_url());
		endif;
		$data = array(
			'session'   => $_SESSION,
			'v' => "message.twig"
		);
		$user_id = $this->session->userdata('user_id');
		$filter_data=array('search_string'=>'');
		$where_clause=[];
		if(isset($_POST['search_string']) || !empty($this->uri->segment(3)))
		{
			if(isset($_POST['search_string']))
			{
				$filter_data['search_string']=$_POST['search_string'];
				$this->session->set_userdata('search_string',$filter_data);	
			}
			if($this->session->userdata('search_string'))
			{
				$filter_data['search_string']=$this->session->userdata('search_string')['search_string'];
			}
			
		}
		else
		{
			$this->session->set_userdata('search_string',$filter_data);	
		}
		if(!empty($filter_data['search_string']))
		{
				$where_clause=$filter_data['search_string'];		
		}
		$config = array();
				$config["base_url"] = base_url() . "Message/index/";
				$total_row =  $this->messages->countReceivedMessage($user_id,$where_clause);
				$config["total_rows"] = $total_row; 
				$config["per_page"] = 5;
				$config['use_page_numbers'] = TRUE;
				$config['num_links'] = 10;
				$config['cur_tag_open'] = '&nbsp;<a class="current">';
				$config['cur_tag_close'] = '</a>';
				$config['next_link'] = 'Next';
				$config['prev_link'] = 'Previous';
				$config["uri_segment"] = 3;
			
				$this->pagination->initialize($config);
				if($this->uri->segment(3))
				{
					$offset = ($this->uri->segment(3));
				}
				else
				{
					$offset = 1;
				}
						
				$data["messages"] = $this->messages->getReceiveMessage($config["per_page"], ($offset-1)*$config["per_page"], $user_id,$where_clause);
				$data["unread_message_count"] =$this->Message_model->countUnreadReceiveMessages($this->session->userdata('user_id'),$where_clause);
				 $data["pagination"] =$this->pagination->create_links();
				$data["tab"] = "received";
				$this->framework->init($data,false);		
	}		

		public function sent()
		{ 
			if (!$this->ion_auth->logged_in()):
				// redirect them to the login page
				redirect(base_url());
			endif;
			$data = array(
				'session'   => $_SESSION,
				'v' => "sent.twig"
			);
			$user_id = $this->session->userdata('user_id');
		$filter_data=array('search_string'=>'');
		$where_clause=[];
		if(isset($_POST['search_string']) || !empty($this->uri->segment(3)))
		{
			if(isset($_POST['search_string']))
			{
				$filter_data['search_string']=$_POST['search_string'];
				$this->session->set_userdata('search_string',$filter_data);	
			}
			if($this->session->userdata('search_string'))
			{
				$filter_data['search_string']=$this->session->userdata('search_string')['search_string'];
			}
			
		}
		else
		{
			$this->session->set_userdata('search_string',$filter_data);	
		}
		if(!empty($filter_data['search_string']))
		{
				$where_clause=$filter_data['search_string'];		
		}

			$config = array();
			$config["base_url"] = base_url() . "/Message/sent/";
		    $total_row = $this->messages->countSendMessage($user_id,$where_clause);
			$config["total_rows"] = $total_row;
			$config["per_page"] = 5;
			$config['use_page_numbers'] = TRUE;
			$config['num_links'] = 10;
			$config['cur_tag_open'] = '&nbsp;<a class="current">';
			$config['cur_tag_close'] = '</a>';
			$config['next_link'] = 'Next';
			$config['prev_link'] = 'Previous';
			$config["uri_segment"] = 3;
			
			$this->pagination->initialize($config);
			if($this->uri->segment(3))
			{
				$offset = ($this->uri->segment(3));
			}
			else
			{
				   $offset = 1;
			}
			
				$data["messages"] = $this->messages->getSendMessage($config["per_page"], ($offset-1)*$config["per_page"], $user_id,$where_clause);
				$data["unread_message_count"] =$this->Message_model->countUnreadReceiveMessages($this->session->userdata('user_id'),$where_clause);
			    $data["pagination"] =$this->pagination->create_links();
				$data["tab"] = "sent";
				$this->framework->init($data,false);				
	}
		
    function compose($offset = 0)
    {  
		if (!$this->ion_auth->logged_in()):
			// redirect them to the login page
			redirect(base_url());
		endif;
		$data["user_email"] = '';
		$data["title"] = '';
		$data["message"] = '';
		$email_id =$this->Agent_model->get_agent($this->session->userdata('user_id'));
		//$sender_mail = $email_id->email; // email of the sender
		$sender_mail = "egent@clagdev.com";
		$sender_name = $email_id->first_name;
		if($this->input->server('REQUEST_METHOD')=='POST')
        {//if is set post message
            if($this->input->post('user_type')!='admin')
            {
               $this->form_validation->set_rules('user_email','Email','trim|required|valid_email');
			}
			
				$this->form_validation->set_rules('title','Title','required');
				$this->form_validation->set_rules('message','Message','required');
				$typ=$this->input->post('user_type');
				
            if( $this->form_validation->run() !==false)
            {
              
                if($this->input->post('user_type')!='admin')
                {					
						$result=$this->Client_model->get_client_byemail($this->input->post('user_email'));
					if($result->num_rows() > 0)
                    {
						$user_data=$result->result();
						if($this->input->post('user_type')=='user'){
							$receiver_id=$user_data[0]->client_id;
							$reciver_mail = $user_data[0]->email;						
						}else{
							$receiver_id=$user_data[0]->id;
							$reciver_mail = $user_data[0]->email;
						}
                        $set_data=array(
                                "sender_id"=>$this->session->userdata('user_id'),
								"receiver_id"=>$receiver_id,
								
                                "title"=>$this->input->post('title'),
								"message"=>$this->input->post('message'),
								"receiver_type"=>$this->input->post('user_type')
                            );
						$retrn = 1;
						$detail_data= array("message"=>$this->input->post('message'),"title"=>$this->input->post('title'));
						$detail_data["file"] =array();
						$valid_recipients = array();
						if(!empty($this->input->post('contract_recipient'))){
							foreach($this->input->post('contract_recipient') as $val){
                                if (filter_var($val, FILTER_VALIDATE_EMAIL)){
                                        $valid_recipients[] = $val;
								 }
							}
							$all_reciever= array_diff($valid_recipients,array($reciver_mail));
							 array_push($all_reciever,$reciver_mail);
						}else{
							$all_reciever = array($reciver_mail);
						}
						if(is_array($all_reciever)){
$set_data["contract_recipient"] = json_encode($all_reciever);
						}else{
							$set_data["contract_recipient"] = $all_reciever;	
						}
						// print_r($this->input->post('contract_list'));
						// print_r($this->input->post('contract_recipient'));
						// exit;
						if($this->input->post('contract_list') && !empty($all_reciever)){							
foreach($this->input->post('contract_list') as $list=>$list_val){
	$contract_rel = $this->Client_model->get_client_agreement($list_val);
	$this->Client_model->saveagreement_rel(array("status"=>"locked","id"=>$list_val));
	$set_data["contract_pid"] = $contract_rel[0]->id;
	$set_data["contract_id"] = $contract_rel[0]->contract_id;
	$detail_data["file"][] = FCPATH."/assets/contract_pdf/".$contract_rel[0]->pdf_name ;
	$this->Message_model->creatMessages($set_data);
} 
$redirect_uri =base_url("Message/compose/contract/".$this->input->post("current_client")."/".$this->input->post("current_contract"));
$this->session->set_userdata(array("message"=>$this->input->post("message"),"title"=>$this->input->post("title"),"contracts"=>$this->input->post("contract_list"),"recipients"=>$all_reciever,
"contract_pid"=>$this->input->post("current_contract"),"client_id"=>$this->input->post("current_client"),"redirect_uri"=>$redirect_uri));
//print_r($all_reciever); exit;
$detail_data["shared_links"] = $this->sendToPanda();
//print_r($detail_data["shared_links"]); exit;
//print_r($all_reciever); exit;
// $set_data["contract_id"] = $set_data["contract_id"];
// $set_data["contract_pid"] = $set_data["contract_pid"];
// $msg_links1 ="Following is contract links for approval.\r\n";
// 						if(!empty($detail_data["shared_links"])){
// 						foreach($detail_data["shared_links"] as $key=>$res_value){
// 							$msg_links = "";
// 							foreach($res_value as $con_val){
// 								$msg_links .= "Expires at- ".$con_val["expire_at"]." <br /><a href=\"".base_url('Client/clientDocument/').$con_val["link"]."\">View & Approve Contracts</a>\r\n";
// 							}
// 							$detail_data["message"] = $detail_data["message"].$msg_links1.$msg_links;
//                         $retrn = $this->mail($detail_data,$this->input->post('user_type'),$sender_mail,$sender_name,trim($key));
// 						}
						
// 					}

	$this->session->set_flashdata('msg','Your Agreement  has been sent to Recipients.'); 
		$this->session->unset_userdata(array("message","title","contracts","recipients",
						"contract_pid","client_id","redirect_uri"));		
						}
						else{
						$retrn = $this->mail($detail_data,$this->input->post('user_type'),$sender_mail,$sender_name,$all_reciever);
						if($retrn === 1)
                        {
                            $this->session->set_flashdata('msg','Your message  has been sent.'); 
                        }
                        else
                        {
                            $this->session->set_flashdata('msg','Your message has been sent.'); 
                        }
					}
					$msgcount = $this->db
					->select('msg_counter')
					->where('client_id',$receiver_id)									
					->get('clients')->result();
			
					foreach($msgcount as $msgcount)
					{
						$msgcounter = $msgcount->msg_counter + 1;
					}

		$updatemsg = array('msg_counter' => $msgcounter);

		$this->db->where('client_id',$receiver_id);
		$this->db->update('clients',$updatemsg);
						//exit;
						
                        
                      
                    }
                    else
                    {
                        $this->session->set_flashdata('msg','User does not exist'); 
                    }   
                }
                else //if admin
                {          
					$result=$this->Agent_model->get_agent_byemail($this->input->post('user_email'));         
					if($result->num_rows() > 0)
                    {
						    $user_data=$result->result();						
							$receiver_id=$user_data[0]->id;
							$reciver_mail = $user_data[0]->email;						
                        $set_data=array(
                                "sender_id"=>$this->session->userdata('user_id'),
                                "receiver_id"=>$receiver_id,
                                "title"=>$this->input->post('title'),
								"message"=>$this->input->post('message'),
								"receiver_type"=>$this->input->post('user_type')
                            );
                        $this->Message_model->creatMessages($set_data);
						$retrn =1;
						//$retrn = $this->mail($data,$typ,$sender_mail,$sender_name,$reciver_mail);
					                        if($retrn === 1)
                        {
                            $this->session->set_flashdata('msg','Your message has been sent.'); 
                        }
                        else
                        {
                            $this->session->set_flashdata('msg','Your message has been sent.'); 
                        }
                    }
                    else
                    {
                        $this->session->set_flashdata('msg','User does not exist'); 
                    }   
                }
              
           }else{
			$data['errors'] = $this->form_validation->error_array();
		   }
	   }
	   else if($this->session->userdata("message")){
		
		$detail_data["shared_links"] = $this->sendToPanda();
		$sender_name = "egent";
		$sender_mail = "egent@clagdev.com";
		// $msg_links1 ="Following is contract links for approval.\r\n";
		// foreach($detail_data["shared_links"] as $key=>$res_value){
		// 	$msg_links = "";
		// 	foreach($res_value as $con_val){
		// 		$msg_links .= "Expires at- ".$con_val["expire_at"]."<br />  <a href=\"".base_url('Client/clientDocument/').$con_val["link"]."\">View & Approve Contracts</a>\r\n";			}
		// 	$detail_data["message"] = $detail_data["message"].$msg_links1.$msg_links;
		// 	$retrn = $this->mail($detail_data,$sender_mail,$sender_name,$key);
		// }
		$this->session->unset_userdata(array("message","title","contracts","recipients",
		"contract_pid","redirect_uri"));

		if($retrn === 1)
		{
			$this->session->set_flashdata('msg','Your Contract message  has been sent.'); 
		}
		else
		{
			$this->session->set_flashdata('msg','Your Contract message has been sent.'); 
		}
		$client =$this->Client_model->get_client($this->uri->segment(4));
		$where_clause = array();
		$where_clause['client_id'] = $this->uri->segment(4);
		$contract_rel = $this->Client_model->get_client_agreements($this->session->userdata("user_id"),$where_clause,null);
		foreach($contract_rel as $key=>$val){
			$admin_form[$val->contract_id] = $this->Admin_login->get_contract_file_version($val->contract_id);
		}	
		$contract_parties = $this->Client_model->get_client_parties(array("client_id"=>$this->uri->segment(4)));
		//print_r($contract_parties);		
		$data["user_email"] = '';
		$data["title"] = '';
		$data["message"] = '';
		$data["user_type"] = 'user';
		$data["user_email"] = $client->email;
		$data["current_contract"] = $this->uri->segment(5);
		$data["current_client"] = $this->uri->segment(4);
		$data["contract"] = array("contract"=>$contract_rel,"admin_form"=>$admin_form,"contract_parties"=>$contract_parties);

	   }
       else if($this->uri->segment(3) == 'forward')
       {//if is set forward message
           
		$sql_query="select * from messages  where id=".$this->uri->segment(4);
		$result= $this->db->query($sql_query);
		$message = $result->row();
		$data["user_email"] = '';
		$data["title"] = '';
		$data["message"] = '';
		$data["user_type"] = '';
	   if($message){
		$data["user_type"] = $message->receiver_type;
		$data["title"] = $message->title;
		$data["message"] = $message->message;
	   }
	}
	 else if($this->uri->segment(3)=='reply')
	 {//if is set reply message
		
		$sql_query="select * from messages  where id=".$this->uri->segment(4);
		$result= $this->db->query($sql_query);
		$message = $result->row();
		$data["user_email"] = '';
		 $data["title"] = '';
		 $data["message"] = '';
		 $data["user_type"] = '';
		 if($message){
		  $data["user_type"] = $message->receiver_type;
		  if($message->receiver_type=='admin'){
			if($this->uri->segment(5)=='sent'){
				$sql_user="select * from users  where id=".$message->receiver_id;
			}else{
				$sql_user="select * from users  where id=".$message->sender_id;
			}
			
			$result_user= $this->db->query($sql_user);
			$message_user = $result_user->row();
		  }else{
			if($this->uri->segment(5)=='sent'){
				$sql_user="select * from clients  where client_id=".$message->receiver_id;
			}else{
				$sql_user="select * from clients  where client_id=".$message->sender_id;
			}
			$result_user= $this->db->query($sql_user);
			$message_user = $result_user->row();			  
		  }
		 $data["user_email"] = $message_user->email;
		 $data["title"] = $message->title;
		}
		}
		else if($this->uri->segment(3)=='contract')
		{//if is set reply message
			$client =$this->Client_model->get_client($this->uri->segment(4));
			$where_clause = array();
			$where_clause['client_id'] = $this->uri->segment(4);
			$where_clause['pandadoc_id !='] = "";
			$where_clause['panda_status !='] = "document.sent";
			$contract_rel = $this->Client_model->get_client_agreements($this->session->userdata("user_id"),$where_clause,null);
			$admin_form =array();
			foreach($contract_rel as $key=>$val){
				$admin_form[$val->contract_id] = $this->Admin_login->get_contract_file_version($val->contract_id);
			}	
			$contract_parties = $this->Client_model->get_client_parties(array("client_id"=>$this->uri->segment(4)));
			//print_r($contract_parties);		
		    $data["user_email"] = '';
			$data["title"] = '';
			$data["message"] = '';
			$data["user_type"] = 'user';
			$data["user_email"] = $client->email;
			$data["current_contract"] = $this->uri->segment(5);
			$data["current_client"] = $this->uri->segment(4);
			$data["contract"] = array("contract"=>$contract_rel,"admin_form"=>$admin_form,"contract_parties"=>$contract_parties);
		   }
        else
		{//if is set  message compose 
			//print_r($_POST);exit;
            //print_r($this->form_validation->error_array()); exit;
			//$data["message"] = '';
			$data = array(
				'session'   => $_SESSION,
				'v' => "compose.twig",
				'errors' => $this->form_validation->error_array(),
				'user_type' => set_value('user_type'),
				'user_email' => set_value('user_email'),
				'title' => set_value('title'),
				'message' => set_value('message'),
	
			);
        }
        		// Return to form
		$data["clients"] = $this->Client_model->get_clients_list();
		$data["session"] = $_SESSION;
		$data["v"] = "compose.twig";
		//print_r($data["clients"][0]);
		$data["unread_message_count"] =$this->Message_model->countUnreadReceiveMessages($this->session->userdata('user_id'));
		$data['tab'] = 'compose';
		$this->framework->init($data, false);
	}
	     function view_send($offset = 0)
    {  
			if (!$this->ion_auth->logged_in()):
				// redirect them to the login page
				redirect(base_url());
			endif;
			$data = array(
				'session'   => $_SESSION,
				'v' => "view.twig",
			);
			$data["unread_message_count"] =$this->Message_model->countUnreadReceiveMessages($this->session->userdata('user_id'));
			$sql_qr="select * from messages  where messages.id=".$this->uri->segment(3);
			$res= $this->db->query($sql_qr)->row();
			if($res->receiver_type=='user'){
				$sql_query="select * from messages join clients on clients.client_id=messages.receiver_id where messages.id=".$this->uri->segment(3);
			}else{
				$sql_query="select * from messages join users on users.id=messages.receiver_id where messages.id=".$this->uri->segment(3);
			}
            $result= $this->db->query($sql_query);
            $data["messages"] = $result->result_array();         
			$data['tab'] = 'view_send';
			$this->framework->init($data, false);
   
    }
    
     
    function delete()//delete message page
    {  
		 $type=$this->uri->segment(3);
		 $id=$this->uri->segment(4);
		 if (!$this->ion_auth->logged_in()):
			// redirect them to the login page
			redirect(base_url());
		endif;
		
        if($type=='sent')
        {
            $data=array('sender_delete'=>'delete');
            $this->Message_model->updateMessages($id,$data);
			$this->session->set_flashdata('msg','Message Deleted Successfully.');
         
			redirect(base_url().'Message/sent');
        }
        else
        {
			$data=array('receiver_delete'=>'delete');
			$this->Message_model->updateMessages($id,$data);
			$this->session->set_flashdata('msg','Message Deleted Successfully.');         
			redirect(base_url().'Message/index');
        }
	}
        
    public function mail($detail,$typ,$sendr_mail,$sendr_name,$reciver_mail)
    {
       $flag =0;
        if($typ === 'admin')
        {

			$sub =  $detail['title'];
			//$detail['firstname']=$sendr_name;
           	//$msg =  $this->load->view('mails/message',$detail,TRUE);
			//$adminmail = $this->basemaster->get_admin_email();
			$msg =  $detail['message'];
            $e_mail = $reciver_mail;
            $name = "Egent";
            $from_email = $sendr_mail; 
            $config['charset'] = 'utf-8';
            $config['wordwrap'] = TRUE;
            $config['mailtype'] = 'html';
            $this->email->initialize($config);
            $this->email->from($from_email); 
            $this->email->to($e_mail);
            $this->email->subject($sub); 
            $this->email->message($msg); 
            //Send mail 
            if($this->email->send())
            {
                $flag = 1;
            }
            else
            {
                $flag = 0;
            }
        }
        /*IF not admin */
        else
        { 
            $sub =  $detail['title'];
			//$detail['firstname']=$sendr_name;
			// $msg =  $this->load->view('mails/message',$detail,TRUE);
			$msg =  $detail['message'];
            $e_mail = $reciver_mail;
            $name = "Egent";
            $from_email = $sendr_mail; 
            $config['charset'] = 'utf-8';
            $config['wordwrap'] = TRUE;
            $config['mailtype'] = 'html';
            $this->email->initialize($config);
            $this->email->from($from_email); 
            $this->email->to($e_mail);
            $this->email->subject($sub); 
			$this->email->message($msg); 
			//print_r($detail); exit;
			// if(isset($detail['file'])){
			// 	foreach($detail['file'] as $fil=>$file_val)
			// 	//echo $file_val;
			// 	$this->email->attach(trim($file_val),'attachment');
			// }	
			// 	if(isset($detail['file'])){
			// 	foreach($detail['file'] as $fil=>$file_val)
			// 	//echo $file_val;
			// 	$this->email->attach(trim($file_val),'attachment');
			// }		
            //Send mail 
            if($this->email->send())
            {
                $flag = 1;
            }
            else
            {
                $flag = 0;
            }
        }
        return $flag;
    }
	function count_unread()
	{
	  $arr["unread_message_count"] =$this->Message_model->countUnreadReceiveMessages($this->session->userdata('user_id'));
	}
	public function _render_page($view, $data=null, $returnhtml=false)//I think this makes more sense
	{

		$this->viewdata = (empty($data)) ? $data: $data;

		$view_html = $this->load->view($view, $this->viewdata, $returnhtml);

		if ($returnhtml) return $view_html;//This will return html on 3rd argument being true
	}

	    public function index_mail()
	{     
		if (!$this->ion_auth->logged_in()):
			// redirect them to the login page
			redirect(base_url());
		endif;
		$id = time();
		// start imap---
		//$email = $this->ion_auth->user()->row()->email;
		//$domain_name = substr(strrchr($email, "@"), 1);
		//$impl_domain=explode('.',$domain_name);
		// if($impl_domain =="yahoo"){
		// 	$mbox = imap_open("{imap.mail.yahoo.com:993/imap/ssl}INBOX", $email, "tim.clag@321", OP_HALFOPEN)
		// 	or die("can't connect: " . imap_last_error());
		// }else{			
			$mbox = imap_open("{mail.clagdev.com:143/notls/norsh/novalidate-cert}", "egent@clagdev.com", "qi]0mkfni@cV")
				//$mbox = imap_open("{mail.lovewaves.com:143/notls/norsh/novalidate-cert}", "mypropertyplus@mypropertyplus.lovewaves.com", "rO2HrKc&}4BI")				
			// $mbox = imap_open("{imap.gmail.com:993/imap/ssl/novalidate-cert}INBOX", "tim.quickfix@gmail.com", "clag.tim@321")
			or die("can't connect: " . imap_last_error());
		//}
		$this->_imap_stream = $mbox;
		if($this->uri->segment(3))
				{
					$offset = ($this->uri->segment(3));
				}
				else
				{
					$offset = 1;
				}
		// $name1 = "phpnewbox";
		// $name2 = imap_utf7_encode("phpnewbb&w7Y-x"); // phpnewb&w7Y-x
		// $newname = $name1;
		// echo "Newname will be '$name1'<br />\n";
		// we will now create a new mailbox "phptestbox" in your inbox folder,
		// check its status after creation and finally remove it to restore
		// your inbox to its initial state
		// if (@imap_createmailbox($mbox, imap_utf7_encode("{imap.example.org}INBOX.$newname"))) {
		//     $status = @imap_status($mbox, "{imap.example.org}INBOX.$newname", SA_ALL);
		//     if ($status) {
		//         echo "your new mailbox '$name1' has the following status:<br />\n";
		//         echo "Messages:   " . $status->messages    . "<br />\n";
		//         echo "Recent:     " . $status->recent      . "<br />\n";
		//         echo "Unseen:     " . $status->unseen      . "<br />\n";
		//         echo "UIDnext:    " . $status->uidnext     . "<br />\n";
		//         echo "UIDvalidity:" . $status->uidvalidity . "<br />\n";
		
		//         if (imap_renamemailbox($mbox, "{imap.example.org}INBOX.$newname", "{imap.example.org}INBOX.$name2")) {
		//             echo "renamed new mailbox from '$name1' to '$name2'<br />\n";
		//             $newname = $name2;
		//         } else {
		//             echo "imap_renamemailbox on new mailbox failed: " . imap_last_error() . "<br />\n";
		//         }
		//     } else {
		//         echo "imap_status on new mailbox failed: " . imap_last_error() . "<br />\n";
		//     }
		//     if (@imap_deletemailbox($mbox, "{imap.example.org}INBOX.$newname")) {
		//         echo "new mailbox removed to restore initial state<br />\n";
		//     } else {
		//         echo "imap_deletemailbox on new mailbox failed: " . implode("<br />\n", imap_errors()) . "<br />\n";
		//     }
		
		// } else {
		//     echo "could not create new mailbox: " . implode("<br />\n", imap_errors()) . "<br />\n";
		// }
		
		/* if emails are returned, cycle through each... */
// 		$emails = imap_search($mbox,'ALL');
// 		$all_mail = array();
// 		if($emails) {
// 			/* begin output var */
// 			$output = '';
// 			/* put the newest emails on top */
// 			rsort($emails);
// 			/* for every email... */
			
// 			foreach($emails as $email_number) {
// 				/* get information specific to this email */
// 				$overview = imap_fetch_overview($mbox,$email_number,0);
// 				// $output.= 'Name:  '.$overview[0]->from.'</br>';
// 				// $output.= 'Email:  '.$overview[0]->message_id.'</br>';
// 				$all_mail[]= array('name'=>$overview[0]->from,'email'=>$overview[0]->message_id,'date'=>$overview[0]->date,'subject'=>$overview[0]->subject);

// 			}
// 			//echo $output;
// 		} 
$per_page =2;
$all_mail =$this->listMessages($offset, $per_page,array('date','desc'));
//print_r($all_mail);
$this->_total= $all_mail['total'];
$this->_limit= $per_page;
$this->_page= $offset;
$pagenation =$this->createLinks(5,$this->_total,$this->_limit,$this->_page, "pagination");
		imap_errors();
imap_alerts();
		imap_close($mbox);




		// end imap---
				$data = array(
					'session'   => $_SESSION,
					'v' => "all_mail.twig",
					'create' => false,
				);
				$data['all_mail'] = $all_mail;
				$data['pagenation'] = $pagenation;
				$data['tab'] = 'index_mail';
				$this->framework->init($data,false);
			}
			public function single_mail()
			{     
				if (!$this->ion_auth->logged_in()):
					// redirect them to the login page
					redirect(base_url());
				endif;
				$id = time();
				// start imap---
				//$email = $this->ion_auth->user()->row()->email;
				// $domain_name = substr(strrchr($email, "@"), 1);
				// $impl_domain=explode('.',$domain_name);
				$uid = $this->uri->segment(3);
				$email_number =$uid;
				// if($impl_domain =="yahoo"){
				// 	$mbox = imap_open("{imap.mail.yahoo.com:993/imap/ssl}INBOX", $email, "tim.clag@321", OP_HALFOPEN)
				// 	or die("can't connect: " . imap_last_error());
				// }else{					
					$mbox = imap_open("{mail.clagdev.com:143/notls/norsh/novalidate-cert}", "egent@clagdev.com", "qi]0mkfni@cV")
					or die("can't connect: " . imap_last_error());
				//}		

						$overview = imap_fetch_overview($mbox,$uid,0);
						$message = imap_fetchbody($mbox,$uid,2);
					/* get mail structure */
					$structure = imap_fetchstructure($mbox, $email_number);
						// if(isset($structure->parts) && is_array($structure->parts) && isset($structure->parts[1])) {
						// 	$part = $structure->parts[1];
							$message = imap_fetchbody($mbox,$email_number,2);
				
							// if($part->encoding == 3) {
							// 	$message = imap_base64($message);
							// } else if($part->encoding == 1) {
							// 	$message = imap_8bit($message);
							// } else {
							// 	$message = imap_qprint($message);
							// }
							// echo $part->type.'<br />';
							// echo $part->encoding;
						// 	switch ($part->encoding) {
						// 		# 7BIT
				 		// 		case 0:
						// 			//return $text;
						// 			break;
						// 		# 8BIT
						// 		case 1:
						// 		$message = quoted_printable_decode(imap_8bit($message));
						// 		break;
						// 		# BINARY
						// 		case 2:
						// 		$message = imap_binary($message);
						// 		break;
						// 		# BASE64
						// 		case 3:
						// 		echo "dfsd";
						// 		$message = base64_decode($message);
						// 		break;
						// 		# QUOTED-PRINTABLE
						// 		case 4:
						// 		$message = quoted_printable_decode($message);
						// 		break;
						// 		# OTHER
						// 		// case 5:
						// 		// $message = $message;
						// 		# UNKNOWN
						// 		default:
						// 		$message = $message;
						// 		break;
						// 	}
						// }
						$flattenedParts = $this->flattenParts($structure->parts);

foreach($flattenedParts as $partNumber => $part) {

	switch($part->type) {
		
		case 0:
			// the HTML or plain text part of the email
			$message = $this->getPart($mbox, $email_number, $partNumber, $part->encoding);
			// now do something with the message, e.g. render it
		break;
	
		case 1:
			// multi-part headers, can ignore
	
		break;
		case 2:
			// attached message headers, can ignore
		break;
	
		case 3: // application
		// case 4: // audio
		// case 5: // image
		// case 6: // video
		// case 7: // other
		// 	$filename = getFilenameFromPart($part);
		// 	if($filename) {
		// 		// it's an attachment
		// 		$attachment = getPart($connection, $messageNumber, $partNumber, $part->encoding);
		// 		// now do something with the attachment, e.g. save it somewhere
		// 	}
		// 	else {
		// 		// don't know what it is
		// 	}
		 break;
	
	}}
	//$message = preg_replace('#(^\w.+:\n)?(^>.*(\n|$))+#mi', "", $message);
	//$message_ar =explode("===========reply above this line===========",$message);
	// $message = (new EmailParser())->parse($message);
	// $message = current($message->getFragments())->getContent();
	//$message =\EmailReplyParser\EmailReplyParser::parseReply($message);
	//$message = imap_qprint(imap_body($mbox, $email_number)); 
						// $output.= 'Name:  '.$overview[0]->from.'</br>';
						// $output.= 'Email:  '.$overview[0]->message_id.'</br>';
						$client_detail = $this->Client_model->get_clientmail_detail(array("sender_id"=>$this->session->userdata('user_id'),"subject"=>$overview[0]->subject));
						$client_contracts =array();
						if($client_detail){
							foreach(json_decode($client_detail[0]->contract_pid) as $con_key =>$con_val){
								$contracts =  $this->client_model->get_client_agreement($con_val);
								$admin_form = $this->Admin_login->get_contract_file_version($val->contract_id);
								$client_contracts[] =array("contracts"=>$con_contract,"admin_form" => $admin_form);
							}
							
						}	
						//print_r($overview[0]);	exit;	

						$single_mail= array('name'=>utf8_decode(imap_utf8($overview[0]->from)),'message'=>$message,
						'seen'=>$overview[0]->seen,
						'email'=>$overview[0]->message_id,'date'=>utf8_decode(imap_utf8($overview[0]->date)),'from'=>utf8_decode(imap_utf8($overview[0]->from)),'subject'=>utf8_decode(imap_utf8($overview[0]->subject)));


								$attachments = array();
								$cleint_attach =array();
								/* if any attachments found... */
								if(isset($structure->parts) && count($structure->parts)) 
								{
									for($i = 0; $i < count($structure->parts); $i++) 
									{
										$attachments[$i] = array(
											'is_attachment' => false,
											'filename' => '',
											'name' => '',
											'attachment' => ''
										);
						
										if($structure->parts[$i]->ifdparameters) 
										{
											foreach($structure->parts[$i]->dparameters as $object) 
											{
												if(strtolower($object->attribute) == 'filename') 
												{
													$attachments[$i]['is_attachment'] = true;
													$attachments[$i]['filename'] = $object->value;
												}
											}
										}
						
										if($structure->parts[$i]->ifparameters) 
										{
											foreach($structure->parts[$i]->parameters as $object) 
											{
												if(strtolower($object->attribute) == 'name') 
												{
													$attachments[$i]['is_attachment'] = true;
													$attachments[$i]['name'] = $object->value;
												}
											}
										}
						
										if($attachments[$i]['is_attachment']) 
										{
											$attachments[$i]['attachment'] = imap_fetchbody($mbox, $email_number, $i+1);
						
											/* 3 = BASE64 encoding */
											if($structure->parts[$i]->encoding == 3) 
											{ 
												$attachments[$i]['attachment'] = base64_decode($attachments[$i]['attachment']);
											}
											/* 4 = QUOTED-PRINTABLE encoding */
											elseif($structure->parts[$i]->encoding == 4) 
											{ 
												$attachments[$i]['attachment'] = quoted_printable_decode($attachments[$i]['attachment']);
											}
										}
									}
								}
						
								/* iterate through each attachment and save it */
								foreach($attachments as $attachment)
								{
									if($attachment['is_attachment'] == 1)
									{
										$filename = $attachment['name'];
										if(empty($filename)) $filename = $attachment['filename'];
						
										if(empty($filename)) $filename = time() . ".dat";
										$folder = FCPATH."/assets/attachment";
										if(!is_dir($folder))
										{
											 mkdir($folder);
										}
										if($single_mail['seen']==0){
										$fp = fopen($folder ."/". $email_number . "-" . $filename, "w+");
										fwrite($fp, $attachment['attachment']);
										fclose($fp);
										}
										$path_info = pathinfo($folder ."/". $email_number . "-" . $filename);
										$img_type = array("jpg","JPG","jpeg","JPEG","png","PNG","gif","GIF");
										$img_allowed = in_array($path_info["extension"],$img_type);
										if(file_exists($folder ."/". $email_number . "-" . $filename)){
											$loaded= "yes";									
											}else{
											$loaded= "no";
										}
										$cleint_attach[] = array("file"=>$email_number . "-" . $filename,"type"=>$img_allowed,"loaded"=>$loaded);
									}
								}

								imap_setflag_full($mbox, $email_number, "\\Seen \\Flagged", ST_UID);
						
						
						imap_errors();
						imap_alerts();
				imap_close($mbox);
				// end imap---
						$data = array(
							'session'   => $_SESSION,
							'v' => "index.twig",
							'create' => false,
						);
						$data['single_mail'] = $single_mail;
						$data['client_contracts'] = $client_contracts;
						$data['tab'] = 'single_mail';
						$data['cleint_attach'] = $cleint_attach;
						$this->framework->init($data,false);
					}		
 /**
     * Return array of IMAP messages for pagination
     *
     * @param   int     $page       page number to get
     * @param   int     $per_page   number of results per page
     * @param   array   $sort       array('subject', 'asc') etc
     * 
     * @return  mixed   array containing imap_fetch_overview, pages, and total rows if successful, false if an error occurred
     * @author  Raja K
     */
				
    public function listMessages($page = 1, $per_page = 2, $sort = null) {
        $limit = ($per_page * $page);
        $start = ($limit - $per_page) + 1;
        $start = ($start < 1) ? 1 : $start;
        $limit = (($limit - $start) != ($per_page-1)) ? ($start + ($per_page-1)) : $limit;
        $info = imap_check($this->_imap_stream);
        $limit = ($info->Nmsgs < $limit) ? $info->Nmsgs : $limit;

        if(true === is_array($sort)) {
            $sorting = array(
                        'direction' => array(   'asc' => 0, 
                                                'desc' => 1),

                        'by'        => array(   'date' => SORTDATE,
                                                'arrival' => SORTARRIVAL,
                                                'from' => SORTFROM,
                                                'subject' => SORTSUBJECT,
                                                'size' => SORTSIZE));
            $by = (true === is_int($by = $sorting['by'][$sort[0]])) 
                            ? $by 
                            : $sorting['by']['date'];
            $direction = (true === is_int($direction = $sorting['direction'][$sort[1]])) 
                            ? $direction 
                            : $sorting['direction']['desc'];

            $sorted = imap_sort($this->_imap_stream, $by, $direction);

            $msgs = array_chunk($sorted, $per_page);
            $msgs = $msgs[$page-1];
        }
        else 
            $msgs = range($start, $limit); //just to keep it consistent

        $result = imap_fetch_overview($this->_imap_stream, implode($msgs, ','), 0);
        if(false === is_array($result)) return false;

        //sorting!
        if(true === is_array($sorted)) {
            $tmp_result = array();
            foreach($result as $r)
                $tmp_result[$r->msgno] = $r;

            $result = array();
            foreach($msgs as $msgno) {
                $result[] = $tmp_result[$msgno];
            }
        }

        $return = array('res' => $result,
                        'start' => $start,
                        'limit' => $limit,
                        'sorting' => array('by' => $sort[0], 'direction' => $sort[1]),
                        'total' => imap_num_msg($this->_imap_stream));
        $return['pages'] = ceil($return['total'] / $per_page);
        return $return;
    }
	public function createLinks( $links,$total,$limit,$page, $list_class ) {		
		 $this->_total= $total;
//  echo "<br />";
  $this->_limit= $limit;
  $this->_page= $page;
		if ( $this->_limit == 'all' ) {
			return '';
		}
	 
		 $last       = ceil( $this->_total / $this->_limit );
	 
		 $start      = ( ( $this->_page - $links ) > 0 ) ? $this->_page - $links : 1;
		 $end        = ( ( $this->_page + $links ) < $last ) ? $this->_page + $links : $last;
	 
		$html       = '<div class="' . $list_class . '">';
	 
		$class      = ( $this->_page == 1 ) ? "disabled" : "";
		$html       .= '<a class="' . $class . '" href="'.base_url().'Message/index_mail/' . ( $this->_page - 1 ) . '">&laquo;</a>';
	 
		if ( $start > 1 ) {
			$html   .= '<a href="'.base_url().'Message/index_mail/1">1</a>';
			//$html   .= '<li class="disabled"><span>...</span></li>';
		}
	 
		for ( $i = $start ; $i <= $end; $i++ ) {
			$class  = ( $this->_page == $i ) ? "current" : "";
			$html   .= '<a class="' . $class . '" href="'.base_url().'Message/index_mail/'  . $i . '">' . $i . '</a>';
		}
	 
		if ( $end < $last ) {
			//$html   .= '<li class="disabled"><span>...</span></li>';
			$html   .= '<a href="'.base_url().'Message/index_mail/' . $last . '">' . $last . '</a>';
		}
	 
		$class      = ( $this->_page == $last ) ? "current" : "";
		// echo $this->_page;
		if($this->_page >= $last){
			$html       .= '<a class="' . $class . '" href="'.base_url().'Message/index_mail/' . ( $last ) . '">&raquo;</a>';
		}else{
			$html       .= '<a class="' . $class . '" href="'.base_url().'Message/index_mail/' . ( $this->_page + 1 ) . '">&raquo;</a>';
		}
		
	 
		$html       .= '</div>';
	 
		return $html;
	}
	public function get_attach_mail(){
		
		if(file_exists(FCPATH."/assets/attachment/".$this->uri->segment(3))){
			echo base_url()."/assets/attachment/".$this->uri->segment(3);
		}
		
	}
	function flattenParts($messageParts, $flattenedParts = array(), $prefix = '', $index = 1, $fullPrefix = true) {

		foreach($messageParts as $part) {
			$flattenedParts[$prefix.$index] = $part;
			if(isset($part->parts)) {
				if($part->type == 2) {
					$flattenedParts = $this->flattenParts($part->parts, $flattenedParts, $prefix.$index.'.', 0, false);
				}
				elseif($fullPrefix) {
					$flattenedParts = $this->flattenParts($part->parts, $flattenedParts, $prefix.$index.'.');
				}
				else {
					$flattenedParts = $this->flattenParts($part->parts, $flattenedParts, $prefix);
				}
				unset($flattenedParts[$prefix.$index]->parts);
			}
			$index++;
		}
	
		return $flattenedParts;
				
	}
	function getPart($connection, $messageNumber, $partNumber, $encoding) {
	
		$data = imap_fetchbody($connection, $messageNumber, $partNumber);
		switch($encoding) {
			case 0: return $data; // 7BIT
			case 1: return $data; // 8BIT
			case 2: return $data; // BINARY
			case 3: return base64_decode($data); // BASE64
			case 4: return quoted_printable_decode($data); // QUOTED_PRINTABLE
			case 5: return $data; // OTHER
		}
		
		
	}
	
	function getFilenameFromPart($part) {
	
		$filename = '';
		
		if($part->ifdparameters) {
			foreach($part->dparameters as $object) {
				if(strtolower($object->attribute) == 'filename') {
					$filename = $object->value;
				}
			}
		}
	
		if(!$filename && $part->ifparameters) {
			foreach($part->parameters as $object) {
				if(strtolower($object->attribute) == 'name') {
					$filename = $object->value;
				}
			}
		}
		
		return $filename;
		
	}
function check_attachment(){
		if(file_exists(FCPATH."/assets/attachment/".$this->input->post("attachment"))){
			echo json_encode(array("loaded"=>"yes")); exit;									
			}else{
				echo json_encode(array("loaded"=>"no")); exit;
		}
	}

	public function sendToPanda(){
        // $client_id = '396b0a09962299615e2f';
        // $client_secret = '2c686086130c14445120a3f387392e58333b821b';
        $client_id = '07ed0eae4e0fad35d057';
        $client_secret = '5f354335aa8bf2b0a0d8c10b01be2968d94f5010';
		// $redirect_uri = base_url().'Message/sendToPanda';
		$redirect_uri = base_url().'Agreement/pandaverifyer';

            $contracts=$this->session->userdata("contracts");
			$recipients=$this->session->userdata("recipients");
			$contract_pid=$this->session->userdata("contract_pid");
        
       $contract_res = $this->Client_model->get_client_agreement($contract_pid);
	   $client_detail=$this->Client_model->get_client($contract_res[0]->client_id);  
	   $shared_docs=array(); 
	   
	   foreach($recipients as $res_val) {
		$shared_res =array();
	   foreach($contracts as $con_val) {
		$contract_res = $this->Client_model->get_client_agreement($con_val);
		
try{
	// {
	// 	"recipient": "jane@example.com",
	// 	"lifetime": 900
	//   }
$act_data = array('data'=>json_encode(array(
"recipient"=>$res_val,
"lifetime"=> 3600
)
),'send_data'=>json_encode(array(
	"recipient"=>"Hello! This document was sent from the PandaDoc API.",
	"silent"=> false
	)
	));
//print_r($act_data);
    $boundary =md5(time());        
	$post_data = $this->pandadoc->build_data_files($boundary, $act_data, null);
	//print_r($post_data);
    $authorization = "'Authorization: Bearer ".$this->session->userdata('panda_bearer')."'";
    $panda_bearer = $this->session->userdata('panda_bearer');
	$authorization = "Authorization: Bearer ".$this->session->userdata('panda_bearer');
	$ch = curl_init();
    curl_setopt_array($ch, array( CURLOPT_URL => "https://api.pandadoc.com/public/v1/documents/".$contract_res[0]->pandadoc_id."/send", 
    CURLOPT_RETURNTRANSFER => true, 
    CURLOPT_ENCODING => "", 
    CURLOPT_MAXREDIRS => 10, 
    CURLOPT_TIMEOUT => 30,
    CURLINFO_HEADER_OUT=>TRUE,
     CURLOPT_HTTP_VERSION => CURL_HTTP_VERSION_1_1,
      CURLOPT_CUSTOMREQUEST => "POST",
      CURLOPT_POSTFIELDS => $act_data["send_data"],
       CURLOPT_HTTPHEADER => array( "Authorization: Bearer ".$this->session->userdata('panda_bearer'), "Cache-Control: no-cache" , "content-type: application/json; boundary=".$boundary ), ));
	   $response = curl_exec($ch);
	   $err = curl_error($ch);
curl_close($ch);

if ($err) {
	//print_r($err);
	throw new Exception("Curl is not connected");
//echo "cURL Error #:" . $err;
} else {
//echo $response;
$response_ar=json_decode($response);
//print_r($response_ar);
//print_r($response_ar); exit;
$set_data = array();
if(isset($response_ar->id) && $response_ar->id !=""){
$where_clause = array("id"=>$contract_pid);
$set_data["panda_status"] =$response_ar->status;
$this->Client_model->update_contract($set_data,$where_clause);
}
elseif(isset($response_ar->type) && $response_ar->type =="validation_error"){
    //print_r($response_ar);
    throw new Exception("Validation error is found.");
}
// else if(isset($response_ar->type) && $response_ar->type =="permissions_error"){    
// 	throw new Exception("Permission error is found.");
// }
else if($response_ar->type == "authentication_error"){    
	header('Location:https://app.pandadoc.com/oauth2/authorize?client_id='.$client_id.'&redirect_uri='.$redirect_uri.'&scope=read+write&response_type=code');    
}        
else{
	throw new Exception("Document is not submitted.");
}
}

// 	$ch = curl_init();
//     curl_setopt_array($ch, array( CURLOPT_URL => "https://api.pandadoc.com/public/v1/documents/".$contract_res[0]->pandadoc_id."/session", 
//     CURLOPT_RETURNTRANSFER => true, 
//     CURLOPT_ENCODING => "", 
//     CURLOPT_MAXREDIRS => 10, 
//     CURLOPT_TIMEOUT => 30,
//     CURLINFO_HEADER_OUT=>TRUE,
//      CURLOPT_HTTP_VERSION => CURL_HTTP_VERSION_1_1,
//       CURLOPT_CUSTOMREQUEST => "POST",
//       CURLOPT_POSTFIELDS => $act_data["data"],
//        CURLOPT_HTTPHEADER => array( "Authorization: Bearer ".$this->session->userdata('panda_bearer'), "Cache-Control: no-cache" , "content-type: application/json; boundary=".$boundary ), ));
//        $response = curl_exec($ch);
//        $header_info = curl_getinfo($ch,CURLINFO_HEADER_OUT);
//       $err = curl_error($ch);
// //print_r($post_data);
// curl_close($ch);
//         if ($err) {
//             //print_r($err);
//             throw new Exception("Curl is not connected");
//         //echo "cURL Error #:" . $err;
//         } else {
//         //echo $response;
// 		$response_ar=json_decode($response);
// 		//print_r($response_ar);
//         //print_r($response_ar); exit;
//         $set_data = array();
//         if(isset($response_ar->id) && $response_ar->id !=""){
//         $where_clause = array("id"=>$contract_pid);
//         $set_data["link"] =$response_ar->id;
// 		$set_data["expire_at"] =$response_ar->expires_at;
// 		$shared_res[]=$set_data;
// 		//print_r($set_data); 
//         $this->session->unset_userdata(array("contract_pid","pdf_name","redirect_uri"));            
//         $this->Agent_model->create_link($set_data);
//         $this->session->set_flashdata(array("msg"=>"Document is submitted."));
// 		}
// 		// elseif(isset($response_ar->type) && $response_ar->type =="validation_error"){
//         //     //print_r($response_ar);
//         //     throw new Exception("Validation error is found.");
// 		// }
// 		// else if(isset($response_ar->type) && $response_ar->type =="permissions_error"){    
//         //     throw new Exception("Permission error is found.");
// 		// }
// 		else if($response_ar->type == "authentication_error"){    
//             header('Location:https://app.pandadoc.com/oauth2/authorize?client_id='.$client_id.'&redirect_uri='.$redirect_uri.'&scope=read+write&response_type=code');    
//         }        
//         else{
//             throw new Exception("Document is not submitted.");
//         }
//         }
        }catch(Exception $e){
$this->session->set_flashdata(array("msg"=>$e->getMessage()));
		}
		$shared_docs[$res_val] = $shared_res;
	}
	
}
//print_r($shared_docs); exit;
return $shared_docs;
        //header("Location:".base_url("Message/compose/contract/".$contract_res[0]->client_id."/".$contract_res[0]->id));
}


}
