<?php

defined('BASEPATH') OR exit('No direct script access allowed');
require_once(APPPATH."third_party/dompdf/autoload.inc.php");
// require_once('/home/egent/egent.uldev.co/vendor/garethhallnz/pandadoc/src/PandaDoc.php');
// require_once('/home/egent/egent.uldev.co/vendor/garethhallnz/pandadoc/src/Documents.php');
require_once(FCPATH.'application/libraries/pdfcrowd.php');

use Dompdf\Dompdf;
use PandaDoc\Documents;
use PandaDoc\Entity\DocumentBuilder;

class Property extends MX_Controller {

    public function __construct() {
        parent::__construct();
        $this->load->database();
        $this->load->add_package_path(APPPATH . 'third_party/ion_auth/');
        $this->load->library(array('ion_auth', 'framework', 'form_validation', 'twig'));
        $this->load->model(array('client_model','agent_model'));
        $this->load->library('messages');    
		$this->load->model('Message_model');  
    }
    public function index(){
	if (!$this->ion_auth->logged_in()):
        // redirect them to the login page
        redirect(base_url());
    endif;
    $client_id = $this->uri->segment(3);
    if($client_id === NULL):
        redirect('Client/dashboard');
    endif;

    if(!$this->client_model->check_client($client_id)):
        redirect('Client/dashboard');
    endif;

    $filter_data=array('search_string'=>'');
    $where_clause=[];
    if(isset($_POST['search_string']) || !empty($this->uri->segment(4)))
    {
        if(isset($_POST['search_string']))
        {
            $filter_data['search_string']=$_POST['search_string'];
            $this->session->set_userdata('search_string',$filter_data);	
        }
        if($this->session->userdata('search_string'))
        {
            $filter_data['search_string']=$this->session->userdata('search_string')['search_string'];
        }
        
    }
    else
    {
        $this->session->set_userdata('search_string',$filter_data);	
    }
    if(!empty($filter_data['search_string']))
    {
            $where_clause=$filter_data['search_string'];		
    }
    $user_id =$this->session->userdata("user_id");
    // Get countries
    $country = $this->client_model->get_country();
    $config = array();
    $config["base_url"] = base_url() . "Property/index/".$this->uri->segment(3)."/";
    $total_row =  $this->client_model->count_property($client_id,$where_clause);
    $config["total_rows"] = $total_row; 
    $config["per_page"] = 3;
    $config['use_page_numbers'] = TRUE;
    $config['num_links'] = 10;
    $config['cur_tag_open'] = '&nbsp;<a class="current">';
    $config['cur_tag_close'] = '</a>';
    $config['next_link'] = 'Next';
    $config['prev_link'] = 'Previous';
    $config["uri_segment"] = 4;

    $this->pagination->initialize($config);
    if($this->uri->segment(4))
    {
        $offset = ($this->uri->segment(4));
    }
    else
    {
        $offset = 1;
    }				
    //Get notifications
    $properties = $this->client_model->get_property($client_id,$where_clause,$config["per_page"], ($offset-1)*$config["per_page"]);

    
    // Get contracts from Admin
    //$agreement = $this->client_model->get_client_contracts();
    //'clientagreement' => $agreement,
    
    $data = array(
        'session'   => $_SESSION,
        'v' => "property.twig",
        'country' => $country,			
        'client' => $this->client_model->get_client($client_id),
        'properties' => $properties
    );
    $data["pagination"] =$this->pagination->create_links();
    //print_r($data["pagination"]); exit;
    $this->framework->init($data,false);
}

public function edit_property($client_id = null, $propertycontract_id =null, $property_id= null){
    //echo "hello";
    //echo $client_id;
    //echo $propertycontract_id;
    //echo $property_id;
    $properties = $this->client_model->get_property_by_id($property_id);

    $view_data = array();
    if(isset($_POST['property_address'])){
        if(!empty($_POST['property_detail'])){
    
            $property_street=!empty($_POST['property_street'])? $_POST['property_street'] :''; 
            $property_type=!empty($_POST['property_type'])? $_POST['property_type'] :'';
            $property_address=!empty($_POST['property_address'])? $_POST['property_address'] :'';
            $property_unit=!empty($_POST['property_unit'])? $_POST['property_unit'] :'';
            $property_mode=!empty($_POST['property_mode'])? $_POST['property_mode'] :'';
            $created_date=!empty($_POST['created_date'])? $_POST['created_date'] :'';
            $property_city=!empty($_POST['property_city'])? $_POST['property_city'] :'';
            $property_state=!empty($_POST['property_state'])? $_POST['property_state'] :'';
            $property_zipcode=!empty($_POST['property_zipcode'])? $_POST['property_zipcode'] :'';
            $property_county=!empty($_POST['property_county'])? $_POST['property_county'] :'';
            $property_detail=!empty($_POST['property_detail'])? $_POST['property_detail'] :'';
                $view_data['contract_property']=array(
                                                                "client_id"=>$client_id,
                                                                "contract_id"=>$propertycontract_id,
                                                                "id"=>$property_id,
                                                                "property_street_name"=>$property_street,  
                                                                "type"=>$property_type, 
                                                                "mode"=>$property_mode, 
                                                                "property_location"=>$property_address, 
                                                                "property_unit"=>$property_unit,  
                                                                "property_city"=>$property_city,
                                                                "property_state"=>$property_state,
                                                                "property_zipcode"=>$property_zipcode,
                                                                "property_county"=>$property_county,
                                                                "property_detail"=>$property_detail
                                                            );
            
        }
        // print_r($_POST);
        // print_r($view_data); 
        $this->client_model->update_property($view_data);
        //exit;
        $this->session->set_flashdata(array("msg"=>"Property Updated Successfully."));
    }
    //print_r($properties); exit;

     $data = array(
        'v' => "edit_property.twig",              
        'session' => $_SESSION,
        'properties' => $properties
    );
    $this->framework->init($data,false);
    //$this->load->view('Property/edit_property');
   // $this->load->view('property/edit_property');
   // die();

}
public function view_property($client_id = null, $propertycontract_id =null, $property_id= null){
    //echo "hello";
    //echo $client_id;
    //echo $propertycontract_id;
    //echo $property_id;
    $properties = $this->client_model->get_property_by_id($property_id);

    $properties_doc = array();
   // foreach($properties as $val){
    $contract_detail = $this->client_model->get_client_agreement($properties[0]->contract_pid);
    $properties_doc[$properties[0]->id] = array("pdf_name"=>$contract_detail[0]->pdf_name,"contract_pid"=>$contract_detail[0]->id);
   //}
     $data = array(
        'v' => "view_property.twig",              
        'session' => $_SESSION,
        'properties' => $properties,
        'properties_doc' => $properties_doc
    );
    $this->framework->init($data,false);
    //$this->load->view('Property/edit_property');
   // $this->load->view('property/edit_property');
   // die();

}
function upload()
 { // echo "fsdgdfghd"; 
  sleep(3);
  
  if($_FILES["files"]["name"] != '')
  {
   $output = '';
   $config["upload_path"] = FCPATH.'assets/propertyupload/';
   $config["allowed_types"] = 'gif|jpg|png|pdf';
   $this->load->library('upload', $config);
   $this->upload->initialize($config);
   $data=array();
   for($count = 0; $count<count($_FILES["files"]["name"]); $count++)
   {
    $_FILES["file"]["name"] = $_FILES["files"]["name"][$count];
    $_FILES["file"]["type"] = $_FILES["files"]["type"][$count];
    $_FILES["file"]["tmp_name"] = $_FILES["files"]["tmp_name"][$count];
    $_FILES["file"]["error"] = $_FILES["files"]["error"][$count];
    $_FILES["file"]["size"] = $_FILES["files"]["size"][$count];
    if($this->upload->do_upload('file'))
    {
        $file_detail = $this->upload->data();
     $data[] = $this->upload->data();
     $check_file_ext =explode('.',$file_detail["file_name"]);
     $ext_type=$check_file_ext[count($check_file_ext)-1];
     if($ext_type=="pdf"){
        $output .= '
        <div class="col-md-3">
         <iframe src="'.base_url().'assets/propertyupload/'.$file_detail["file_name"].'" class="img-responsive img-thumbnail" width="200" height="160"></iframe>
         <a data-value="'.$file_detail["file_name"].'" class="remove_doc" onclick="remove_doc(event)">Remove</a>
         </div>
        ';
     }else{
        $output .= '
        <div class="col-md-3">
         <img src="'.base_url().'assets/propertyupload/'.$file_detail["file_name"].'" class="img-responsive img-thumbnail" width="200" height="160"></iframe>
         <a data-value="'.$file_detail["file_name"].'" class="remove_doc" onclick="remove_doc(event)">Remove</a>
         </div>
        ';
     }
    
    }
   }
   $update_doc= array();
   $property_id=$_POST['property_id'];
   $properties = $this->client_model->get_property_by_id($property_id);
   $already_doc =json_decode($properties[0]->property_doc);
   foreach($data as $key=>$val){
    $update_doc[] =$val["file_name"];
   }
   if(!empty($already_doc)){
   foreach($already_doc as $key=>$val){
    $update_doc[] = $val;
   }
}
   $update_doc_ar=array("contract_property"=>array( "property_doc"=>json_encode($update_doc),"id"=>$property_id));
   $this->client_model->update_property($update_doc_ar);
   echo $output;   
  } 
 }
 function remove_doc()
 { // echo "fsdgdfghd"; 
  sleep(3);
  $update_doc= array();
  $property_id=$_POST['property_id'];
  $property_doc=$_POST['property_doc'];
  $contract_pid=(isset($_POST['contract_pid']) && !empty($_POST['contract_pid'])) ? $_POST['contract_pid']:"";
  $output ="";
  $properties = $this->client_model->get_property_by_id($property_id);
  $properties_doc = array();
  // foreach($properties as $val){
   $contract_detail = $this->client_model->get_client_agreement($properties[0]->contract_pid);
   $properties_doc[$properties[0]->id] = array("pdf_name"=>$contract_detail[0]->pdf_name,"contract_pid"=>$contract_detail[0]->id);
   

   $already_doc =json_decode($properties[0]->property_doc);
  if($contract_pid){
    unlink(FCPATH.'assets/contract_pdf/'.$property_doc);
    $this->client_model->saveagreement_rel(array("pdf_name"=>"","id"=>$contract_pid));
}else{
    if($contract_detail[0]->pdf_name !="")
    $output .= '
    <div class="col-md-3">
     <iframe src="'.base_url().'assets/contract_pdf/'.$contract_detail[0]->pdf_name.'" class="img-responsive img-thumbnail" width="200" height="160"></iframe>
     <br />
            <a href="'.base_url().'assets/contract_pdf/'.$contract_detail[0]->pdf_name.'" title="Click to view detail" target="_blank">View Full</a>
            <br />
     <a data-value="'.$contract_detail[0]->pdf_name.'" data-id="'.$contract_detail[0]->id.'" class="remove_doc" onclick="remove_doc(event)">Remove</a>
     </div>
    ';
}
  

  if(!empty($already_doc)){
  foreach($already_doc as $key=>$val){
      if($val==$property_doc && empty($contract_pid)){
unlink(FCPATH.'assets/propertyupload/'.$property_doc);
      }else{
        $update_doc[] = $val;
        $check_file_ext =explode('.',$val);
     $ext_type=$check_file_ext[count($check_file_ext)-1];
     if($ext_type=="pdf"){
            $output .= '
            <div class="col-md-3">
             <iframe src="'.base_url().'assets/propertyupload/'.$val.'" class="img-responsive img-thumbnail" width="200" height="160"></iframe>
             <br />
            <a href="'.base_url().'assets/propertyupload/'.$val.'" title="Click to view detail" target="_blank">View Full</a>
            <br />
             <a data-value="'.$val.'" class="remove_doc" onclick="remove_doc(event)">Remove</a>
             </div>
            ';
         }else{
            $output .= '
            <div class="col-md-3">
             <img src="'.base_url().'assets/propertyupload/'.$val.'" class="img-responsive img-thumbnail" width="200" height="160"></iframe>
             <br />
            <a href="'.base_url().'assets/propertyupload/'.$val.'" title="Click to view detail" target="_blank">View Full</a>
            <br />
             <a data-value="'.$val.'" class="remove_doc" onclick="remove_doc(event)">Remove</a>
             </div>
            ';
         }
      }
      
  }

  $update_doc_ar=array("contract_property"=>array( "property_doc"=>json_encode($update_doc),"id"=>$property_id));
  $this->client_model->update_property($update_doc_ar);
}
  echo $output;   

 }
}
 