<?php

defined('BASEPATH') OR exit('No direct script access allowed');
require_once(APPPATH."third_party/dompdf/autoload.inc.php");
// require_once(FCPATH.'/vendor/garethhallnz/pandadoc/src/PandaDoc.php');
// require_once(FCPATH.'/vendor/garethhallnz/pandadoc/src/Documents.php');
require_once(FCPATH.'/application/libraries/pdfcrowd.php');

use Dompdf\Dompdf;
use PandaDoc\Documents;
use PandaDoc\Entity\DocumentBuilder;

class Agreement extends MX_Controller {

    public function __construct() {
        parent::__construct();
        $this->load->database();
        $this->load->add_package_path(APPPATH . 'third_party/ion_auth/');
        $this->load->library(array('ion_auth', 'framework', 'form_validation', 'twig'));
        $this->load->model(array('client_model','agent_model'));
        $this->load->library('messages');    
		$this->load->model('Message_model');  
    }

    public function newagreement() {

        if (!$this->ion_auth->logged_in()):
            // redirect them to the login page
            redirect(base_url());
        endif;
       
        //Get agreement id
        $contractid = $this->uri->segment(4);
        //Get client data
        $client_id = $this->uri->segment(3);
        $clients = $this->client_model->get_client($client_id);
        //Get agent data
        $agent = $this->client_model->get_agent_client($this->session->userdata('user_id'));
        // Get new agreements from Admin with contract id
        $agreement = $this->client_model->get_agreement($contractid);

        //$this->twig->render('framework/index.twig', array('agreement' => $agreement));
        $contract_doc = $agreement->contract_file;
        $contract_doc = str_replace("{{ client.company }}", $clients->company, $contract_doc);
        $contract_doc = str_replace("{{ client.phone }}", $clients->phone, $contract_doc);
        $contract_doc = str_replace("{{ client.email }}", $clients->email, $contract_doc);

        $contract_doc = str_replace("{{ agent.company }}", $agent->company, $contract_doc);
        $contract_doc = str_replace("{{ agent.phone }}", $agent->phone, $contract_doc);
        $contract_doc = str_replace("{{ agent.email }}", $agent->email, $contract_doc);

        $agreement->contract_file = $contract_doc;
        $clause_data = array("user_id"=>$this->session->userdata('user_id'),"client_id"=>$clients->client_id,"contract_id"=>$agreement->contract_id);
        $agreement_flow = $this->agent_model->get_agreement_flow($clause_data);
        $agreement_flow_val = "";
        if($agreement_flow){
            $agreement_flow_val = $agreement_flow->agreement_flow;
        }
        $data = array(
            'session' => $_SESSION,
            'v' => "agreement.twig",
            'agent' => $agent,
            'agreement' => $agreement,
            'client' => $clients,
            'agreement_flow'=>$agreement_flow_val
        );
        $id = $this->uri->segment(5); 
            if(!empty($id)){
                $data['agreement'] =  $this->client_model->get_client_agreement($id);
                $data['agreement_list'] =  $this->client_model->get_agreement_list($id);
                if(!empty($data['agreement_list'])){
                  $data['agreement_list'] =  $data['agreement_list'];
                }
                
                $data['agreement_parties'] =  $this->client_model->get_agreement_parties($id);
                $data['agreement_seller'] =  $this->client_model->get_agreement_seller($id);
                if(!empty($data['agreement_seller'])){
                  $data['agreement_seller'] =  $data['agreement_seller'];
                }
                $data['agreement_companies'] =  $this->client_model->get_agreement_companies($id);
                if(!empty($data['agreement_companies'])){
                  $data['agreement_companies'] =  $data['agreement_companies'];
                }
                $data['agreement_deadline'] =  $this->client_model->get_agreement_deadline($id);
                $data['agreement_inclusion'] =  $this->client_model->get_agreement_inclusion($id);
                if(!empty($data['agreement_inclusion'])){
                  $data['agreement_inclusion'] =  $data['agreement_inclusion'];
                }
              }
            
        $this->framework->init($data, false);
    }
    public function editagreement() {

        if (!$this->ion_auth->logged_in()):
            // redirect them to the login page
            redirect(base_url());
        endif;
       
        //Get agreement id
        $contractid = $this->uri->segment(4);
        //Get client data
        $client_id = $this->uri->segment(3);
        $id = $this->uri->segment(5);
        $clients = $this->client_model->get_client($client_id);
        //Get agent data
        $agent = $this->client_model->get_agent_client($this->session->userdata('user_id'));
        // Get new agreements from Admin with contract id
        $agreement = $this->client_model->get_agreement_persisted($contractid);
if(isset($_POST)){
    $data=[];
    if(!empty($_POST)){
        $client_id      =   $_POST['client_id'];
        $contract_id    =   $_POST['contract_id'];
        $contract_type    =  isset($_POST['contract_type']) ? $_POST['contract_type']:"" ;
        $contract_file =  $_POST['contract_file'];
        $xml_file = $this->print_r_xml($_POST);
        $contract_date = isset($_POST['contract_date']) ? $_POST['contract_date']:"0000-00-00";
        $additional_provisions = isset($_POST['additional_provisions']) ? (is_array($_POST['additional_provisions']) ? json_encode($_POST['additional_provisions']) : $_POST['additional_provisions']):"";
        $attachments =isset($_POST['attachments']) ? (is_array($_POST['attachments']) ? json_encode($_POST['attachments']) : $_POST['attachments']):"";
        $not_attachments_part =isset($_POST['not_attachments_part']) ? (is_array($_POST['not_attachments_part']) ? json_encode($_POST['not_attachments_part']) : $_POST['not_attachments_part']):"";
        $electronic_deliver =isset($_POST['electronic_deliver']) ? (is_array($_POST['electronic_deliver']) ? json_encode($_POST['electronic_deliver']) : $_POST['electronic_deliver']):"";
        $listing_period_start =isset($_POST['listing_period_start']) ? (is_array($_POST['listing_period_start']) ? json_encode($_POST['listing_period_start']) : $_POST['listing_period_start']):"";
        $listing_period_end =isset($_POST['listing_period_end']) ? (is_array($_POST['listing_period_end']) ? json_encode($_POST['listing_period_end']) : $_POST['listing_period_end']):"";
        $authorize_broker_negotiation =isset($_POST['authorize_broker_negotiation']) ? (is_array($_POST['authorize_broker_negotiation']) ? json_encode($_POST['authorize_broker_negotiation']) : $_POST['authorize_broker_negotiation']):"";
        $computation_deadline_period =isset($_POST['computation_deadline_period']) ? (is_array($_POST['computation_deadline_period']) ? json_encode($_POST['computation_deadline_period']) : $_POST['computation_deadline_period']):"";
        $agency_unless_brokerage_relationship =isset($_POST['agency_unless_brokerage_relationship']) ? (is_array($_POST['agency_unless_brokerage_relationship']) ? json_encode($_POST['agency_unless_brokerage_relationship']) : $_POST['agency_unless_brokerage_relationship']):"";
        $obligations_to_broker_diclosurers =isset($_POST['obligations_to_broker_diclosurers']) ? (is_array($_POST['obligations_to_broker_diclosurers']) ? json_encode($_POST['obligations_to_broker_diclosurers']) : $_POST['obligations_to_broker_diclosurers']):"";
        $holdover_period_days =isset($_POST['holdover_period_days']) ? (is_array($_POST['holdover_period_days']) ? json_encode($_POST['holdover_period_days']) : $_POST['holdover_period_days']):"";
        $holdover_period_check =isset($_POST['holdover_period_check']) ? (is_array($_POST['holdover_period_check']) ? json_encode($_POST['holdover_period_check']) :$_POST['holdover_period_check']):"";
        $agency_or_transaction_brokerage =isset($_POST['agency_or_transaction_brokerage']) ? (is_array($_POST['agency_or_transaction_brokerage']) ? json_encode($_POST['agency_or_transaction_brokerage']) : $_POST['agency_or_transaction_brokerage']):"";
        $broker_and_brokerage_firm =isset($_POST['broker_and_brokerage_firm']) ? (is_array($_POST['broker_and_brokerage_firm']) ? json_encode($_POST['broker_and_brokerage_firm']) : $_POST['broker_and_brokerage_firm']):"";
        $party_detail = isset($_POST['party_detail']) ? (is_array($_POST['party_detail']) ? json_encode($_POST['party_detail']) : $_POST['party_detail']) :'';
        $party_seller_detail = isset($_POST['party_seller_detail']) ? (is_array($_POST['party_seller_detail']) ? json_encode($_POST['party_seller_detail']) : $_POST['party_seller_detail']) :'';            
        $broker_detail = isset($_POST['broker_detail']) ? (is_array($_POST['broker_detail']) ? json_encode($_POST['broker_detail']) : $_POST['broker_detail']) :'';
        $brokerage_firm_detail = isset($_POST['brokerage_firm_detail']) ? (is_array($_POST['brokerage_firm_detail']) ? json_encode($_POST['brokerage_firm_detail']) : $_POST['brokerage_firm_detail']) :'';
        $possesion = isset($_POST['possesion']) ? (is_array($_POST['possesion']) ? json_encode($_POST['possesion']) : $_POST['possesion']) :'';

        

        if( !empty($_POST['contract_id']) ){           
                                      $contract_rel = $this->client_model->get_client_agreement($id);
                                      $this->client_model->saveagreement_rel(array('id'=>$contract_rel[0]->id,
                                      'version'=>$contract_rel[0]->version +1,
                                      "contract_file"=>$contract_file,
                                      "contract_date"=>$contract_date,
                                       "xml_file"=>$xml_file,
                                       "type"=>$contract_type,
                                       "pandadoc_id"=>"",
                                       "panda_status"=>"",
                                       "additional_provisions" =>$additional_provisions,
                                       "attachments" => $attachments,
                                       "not_attachments_part" => $not_attachments_part,
                                       "electronic_deliver" =>$electronic_deliver,
                                       "listing_period_start" =>$listing_period_start,
                                       "listing_period_end" =>$listing_period_end,
                                       "authorize_broker_negotiation" => $authorize_broker_negotiation,
                                       "computation_deadline_period" => $computation_deadline_period,
                                       "agency_unless_brokerage_relationship" =>$agency_unless_brokerage_relationship,
                                       "obligations_to_broker_diclosurers" =>$obligations_to_broker_diclosurers,
                                       "holdover_period_days" =>$holdover_period_days,
                                       "holdover_period_check" => $holdover_period_check,
                                       "agency_or_transaction_brokerage" => $agency_or_transaction_brokerage,
                                       "broker_and_brokerage_firm" =>$broker_and_brokerage_firm,
                                       "party_detail"=>$party_detail,
                                       "party_seller_detail"=>$party_seller_detail,
                                       "broker_detail"=>$broker_detail,
                                        "brokerage_firm_detail"=>$brokerage_firm_detail,
                                        "possesion"=>$possesion
                                    ));
                                      $insert_id = $contract_rel[0]->id;
                                   }
                                   if($contract_type == "buy" || $contract_type == "Buy"){
                                    $brokerage_firm_fees_check = isset($_POST['brokerage_firm_fees_check']) ? (is_array($_POST['brokerage_firm_fees_check']) ? json_encode($_POST['brokerage_firm_fees_check']) : $_POST['brokerage_firm_fees_check']):"";
                                    $fees_percentage_price = isset($_POST['fees_percentage_price']) ? (is_array($_POST['fees_percentage_price']) ? json_encode($_POST['fees_percentage_price']) : $_POST['fees_percentage_price']):"";
                                    $fees_us_dollar =isset($_POST['fees_us_dollar']) ? (is_array($_POST['fees_us_dollar']) ? json_encode($_POST['fees_us_dollar']) : $_POST['fees_us_dollar']):"";
                                    $adjusted_amount =isset($_POST['adjusted_amount']) ? (is_array($_POST['adjusted_amount']) ? json_encode($_POST['adjusted_amount']) : $_POST['adjusted_amount']):"";
                                    $adjusted_amount_other =isset($_POST['adjusted_amount_other']) ? (is_array($_POST['adjusted_amount_other']) ? json_encode($_POST['adjusted_amount_other']) : $_POST['adjusted_amount_other']):"";
                                    $adjusted_amount_other_chk =isset($_POST['adjusted_amount_other_chk']) ? (is_array($_POST['adjusted_amount_other_chk']) ? json_encode($_POST['adjusted_amount_other_chk']) : $_POST['adjusted_amount_other_chk']):"";
                                    $hourly_fee_check =isset($_POST['hourly_fee_check']) ? (is_array($_POST['hourly_fee_check']) ? json_encode($_POST['hourly_fee_check']) : $_POST['hourly_fee_check']):"";
                                    $hourly_fee_per_hour =isset($_POST['hourly_fee_per_hour']) ? (is_array($_POST['hourly_fee_per_hour']) ? json_encode($_POST['hourly_fee_per_hour']) : $_POST['hourly_fee_per_hour']):"";
                                    $hourly_fee_maximum_total =isset($_POST['hourly_fee_maximum_total']) ? (is_array($_POST['hourly_fee_maximum_total']) ? json_encode($_POST['hourly_fee_maximum_total']) : $_POST['hourly_fee_maximum_total']):"";
                                    $retainer_fee_check =isset($_POST['retainer_fee_check']) ? (is_array($_POST['retainer_fee_check']) ? json_encode($_POST['retainer_fee_check']) : $_POST['retainer_fee_check']):"";
                                    $retainer_fee_due =isset($_POST['retainer_fee_due']) ? (is_array($_POST['retainer_fee_due']) ? json_encode($_POST['retainer_fee_due']) : $_POST['retainer_fee_due']):"";
                                    $retainer_fee_will_check =isset($_POST['retainer_fee_will_check']) ? (is_array($_POST['retainer_fee_will_check']) ? json_encode($_POST['retainer_fee_will_check']) : $_POST['retainer_fee_will_check']):"";
                                    $other_compensation_check =isset($_POST['other_compensation_check']) ? (is_array($_POST['other_compensation_check']) ? json_encode($_POST['other_compensation_check']) : $_POST['other_compensation_check']):"";
                                    $other_compensation =isset($_POST['other_compensation']) ? (is_array($_POST['other_compensation']) ? json_encode($_POST['other_compensation']) : $_POST['other_compensation']):"";
                                    $firm_fee_lease_amt =isset($_POST['firm_fee_lease_amt']) ? (is_array($_POST['firm_fee_lease_amt']) ? json_encode($_POST['firm_fee_lease_amt']) : $_POST['firm_fee_lease_amt']):"";
                                            
                                    
                                    $firm_fee_lease_amt_per =isset($_POST['firm_fee_lease_amt_per']) ? (is_array($_POST['firm_fee_lease_amt_per']) ? json_encode($_POST['firm_fee_lease_amt_per']) : $_POST['firm_fee_lease_amt_per']):"";
                                    $firm_fee_lease_amt_or =isset($_POST['firm_fee_lease_amt_or']) ? (is_array($_POST['firm_fee_lease_amt_or']) ? json_encode($_POST['firm_fee_lease_amt_or']) : $_POST['firm_fee_lease_amt_or']):"";
                                    $firm_fee_lease_adj_amt_check =isset($_POST['firm_fee_lease_adj_amt_check']) ? (is_array($_POST['firm_fee_lease_adj_amt_check']) ? json_encode($_POST['firm_fee_lease_adj_amt_check']) : $_POST['firm_fee_lease_adj_amt_check']):"";
                                    $firm_fee_lease_adj_amt_other =isset($_POST['firm_fee_lease_adj_amt_other']) ? (is_array($_POST['firm_fee_lease_adj_amt_other']) ? json_encode($_POST['firm_fee_lease_adj_amt_other']) : $_POST['firm_fee_lease_adj_amt_other']):"";
                                    $firm_fee_lease_adj_amt_other_chk =isset($_POST['firm_fee_lease_adj_amt_other_chk']) ? (is_array($_POST['firm_fee_lease_adj_amt_other_chk']) ? json_encode($_POST['firm_fee_lease_adj_amt_other_chk']) : $_POST['firm_fee_lease_adj_amt_other_chk']):"";
                                    $firm_fee_lease_adj_amt_other1 =isset($_POST['firm_fee_lease_adj_amt_other1']) ? (is_array($_POST['firm_fee_lease_adj_amt_other1']) ? json_encode($_POST['firm_fee_lease_adj_amt_other1']) : $_POST['firm_fee_lease_adj_amt_other1']):"";
                                    $when_earned_when_payable_lease_txt =isset($_POST['when_earned_when_payable_lease_txt']) ? (is_array($_POST['when_earned_when_payable_lease_txt']) ? json_encode($_POST['when_earned_when_payable_lease_txt']) : $_POST['when_earned_when_payable_lease_txt']):"";
                                    $when_earned_when_payable_lease_chk =isset($_POST['when_earned_when_payable_lease_chk']) ? (is_array($_POST['when_earned_when_payable_lease_chk']) ? json_encode($_POST['when_earned_when_payable_lease_chk']) : $_POST['when_earned_when_payable_lease_chk']):"";
                                    
                                    $when_earned_when_payable_lease_txt1 =isset($_POST['when_earned_when_payable_lease_txt1']) ? (is_array($_POST['when_earned_when_payable_lease_txt1']) ? json_encode($_POST['when_earned_when_payable_lease_txt1']) : $_POST['when_earned_when_payable_lease_txt1']):"";
                                    $who_will_pay_firm_fee =isset($_POST['who_will_pay_firm_fee']) ? (is_array($_POST['who_will_pay_firm_fee']) ? json_encode($_POST['who_will_pay_firm_fee']) : $_POST['who_will_pay_firm_fee']):"";
                                
                                
                                                    $data['buyer_compensation']=array(
                                                        "client_id"=>$client_id,
                                                        "contract_id"=>$contract_id,
                                                        "contract_pid"=>$insert_id,
                                                        "brokerage_firm_fees_check"=>$brokerage_firm_fees_check,
                                                        "fees_percentage_price"=>$fees_percentage_price,
                                                        "fees_us_dollar"=>$fees_us_dollar,
                                                        "adjusted_amount" =>$adjusted_amount,
                                                        "adjusted_amount_other" => $adjusted_amount_other,
                                                        "hourly_fee_check" =>$hourly_fee_check,
                                                        "hourly_fee_per_hour" =>$hourly_fee_per_hour,
                                                        "hourly_fee_maximum_total" =>$hourly_fee_maximum_total,
                                                        "retainer_fee_check" => $retainer_fee_check,
                                                        "retainer_fee_due" => $computation_deadline_period,
                                                        "retainer_fee_will_check" =>$agency_unless_brokerage_relationship,
                                                        "other_compensation_check" =>$other_compensation_check,
                                                        "other_compensation" =>$other_compensation,
                                                        "firm_fee_lease_amt" => $firm_fee_lease_amt,
                                                        "firm_fee_lease_amt_or" => $firm_fee_lease_amt_or,
                                                        "firm_fee_lease_amt_per" =>$firm_fee_lease_amt_per,
                                
                                                        "firm_fee_lease_adj_amt_check" =>$firm_fee_lease_adj_amt_check,
                                                        "firm_fee_lease_adj_amt_other" =>$firm_fee_lease_adj_amt_other,
                                                        "firm_fee_lease_adj_amt_other1" => $firm_fee_lease_adj_amt_other1,
                                                        "when_earned_when_payable_lease_txt" => $when_earned_when_payable_lease_txt,
                                                        "when_earned_when_payable_lease_chk" =>$when_earned_when_payable_lease_chk,
                                                        "when_earned_when_payable_lease_txt1" => $when_earned_when_payable_lease_txt1,
                                                        "who_will_pay_firm_fee" =>$who_will_pay_firm_fee
                                                        );
                                            }
                                            if($contract_type == "sell" || $contract_type == "Sell"){
                                                $lease_commision_percentage_gross = isset($_POST['lease_commision_percentage_gross']) ? (is_array($_POST['lease_commision_percentage_gross']) ? json_encode($_POST['lease_commision_percentage_gross']) : $_POST['lease_commision_percentage_gross']):"";
                                                $lease_commision_dollar = isset($_POST['lease_commision_dollar']) ? (is_array($_POST['lease_commision_dollar']) ? json_encode($_POST['lease_commision_dollar']) : $_POST['lease_commision_dollar']):"";
                                                $lease_commision_payable = isset($_POST['lease_commision_payable']) ? (is_array($_POST['lease_commision_payable']) ? json_encode($_POST['lease_commision_payable']) : $_POST['lease_commision_payable']):"";
                                                $sales_commision_percentage_gross =isset($_POST['sales_commision_percentage_gross']) ? (is_array($_POST['sales_commision_percentage_gross']) ? json_encode($_POST['sales_commision_percentage_gross']) : $_POST['sales_commision_percentage_gross']):"";
                                                $sales_commision_dollar =isset($_POST['sales_commision_dollar']) ? (is_array($_POST['sales_commision_dollar']) ? json_encode($_POST['sales_commision_dollar']) : $_POST['sales_commision_dollar']):"";
                                                $tenant_agent_percentage_gross =isset($_POST['tenant_agent_percentage_gross']) ? (is_array($_POST['tenant_agent_percentage_gross']) ? json_encode($_POST['tenant_agent_percentage_gross']) : $_POST['tenant_agent_percentage_gross']):"";
                                                $tenant_agent_dollar =isset($_POST['tenant_agent_dollar']) ? (is_array($_POST['tenant_agent_dollar']) ? json_encode($_POST['tenant_agent_dollar']) : $_POST['tenant_agent_dollar']):"";
                                                $transaction_broker_gross =isset($_POST['transaction_broker_gross']) ? (is_array($_POST['transaction_broker_gross']) ? json_encode($_POST['transaction_broker_gross']) : $_POST['transaction_broker_gross']):"";
                                                $transaction_dollar =isset($_POST['transaction_dollar']) ? (is_array($_POST['transaction_dollar']) ? json_encode($_POST['transaction_dollar']) : $_POST['transaction_dollar']):"";
                                                $fee_for_expansion_renewal_chk =isset($_POST['fee_for_expansion_renewal_chk']) ? (is_array($_POST['fee_for_expansion_renewal_chk']) ? json_encode($_POST['fee_for_expansion_renewal_chk']) : $_POST['fee_for_expansion_renewal_chk']):"";
                                                $fee_for_expansion_renewal_chk1 =isset($_POST['fee_for_expansion_renewal_chk1']) ? (is_array($_POST['fee_for_expansion_renewal_chk1']) ? json_encode($_POST['fee_for_expansion_renewal_chk1']) : $_POST['fee_for_expansion_renewal_chk1']):"";
                                                $fee_for_expansion_renewal_chk2 =isset($_POST['fee_for_expansion_renewal_chk2']) ? (is_array($_POST['fee_for_expansion_renewal_chk2']) ? json_encode($_POST['fee_for_expansion_renewal_chk2']) : $_POST['fee_for_expansion_renewal_chk2']):"";
                                                $fee_for_expansion_renewal =isset($_POST['fee_for_expansion_renewal']) ? (is_array($_POST['fee_for_expansion_renewal']) ? json_encode($_POST['fee_for_expansion_renewal']) : $_POST['fee_for_expansion_renewal']):"";
                                                $fee_for_expansion_renewal_chk3 =isset($_POST['fee_for_expansion_renewal_chk3']) ? (is_array($_POST['fee_for_expansion_renewal_chk3']) ? json_encode($_POST['fee_for_expansion_renewal_chk3']) : $_POST['fee_for_expansion_renewal_chk3']):"";
                                                $fee_for_expansion_renewal_chk4 =isset($_POST['fee_for_expansion_renewal_chk4']) ? (is_array($_POST['fee_for_expansion_renewal_chk4']) ? json_encode($_POST['fee_for_expansion_renewal_chk4']) : $_POST['fee_for_expansion_renewal_chk4']):"";
                                                        
                                                
                                                $fee_for_expansion_renewal_chk5 =isset($_POST['fee_for_expansion_renewal_chk5']) ? (is_array($_POST['fee_for_expansion_renewal_chk5']) ? json_encode($_POST['fee_for_expansion_renewal_chk5']) : $_POST['fee_for_expansion_renewal_chk5']):"";
                                                $fee_for_expansion_renewal1 =isset($_POST['fee_for_expansion_renewal1']) ? (is_array($_POST['fee_for_expansion_renewal1']) ? json_encode($_POST['fee_for_expansion_renewal1']) : $_POST['fee_for_expansion_renewal1']):"";
                                                $other_compensation =isset($_POST['other_compensation']) ? (is_array($_POST['other_compensation']) ? json_encode($_POST['other_compensation']) : $_POST['other_compensation']):"";
                                                $when_earned_when_payable_lease_txt =isset($_POST['when_earned_when_payable_lease_txt']) ? (is_array($_POST['when_earned_when_payable_lease_txt']) ? json_encode($_POST['when_earned_when_payable_lease_txt']) : $_POST['when_earned_when_payable_lease_txt']):"";
                                                $when_applicable_payable =isset($_POST['when_applicable_payable']) ? (is_array($_POST['when_applicable_payable']) ? json_encode($_POST['when_applicable_payable']) : $_POST['when_applicable_payable']):"";
                                            
                                            
                                                                $data['sell_compensation']=array(
                                                                    "client_id"=>$client_id,
                                                                    "contract_id"=>$contract_id,
                                                                    "contract_pid"=>$insert_id,
                                                                    "lease_commision_percentage_gross"=>$lease_commision_percentage_gross,
                                                                    "lease_commision_dollar"=>$lease_commision_dollar,
                                                                    "lease_commision_payable"=>$lease_commision_payable,
                                                                    "sales_commision_percentage_gross"=>$sales_commision_percentage_gross,
                                                                    "sales_commision_dollar" =>$sales_commision_dollar,
                                                                    "tenant_agent_percentage_gross" => $tenant_agent_percentage_gross,
                                                                    "tenant_agent_dollar" =>$tenant_agent_dollar,
                                                                    "transaction_broker_gross" =>$transaction_broker_gross,
                                                                    "transaction_dollar" =>$transaction_dollar,
                                                                    "fee_for_expansion_renewal_chk" => $fee_for_expansion_renewal_chk,
                                                                    "fee_for_expansion_renewal_chk1" => $fee_for_expansion_renewal_chk1,
                                                                    "fee_for_expansion_renewal_chk2" =>$fee_for_expansion_renewal_chk2,
                                                                    "fee_for_expansion_renewal" =>$fee_for_expansion_renewal,
                                                                    "fee_for_expansion_renewal_chk3" =>$fee_for_expansion_renewal_chk3,
                                                                    "fee_for_expansion_renewal_chk4" => $fee_for_expansion_renewal_chk4,
                                                                    "fee_for_expansion_renewal_chk5" => $fee_for_expansion_renewal_chk5,
                                                                    "fee_for_expansion_renewal1" =>$fee_for_expansion_renewal1,
                                            
                                                                    "other_compensation" =>$other_compensation,
                                                                    "when_earned_when_payable_lease_txt" =>$when_earned_when_payable_lease_txt,
                                                                    "when_applicable_payable" => $when_applicable_payable,
                                                                    
                                
                                                                    );
                                            
                                            }
                                            if($contract_type == "tenant" || $contract_type == "Tenant"){
                                                $firm_fees_check = isset($_POST['firm_fees_check']) ? (is_array($_POST['firm_fees_check']) ? json_encode($_POST['firm_fees_check']) : $_POST['firm_fees_check']):"";
                                                $fees_percentage_price = isset($_POST['fees_percentage_price']) ? (is_array($_POST['fees_percentage_price']) ? json_encode($_POST['fees_percentage_price']) : $_POST['fees_percentage_price']):"";
                                                $fees_us_dollar =isset($_POST['fees_us_dollar']) ? (is_array($_POST['fees_us_dollar']) ? json_encode($_POST['fees_us_dollar']) : $_POST['fees_us_dollar']):"";
                                                $hourly_fee_check =isset($_POST['hourly_fee_check']) ? (is_array($_POST['hourly_fee_check']) ? json_encode($_POST['hourly_fee_check']) : $_POST['hourly_fee_check']):"";
                                                $hourly_fee_maximum_total =isset($_POST['hourly_fee_maximum_total']) ? (is_array($_POST['hourly_fee_maximum_total']) ? json_encode($_POST['hourly_fee_maximum_total']) : $_POST['hourly_fee_maximum_total']):"";
                                                $retainer_fee_check =isset($_POST['retainer_fee_check']) ? (is_array($_POST['retainer_fee_check']) ? json_encode($_POST['retainer_fee_check']) : $_POST['retainer_fee_check']):"";
                                                $retainer_fee_due =isset($_POST['retainer_fee_due']) ? (is_array($_POST['retainer_fee_due']) ? json_encode($_POST['retainer_fee_due']) : $_POST['retainer_fee_due']):"";
                                                $retainer_fee_will_check =isset($_POST['retainer_fee_will_check']) ? (is_array($_POST['retainer_fee_will_check']) ? json_encode($_POST['retainer_fee_will_check']) : $_POST['retainer_fee_will_check']):"";
                                                $fee_for_expansion_renewal_chk =isset($_POST['fee_for_expansion_renewal_chk']) ? (is_array($_POST['fee_for_expansion_renewal_chk']) ? json_encode($_POST['fee_for_expansion_renewal_chk']) : $_POST['fee_for_expansion_renewal_chk']):"";
                                                $fee_for_expansion_renewal =isset($_POST['fee_for_expansion_renewal']) ? (is_array($_POST['fee_for_expansion_renewal']) ? json_encode($_POST['fee_for_expansion_renewal']) : $_POST['fee_for_expansion_renewal']):"";
                                                $other_compensation_check =isset($_POST['other_compensation_check']) ? (is_array($_POST['other_compensation_check']) ? json_encode($_POST['other_compensation_check']) : $_POST['other_compensation_check']):"";
                                                $other_compensation =isset($_POST['other_compensation']) ? (is_array($_POST['other_compensation']) ? json_encode($_POST['other_compensation']) : $_POST['other_compensation']):"";
                                                $firm_fee_lease_amt =isset($_POST['firm_fee_lease_amt']) ? (is_array($_POST['firm_fee_lease_amt']) ? json_encode($_POST['firm_fee_lease_amt']) : $_POST['firm_fee_lease_amt']):"";
                                                $firm_fee_lease_amt_per =isset($_POST['firm_fee_lease_amt_per']) ? (is_array($_POST['firm_fee_lease_amt_per']) ? json_encode($_POST['firm_fee_lease_amt_per']) : $_POST['firm_fee_lease_amt_per']):"";
                                                $firm_fee_lease_amt_or =isset($_POST['firm_fee_lease_amt_or']) ? (is_array($_POST['firm_fee_lease_amt_or']) ? json_encode($_POST['firm_fee_lease_amt_or']) : $_POST['firm_fee_lease_amt_or']):"";
                                                        
                                                
                                                $firm_fee_lease_adj_amt_check =isset($_POST['firm_fee_lease_adj_amt_check']) ? (is_array($_POST['firm_fee_lease_adj_amt_check']) ? json_encode($_POST['firm_fee_lease_adj_amt_check']) : $_POST['firm_fee_lease_adj_amt_check']):"";
                                                $firm_fee_lease_adj_amt_other =isset($_POST['firm_fee_lease_adj_amt_other']) ? (is_array($_POST['firm_fee_lease_adj_amt_other']) ? json_encode($_POST['firm_fee_lease_adj_amt_other']) : $_POST['firm_fee_lease_adj_amt_other']):"";
                                                $firm_fee_lease_adj_amt_other1 =isset($_POST['firm_fee_lease_adj_amt_other1']) ? (is_array($_POST['firm_fee_lease_adj_amt_other1']) ? json_encode($_POST['firm_fee_lease_adj_amt_other1']) : $_POST['firm_fee_lease_adj_amt_other1']):"";
                                                $when_earned_when_payable_lease_txt =isset($_POST['when_earned_when_payable_lease_txt']) ? (is_array($_POST['when_earned_when_payable_lease_txt']) ? json_encode($_POST['when_earned_when_payable_lease_txt']) : $_POST['when_earned_when_payable_lease_txt']):"";
                                                $who_will_pay_firm_fee =isset($_POST['who_will_pay_firm_fee']) ? (is_array($_POST['who_will_pay_firm_fee']) ? json_encode($_POST['who_will_pay_firm_fee']) : $_POST['who_will_pay_firm_fee']):"";
                                                $who_will_pay_firm_obligated =isset($_POST['who_will_pay_firm_obligated']) ? (is_array($_POST['who_will_pay_firm_obligated']) ? json_encode($_POST['who_will_pay_firm_obligated']) : $_POST['who_will_pay_firm_obligated']):"";
                                                $who_will_pay_firm_obligated_not =isset($_POST['who_will_pay_firm_obligated_not']) ? (is_array($_POST['who_will_pay_firm_obligated_not']) ? json_encode($_POST['who_will_pay_firm_obligated_not']) : $_POST['who_will_pay_firm_obligated_not']):"";
                                
                                            
                                                                $data['tenant_compensation']=array(
                                                                    "client_id"=>$client_id,
                                                                    "contract_id"=>$contract_id,
                                                                    "contract_pid"=>$insert_id,
                                                                    "firm_fees_check"=>$firm_fees_check,
                                                                    "fees_percentage_price"=>$fees_percentage_price,
                                                                    "fees_us_dollar"=>$fees_us_dollar,
                                                                    "hourly_fee_check" =>$hourly_fee_check,
                                                                    "hourly_fee_maximum_total" => $hourly_fee_maximum_total,
                                                                    "retainer_fee_check" =>$retainer_fee_check,
                                                                    "retainer_fee_due" =>$retainer_fee_due,
                                                                    "retainer_fee_will_check" =>$retainer_fee_will_check,
                                                                    "fee_for_expansion_renewal_chk" => $fee_for_expansion_renewal_chk,
                                                                    "fee_for_expansion_renewal" => $fee_for_expansion_renewal,
                                                                    "other_compensation_check" =>$other_compensation_check,
                                                                    "other_compensation" =>$other_compensation,
                                                                    "firm_fee_lease_amt" =>$firm_fee_lease_amt,
                                                                    "firm_fee_lease_amt_per" => $firm_fee_lease_amt_per,
                                                                    "firm_fee_lease_amt_or" => $firm_fee_lease_amt_or,
                                                                    "firm_fee_lease_adj_amt_check" =>$firm_fee_lease_adj_amt_check,
                                            
                                                                    "firm_fee_lease_adj_amt_other" =>$firm_fee_lease_adj_amt_other,
                                                                    "firm_fee_lease_adj_amt_other1" =>$firm_fee_lease_adj_amt_other1,
                                                                    "when_earned_when_payable_lease_txt" => $when_earned_when_payable_lease_txt,
                                
                                                                    "who_will_pay_firm_fee" =>$who_will_pay_firm_fee,
                                                                    "who_will_pay_firm_obligated" =>$who_will_pay_firm_obligated,
                                                                    "who_will_pay_firm_obligated_not" => $who_will_pay_firm_obligated_not
                                
                                                                    );
                                            }
                                            if($contract_type == "lease" || $contract_type == "Lease"){
                                                $lease_commision_percentage_gross = isset($_POST['lease_commision_percentage_gross']) ? (is_array($_POST['lease_commision_percentage_gross']) ? json_encode($_POST['lease_commision_percentage_gross']) : $_POST['lease_commision_percentage_gross']):"";
                                                $lease_commision_dollar = isset($_POST['lease_commision_dollar']) ? (is_array($_POST['lease_commision_dollar']) ? json_encode($_POST['lease_commision_dollar']) : $_POST['lease_commision_dollar']):"";
                                                $sales_commision_percentage_gross =isset($_POST['sales_commision_percentage_gross']) ? (is_array($_POST['sales_commision_percentage_gross']) ? json_encode($_POST['sales_commision_percentage_gross']) : $_POST['sales_commision_percentage_gross']):"";
                                                $sales_commision_dollar =isset($_POST['sales_commision_dollar']) ? (is_array($_POST['sales_commision_dollar']) ? json_encode($_POST['sales_commision_dollar']) : $_POST['sales_commision_dollar']):"";
                                                $tenant_agent_percentage_gross =isset($_POST['tenant_agent_percentage_gross']) ? (is_array($_POST['tenant_agent_percentage_gross']) ? json_encode($_POST['tenant_agent_percentage_gross']) : $_POST['tenant_agent_percentage_gross']):"";
                                                $tenant_agent_dollar =isset($_POST['tenant_agent_dollar']) ? (is_array($_POST['tenant_agent_dollar']) ? json_encode($_POST['tenant_agent_dollar']) : $_POST['tenant_agent_dollar']):"";
                                                $transaction_broker_gross =isset($_POST['transaction_broker_gross']) ? (is_array($_POST['transaction_broker_gross']) ? json_encode($_POST['transaction_broker_gross']) : $_POST['transaction_broker_gross']):"";
                                                $transaction_dollar =isset($_POST['transaction_dollar']) ? (is_array($_POST['transaction_dollar']) ? json_encode($_POST['transaction_dollar']) : $_POST['transaction_dollar']):"";
                                                $fee_for_expansion_renewal =isset($_POST['fee_for_expansion_renewal']) ? (is_array($_POST['fee_for_expansion_renewal']) ? json_encode($_POST['fee_for_expansion_renewal']) : $_POST['fee_for_expansion_renewal']):"";
                                                $fee_for_expansion_renewal_chk =isset($_POST['fee_for_expansion_renewal_chk']) ? (is_array($_POST['fee_for_expansion_renewal_chk']) ? json_encode($_POST['fee_for_expansion_renewal_chk']) : $_POST['fee_for_expansion_renewal_chk']):"";
                                                $fee_for_expansion_renewal_chk1 =isset($_POST['fee_for_expansion_renewal_chk1']) ? (is_array($_POST['fee_for_expansion_renewal_chk1']) ? json_encode($_POST['fee_for_expansion_renewal_chk1']) : $_POST['fee_for_expansion_renewal_chk1']):"";
                                                $fee_for_expansion_renewal_chk2 =isset($_POST['fee_for_expansion_renewal_chk2']) ? (is_array($_POST['fee_for_expansion_renewal_chk2']) ? json_encode($_POST['fee_for_expansion_renewal_chk2']) : $_POST['fee_for_expansion_renewal_chk2']):"";
                                                $fee_for_expansion_renewal_chk3 =isset($_POST['fee_for_expansion_renewal_chk3']) ? (is_array($_POST['fee_for_expansion_renewal_chk3']) ? json_encode($_POST['fee_for_expansion_renewal_chk3']) : $_POST['fee_for_expansion_renewal_chk3']):"";
                                                $fee_for_expansion_renewal_chk4 =isset($_POST['fee_for_expansion_renewal_chk4']) ? (is_array($_POST['fee_for_expansion_renewal_chk4']) ? json_encode($_POST['fee_for_expansion_renewal_chk4']) : $_POST['fee_for_expansion_renewal_chk4']):"";
                                                        
                                                
                                                $fee_for_expansion_renewal_chk5 =isset($_POST['fee_for_expansion_renewal_chk5']) ? (is_array($_POST['fee_for_expansion_renewal_chk5']) ? json_encode($_POST['fee_for_expansion_renewal_chk5']) : $_POST['fee_for_expansion_renewal_chk5']):"";
                                                $fee_for_expansion_renewal1 =isset($_POST['fee_for_expansion_renewal1']) ? (is_array($_POST['fee_for_expansion_renewal1']) ? json_encode($_POST['fee_for_expansion_renewal1']) : $_POST['fee_for_expansion_renewal1']):"";
                                                $other_compensation =isset($_POST['other_compensation']) ? (is_array($_POST['other_compensation']) ? json_encode($_POST['other_compensation']) : $_POST['other_compensation']):"";
                                                $when_earned_when_payable_lease_txt =isset($_POST['when_earned_when_payable_lease_txt']) ? (is_array($_POST['when_earned_when_payable_lease_txt']) ? json_encode($_POST['when_earned_when_payable_lease_txt']) : $_POST['when_earned_when_payable_lease_txt']):"";
                                                $when_applicable_payable =isset($_POST['when_applicable_payable']) ? (is_array($_POST['when_applicable_payable']) ? json_encode($_POST['when_applicable_payable']) : $_POST['when_applicable_payable']):"";
                                                $tenant_agent_chk =isset($_POST['tenant_agent_chk']) ? (is_array($_POST['tenant_agent_chk']) ? json_encode($_POST['tenant_agent_chk']) : $_POST['tenant_agent_chk']):"";
                                                $transaction_chk =isset($_POST['transaction_chk']) ? (is_array($_POST['transaction_chk']) ? json_encode($_POST['transaction_chk']) : $_POST['transaction_chk']):"";
                                
                                            
                                                                $data['lease_compensation']=array(
                                                                    "client_id"=>$client_id,
                                                                    "contract_id"=>$contract_id,
                                                                    "contract_pid"=>$insert_id,
                                                                    "lease_commision_percentage_gross"=>$lease_commision_percentage_gross,
                                                                    "lease_commision_dollar"=>$lease_commision_dollar,
                                                                    "sales_commision_percentage_gross"=>$sales_commision_percentage_gross,
                                                                    "sales_commision_dollar" =>$sales_commision_dollar,
                                                                    "tenant_agent_percentage_gross" => $tenant_agent_percentage_gross,
                                                                    "tenant_agent_dollar" =>$tenant_agent_dollar,
                                                                    "tenant_agent_chk" =>$tenant_agent_chk,
                                                                    "transaction_broker_gross" =>$transaction_broker_gross,
                                                                    "transaction_dollar" =>$transaction_dollar,
                                                                    "transaction_chk" =>$transaction_chk,
                                                                    "fee_for_expansion_renewal" => $fee_for_expansion_renewal,
                                                                    "fee_for_expansion_renewal_chk" => $fee_for_expansion_renewal_chk,
                                                                    
                                                                    "fee_for_expansion_renewal_chk1" =>$fee_for_expansion_renewal_chk1,
                                                                    "fee_for_expansion_renewal_chk2" =>$fee_for_expansion_renewal_chk2,
                                                                    "fee_for_expansion_renewal_chk3" =>$fee_for_expansion_renewal_chk3,
                                                                    "fee_for_expansion_renewal_chk4" => $fee_for_expansion_renewal_chk4,
                                                                    "fee_for_expansion_renewal_chk5" => $fee_for_expansion_renewal_chk5,
                                                                    "fee_for_expansion_renewal1" =>$fee_for_expansion_renewal1,
                                            
                                                                    "other_compensation" =>$other_compensation,
                                                                    "when_earned_when_payable_lease_txt" => $when_earned_when_payable_lease_txt,
                                
                                                                    "when_applicable_payable" =>$when_applicable_payable,
                                                                    );
                                            }        
                                            if($contract_type == "lease" || $contract_type == "Lease" || $contract_type == "sell" || $contract_type == "Sell"){
                                                $mls_info_check = isset($_POST['mls_info_check']) ? (is_array($_POST['mls_info_check']) ? json_encode($_POST['mls_info_check']) : $_POST['mls_info_check']):"";
                                                $mls_info_check1 = isset($_POST['mls_info_check1']) ? (is_array($_POST['mls_info_check1']) ? json_encode($_POST['mls_info_check1']) : $_POST['mls_info_check1']):"";
                                                $mls_marketing_except =isset($_POST['mls_marketing_except']) ? (is_array($_POST['mls_marketing_except']) ? json_encode($_POST['mls_marketing_except']) : $_POST['mls_marketing_except']):"";
                                                $display_premise_address =isset($_POST['display_premise_address']) ? (is_array($_POST['display_premise_address']) ? json_encode($_POST['display_premise_address']) : $_POST['display_premise_address']):"";
                                                $property_access_check =isset($_POST['property_access_check']) ? (is_array($_POST['property_access_check']) ? json_encode($_POST['property_access_check']) : $_POST['property_access_check']):"";
                                                $prooperty_acess =isset($_POST['prooperty_acess']) ? (is_array($_POST['prooperty_acess']) ? json_encode($_POST['prooperty_acess']) : $_POST['prooperty_acess']):"";
                                                $broker_marketing =isset($_POST['broker_marketing']) ? (is_array($_POST['broker_marketing']) ? json_encode($_POST['broker_marketing']) : $_POST['broker_marketing']):"";
                                                                            
                                                                $data['mls_information']=array(
                                                                    "client_id"=>$client_id,
                                                                    "contract_id"=>$contract_id,
                                                                    "contract_pid"=>$insert_id,
                                                                    "mls_info_check"=>$mls_info_check,
                                                                    "mls_info_check1"=>$mls_info_check1,
                                                                    "mls_marketing_except"=>$mls_marketing_except,
                                                                    "display_premise_address" =>$display_premise_address,
                                                                    "property_access_check" => $property_access_check,
                                                                    "prooperty_acess" =>$prooperty_acess,
                                                                    "broker_marketing" =>$broker_marketing
                                                                    );
                                
                                            }  
                                            if($contract_type == "sell" || $contract_type == "Sell"){
                                                $encumbrance = isset($_POST['encumbrance']) ? (is_array($_POST['encumbrance']) ? json_encode($_POST['encumbrance']) : $_POST['encumbrance']):"";
                                                $encumbrance1 = isset($_POST['encumbrance1']) ? (is_array($_POST['encumbrance1']) ? json_encode($_POST['encumbrance1']) : $_POST['encumbrance1']):"";
                                                $evidance_of_title_chk =isset($_POST['evidance_of_title_chk']) ? (is_array($_POST['evidance_of_title_chk']) ? json_encode($_POST['evidance_of_title_chk']) : $_POST['evidance_of_title_chk']):"";
                                                $association_aporx =isset($_POST['association_aporx']) ? (is_array($_POST['association_aporx']) ? json_encode($_POST['association_aporx']) : $_POST['association_aporx']):"";
                                                $association_aporx_per =isset($_POST['association_aporx_per']) ? (is_array($_POST['association_aporx_per']) ? json_encode($_POST['association_aporx_per']) : $_POST['association_aporx_per']):"";
                                                $association_aporx_except =isset($_POST['association_aporx_except']) ? (is_array($_POST['association_aporx_except']) ? json_encode($_POST['association_aporx_except']) : $_POST['association_aporx_except']):"";
                                                $forfeiture_of_chk =isset($_POST['forfeiture_of_chk']) ? (is_array($_POST['forfeiture_of_chk']) ? json_encode($_POST['forfeiture_of_chk']) : $_POST['forfeiture_of_chk']):"";
                                                $forfeiture_of_txt =isset($_POST['forfeiture_of_txt']) ? (is_array($_POST['forfeiture_of_txt']) ? json_encode($_POST['forfeiture_of_txt']) : $_POST['forfeiture_of_txt']):"";
                                
                                                                $data['sell_encumbrances']=array(
                                                                    "client_id"=>$client_id,
                                                                    "contract_id"=>$contract_id,
                                                                    "contract_pid"=>$insert_id,
                                                                    "encumbrance"=>$encumbrance,
                                                                    "encumbrance1"=>$encumbrance1,
                                                                    "evidance_of_title_chk"=>$evidance_of_title_chk,
                                                                    "association_aporx" =>$association_aporx,
                                                                    "association_aporx_per" => $association_aporx_per,
                                                                    "association_aporx_except" =>$association_aporx_except,
                                                                    "forfeiture_of_chk" => $forfeiture_of_chk,
                                                                    "forfeiture_of_txt" =>$forfeiture_of_txt
                                                                    );
                                
                                            }      
                                            if($contract_type == "sell" || $contract_type == "Sell"){
                                                $price = isset($_POST['price']) ? (is_array($_POST['price']) ? json_encode($_POST['price']) : $_POST['price']):"";
                                                $terms = isset($_POST['terms']) ? (is_array($_POST['terms']) ? json_encode($_POST['terms']) : $_POST['terms']):"";
                                                $other_terms =isset($_POST['other_terms']) ? (is_array($_POST['other_terms']) ? json_encode($_POST['other_terms']) : $_POST['other_terms']):"";
                                                $loan_discount_points =isset($_POST['loan_discount_points']) ? (is_array($_POST['loan_discount_points']) ? json_encode($_POST['loan_discount_points']) : $_POST['loan_discount_points']):"";
                                                $buyer_closing_cost =isset($_POST['buyer_closing_cost']) ? (is_array($_POST['buyer_closing_cost']) ? json_encode($_POST['buyer_closing_cost']) : $_POST['buyer_closing_cost']):"";
                                                $buyer_closing_cost1 =isset($_POST['buyer_closing_cost1']) ? (is_array($_POST['buyer_closing_cost1']) ? json_encode($_POST['buyer_closing_cost1']) : $_POST['buyer_closing_cost1']):"";
                                                $earnest_money =isset($_POST['earnest_money']) ? (is_array($_POST['earnest_money']) ? json_encode($_POST['earnest_money']) : $_POST['earnest_money']):"";
                                                $earnest_money_form =isset($_POST['earnest_money_form']) ? (is_array($_POST['earnest_money_form']) ? json_encode($_POST['earnest_money_form']) : $_POST['earnest_money_form']):"";
                                                $seller_proceed_idicated_chk =isset($_POST['seller_proceed_idicated_chk']) ? (is_array($_POST['seller_proceed_idicated_chk']) ? json_encode($_POST['seller_proceed_idicated_chk']) : $_POST['seller_proceed_idicated_chk']):"";
                                
                                                                $data['sell_price_term']=array(
                                                                    "client_id"=>$client_id,
                                                                    "contract_id"=>$contract_id,
                                                                    "contract_pid"=>$insert_id,
                                                                    "price"=>$price,
                                                                    "terms"=>$terms,
                                                                    "other_terms"=>$other_terms,
                                                                    "loan_discount_points" =>$loan_discount_points,
                                                                    "buyer_closing_cost" => $buyer_closing_cost,
                                                                    "buyer_closing_cost1" =>$buyer_closing_cost1,
                                                                    "earnest_money" =>$earnest_money,
                                                                    "earnest_money_form" => $earnest_money_form,
                                                                    "seller_proceed_idicated_chk" =>$seller_proceed_idicated_chk,
                                                                    );
                                
                                            }                 
                                            if($contract_type == "lease" || $contract_type == "Lease"){
                                                $rental_rate = isset($_POST['rental_rate']) ? (is_array($_POST['rental_rate']) ? json_encode($_POST['rental_rate']) : $_POST['rental_rate']):"";
                                                $min_security_deposit = isset($_POST['min_security_deposit']) ? (is_array($_POST['min_security_deposit']) ? json_encode($_POST['min_security_deposit']) : $_POST['min_security_deposit']):"";
                                                $mls_marketing_except =isset($_POST['mls_marketing_except']) ? (is_array($_POST['mls_marketing_except']) ? json_encode($_POST['mls_marketing_except']) : $_POST['mls_marketing_except']):"";
                                                $other_terms =isset($_POST['other_terms']) ? (is_array($_POST['other_terms']) ? json_encode($_POST['other_terms']) : $_POST['other_terms']):"";
                                
                                                                $data['lease_rental_rate']=array(
                                                                    "client_id"=>$client_id,
                                                                    "contract_id"=>$contract_id,
                                                                    "contract_pid"=>$insert_id,
                                                                    "rental_rate"=>$rental_rate,
                                                                    "min_security_deposit"=>$min_security_deposit,
                                                                    "mls_marketing_except"=>$mls_marketing_except,
                                                                    "other_terms" =>$other_terms
                                                                                                        );
                                
                                            }            
                                            if($contract_type == "buy" || $contract_type == "Buy" || $contract_type == "tenant" || $contract_type == "Tenant"){
                                                $broker_services = isset($_POST['broker_services']) ? (is_array($_POST['broker_services']) ? json_encode($_POST['broker_services']) : $_POST['broker_services']):"";
                                                $showing_properties = isset($_POST['showing_properties']) ? (is_array($_POST['showing_properties']) ? json_encode($_POST['showing_properties']) : $_POST['showing_properties']):"";
                                                $showing_properties1 =isset($_POST['showing_properties1']) ? (is_array($_POST['showing_properties1']) ? json_encode($_POST['showing_properties1']) : $_POST['showing_properties1']):"";
                                
                                                                $data['buyer_broker_services']=array(
                                                                    "client_id"=>$client_id,
                                                                    "contract_id"=>$contract_id,
                                                                    "contract_pid"=>$insert_id,
                                                                    "broker_services"=>$broker_services,
                                                                    "showing_properties"=>$showing_properties,
                                                                    "showing_properties1"=>$showing_properties1,
                                                                                                        );
                                
                                            }                        
                                            
                                            if( !empty($_POST['party']) && !empty($insert_id)){
                                                $broker = isset($_POST['broker']) ? (is_array($_POST['broker']) ? json_encode($_POST['broker']) : $_POST['broker']) :'';
                                                $broker_signature = isset($_POST['broker_signature']) ? (is_array($_POST['broker_signature']) ? json_encode($_POST['broker_signature']) : $_POST['broker_signature']) :'';
                                                $broker_date = isset($_POST['broker_date']) ? (is_array($_POST['broker_date']) ? json_encode($_POST['broker_date']) : $_POST['broker_date']) :'';
                                                $broker_address = isset($_POST['broker_address']) ? (is_array($_POST['broker_address']) ? json_encode($_POST['broker_address']) : $_POST['broker_address']) :'';
                                                $broker_phone = isset($_POST['broker_phone']) ? (is_array($_POST['broker_phone']) ? json_encode($_POST['broker_phone']) : $_POST['broker_phone']) :'';
                                                $broker_fax = isset($_POST['broker_fax']) ? (is_array($_POST['broker_fax']) ? json_encode($_POST['broker_fax']) : $_POST['broker_fax']) :'';
                                                $broker_electronic_address = isset($_POST['broker_electronic_address']) ? (is_array($_POST['broker_electronic_address']) ? json_encode($_POST['broker_electronic_address']) : $_POST['broker_electronic_address']) :'';
                                                //brokerage
                                                $brokerage = isset($_POST['brokerage']) ? (is_array($_POST['brokerage']) ? json_encode($_POST['brokerage']) : $_POST['brokerage']) :'';
                                                $brokerage_signature = isset($_POST['brokerage_signature']) ? (is_array($_POST['brokerage_signature']) ? json_encode($_POST['brokerage_signature']) : $_POST['brokerage_signature']) :'';
                                                $brokerage_date = isset($_POST['brokerage_date']) ? (is_array($_POST['brokerage_date']) ? json_encode($_POST['brokerage_date']) : $_POST['brokerage_date']) :'';
                                                $brokerage_address = isset($_POST['brokerage_address']) ? (is_array($_POST['brokerage_address']) ? json_encode($_POST['brokerage_address']) : $_POST['brokerage_address']) :'';
                                                $brokerage_phone = isset($_POST['brokerage_phone']) ? (is_array($_POST['brokerage_phone']) ? json_encode($_POST['brokerage_phone']) : $_POST['brokerage_phone']) :'';
                                                $brokerage_fax = isset($_POST['brokerage_fax']) ? (is_array($_POST['brokerage_fax']) ? json_encode($_POST['brokerage_fax']) : $_POST['brokerage_fax']) :'';
                                                $brokerage_electronic_address = isset($_POST['brokerage_electronic_address']) ? (is_array($_POST['brokerage_electronic_address']) ? json_encode($_POST['brokerage_electronic_address']) : $_POST['brokerage_electronic_address']) :'';
                                                //others
                                                $counter_rejection = isset($_POST['counter_rejection']) ? (is_array($_POST['counter_rejection']) ? json_encode($_POST['counter_rejection']) : $_POST['counter_rejection']) :'';
                                                $counter_rejection_by = isset($_POST['counter_rejection_by']) ? (is_array($_POST['counter_rejection_by']) ? json_encode($_POST['counter_rejection_by']) : $_POST['counter_rejection_by']) :'';
                                                $broker_acknowledge_receipt = isset($_POST['broker_acknowledge_receipt']) ? (is_array($_POST['broker_acknowledge_receipt']) ? json_encode($_POST['broker_acknowledge_receipt']) : $_POST['broker_acknowledge_receipt']) :'';;
                                                $broker_working_as = isset($_POST['broker_working_as']) ? (is_array($_POST['broker_working_as']) ? json_encode($_POST['broker_working_as']) : $_POST['broker_working_as']) :'';
                                                $change_of_satus = isset($_POST['change_of_satus']) ? (is_array($_POST['change_of_satus']) ? json_encode($_POST['change_of_satus']) : $_POST['change_of_satus']) :'';
                                                $compensation_commission_paid = isset($_POST['compensation_commission_paid']) ? (is_array($_POST['compensation_commission_paid']) ? json_encode($_POST['compensation_commission_paid']) : $_POST['compensation_commission_paid']) :'';
                                                $compensation_commission_paid_other = isset($_POST['compensation_commission_paid_other']) ? (is_array($_POST['compensation_commission_paid_other']) ? json_encode($_POST['compensation_commission_paid_other']) : $_POST['compensation_commission_paid_other']) :'';
                                  
                                                $party = isset($_POST['party']) ? (is_array($_POST['party']) ? json_encode($_POST['party']) : $_POST['party']) :'';
                                                $party_signature = isset($_POST['party_signature']) ? (is_array($_POST['party_signature']) ? json_encode($_POST['party_signature']) : $_POST['party_signature']) :'';
                                                $party_date = isset($_POST['party_date']) ? (is_array($_POST['party_date']) ? json_encode($_POST['party_date']) : $_POST['party_date']) :'';
                                                $party_address = isset($_POST['party_address']) ? (is_array($_POST['party_address']) ? json_encode($_POST['party_address']) : $_POST['party_address']) :'';
                                                $party_phone = isset($_POST['party_phone']) ? (is_array($_POST['party_phone']) ? json_encode($_POST['party_phone']) : $_POST['party_phone']) :'';
                                                $party_fax = isset($_POST['party_fax']) ? (is_array($_POST['party_fax']) ? json_encode($_POST['party_fax']) : $_POST['party_fax']) :'';
                                                $party_electronic_address = isset($_POST['party_electronic_address']) ? (is_array($_POST['party_electronic_address']) ? json_encode($_POST['party_electronic_address']) : $_POST['party_electronic_address']) :'';
                                
                                                $party_seller = isset($_POST['party_seller']) ? (is_array($_POST['party_seller']) ? json_encode($_POST['party_seller']) : $_POST['party_seller']) :'';
                                                $party_seller_signature = isset($_POST['party_seller_signature']) ? (is_array($_POST['party_seller_signature']) ? json_encode($_POST['party_seller_signature']) : $_POST['party_seller_signature']) :'';
                                                $party_seller_date = isset($_POST['party_seller_date']) ? (is_array($_POST['party_seller_date']) ? json_encode($_POST['party_seller_date']) : $_POST['party_seller_date']) :'';
                                                $party_seller_address = isset($_POST['party_seller_address']) ? (is_array($_POST['party_seller_address']) ? json_encode($_POST['party_seller_address']) : $_POST['party_seller_address']) :'';
                                                $party_seller_phone = isset($_POST['party_seller_phone']) ? (is_array($_POST['party_seller_phone']) ? json_encode($_POST['party_seller_phone']) : $_POST['party_seller_phone']) :'';
                                                $party_seller_fax = isset($_POST['party_seller_fax']) ? (is_array($_POST['party_seller_fax']) ? json_encode($_POST['party_seller_fax']) : $_POST['party_seller_fax']) :'';
                                                $party_seller_electronic_address = isset($_POST['party_seller_electronic_address']) ? (is_array($_POST['party_seller_electronic_address']) ? json_encode($_POST['party_seller_electronic_address']) : $_POST['party_seller_electronic_address']) :'';
                                                
                                                $data['contract_parties']=array(
                                                    "client_id"=>$client_id,
                                                    "contract_id"=>$contract_id,
                                                    "contract_pid"=>$insert_id,
                                                    "party"=>$party,
                                                    "party_signature"=>$party_signature,
                                                    "party_date"=>$party_date,
                                                    "party_address"=>$party_address,
                                                    "party_phone"=>$party_phone,
                                                    "party_fax"=>$party_fax,
                                                    "party_electronic_address"=>$party_electronic_address,
                                                    "party_seller"=>$party_seller,
                                                    "party_seller_signature"=>$party_seller_signature,
                                                    "party_seller_date"=>$party_seller_date,
                                                    "party_seller_address"=>$party_seller_address,
                                                    "party_seller_phone"=>$party_seller_phone,
                                                    "party_seller_fax"=>$party_seller_fax,
                                                    "party_seller_electronic_address"=>$party_seller_electronic_address,
                                                    "broker"=>$broker,
                                                    "broker_signature"=>$broker_signature,
                                                    "broker_date"=>$broker_date,
                                                    "broker_address"=>$broker_address,
                                                    "broker_phone"=>$broker_phone,
                                                    "broker_fax"=>$broker_fax,
                                                    "broker_electronic_address"=>$broker_electronic_address,
                                                    "brokerage"=>$brokerage,
                                                    "brokerage_signature"=>$brokerage_signature,
                                                    "brokerage_date"=>$brokerage_date,
                                                    "brokerage_address"=>$brokerage_address,
                                                    "brokerage_phone"=>$brokerage_phone,
                                                    "brokerage_fax"=>$brokerage_fax,
                                                    "brokerage_electronic_address"=>$brokerage_electronic_address,
                                                    'counter_rejection'=>$counter_rejection  ,
                                                    'counter_rejection_by' =>$counter_rejection_by,
                                                    'broker_acknowledge_receipt'=>$broker_acknowledge_receipt ,
                                                    'broker_working_as' => $broker_working_as,
                                                    'change_of_satus' =>$change_of_satus,
                                                    'compensation_commission_paid' =>$compensation_commission_paid,
                                                    'compensation_commission_paid_other'=>$compensation_commission_paid_other
                                                );
                                                
                                            }
                                            if( !empty($_POST['contract_date']) && !empty($insert_id)){
                                            $data['contract_list']=array(
                                                                        "client_id"=>$client_id,
                                                                        "contract_id"=>$contract_id,
                                                                        "contract_pid"=>$insert_id,
                                                                        "party_affiliation"=>'test',
                                                                        "sent_date"=>'test',
                                                                        "contract_date"=>$_POST['contract_date'],
                                                                        "contract_status"=>'test',
                                                                        "property_type"=>'test',
                                                                        "property_address"=>'test',
                                                                        "property_MLS"=>'test',
                                                                        "property_original_price"=>'test',
                                                                        "property_contract_price"=>'test',
                                                                        "property_deadline"=>'test',
                                                                        "property_closing_date"=>'test',
                                                                        "property_staus"=>'test',
                                                                        "property_title_resolution"=>'test'
                                                                        );
                                           
                                        }
                                
                                            if(!empty($_POST['event']) && !empty($insert_id)){
                                            foreach($_POST['event'] as $date_key=>$date_value){
                                                $event=$_POST['event'][$date_key];
                                                $deadline_date= !empty($_POST['deadline_date'][$date_key])? date("Y-m-d H:i:s",strtotime($_POST['deadline_date'][$date_key])):0;
                                                $Itemno= !empty($_POST['Itemno'][$date_key])? $_POST['Itemno'][$date_key]:0;
                                                $reference= !empty($_POST['reference'][$date_key])? $_POST['reference'][$date_key]:0;
                                                if(trim($date_value) !='' || trim($deadline_value)!=''){
                                                    $data['contract_date_deadline'][$date_key]=array(
                                                                                                    "client_id"=>$client_id,
                                                                                                    "contract_id"=>$contract_id,
                                                                                                    "contract_pid"=>$insert_id,
                                                                                                    "Itemno"=>$Itemno,
                                                                                                    "Item_name"=>0,
                                                                                                    "reference"=>$reference,
                                                                                                    "event"=>$event,
                                                                                                    "deadline_date"=>$deadline_date
                                                                                                );
                                                }
                                            }
                                        }
                                        if(!empty($_POST['property_detail']) && !empty($insert_id)){
                                    
                                            $property_street=!empty($_POST['property_street'])? (is_array($_POST['property_street']) ? json_encode($_POST['property_street']) : $_POST['property_street']) :''; 
                                            $type=!empty($_POST['type'])? (is_array($_POST['type']) ? json_encode($_POST['type']) : $_POST['type']) :''; 
                                            $property_city=!empty($_POST['property_city'])? (is_array($_POST['property_city']) ? json_encode($_POST['property_city']) : $_POST['property_city']) :'';
                                            $property_state=!empty($_POST['property_state'])? (is_array($_POST['property_state']) ? json_encode($_POST['property_state']) : $_POST['property_state']) :'';
                                            $property_zipcode=!empty($_POST['property_zipcode'])? (is_array($_POST['property_zipcode']) ? json_encode($_POST['property_zipcode']) : $_POST['property_zipcode']) :'';
                                            $property_county=!empty($_POST['property_county'])? (is_array($_POST['property_county']) ? json_encode($_POST['property_county']) : $_POST['property_county']) :'';
                                            $property_detail=!empty($_POST['property_detail'])? (is_array($_POST['property_detail']) ? json_encode($_POST['property_detail']) : $_POST['property_detail']) :'';
                                                $data['contract_property'][]=array(
                                                                                                "client_id"=>$client_id,
                                                                                                "contract_id"=>$contract_id,
                                                                                                "contract_pid"=>$insert_id,
                                                                                                "type"=>$type,
                                                                                                "property_street_name"=>$property_street,    
                                                                                                "property_city"=>$property_city,
                                                                                                "property_state"=>$property_state,
                                                                                                "property_zipcode"=>$property_zipcode,
                                                                                                "property_county"=>$property_county,
                                                                                                "property_detail"=>$property_detail
                                                                                            );
                                            
                                        }
                                            if(!empty($insert_id)){
                                                $deligence_documents= !empty($_POST['deligence_documents'])? (is_array($_POST['deligence_documents']) ? json_encode($_POST['deligence_documents']) : $_POST['deligence_documents']):0;
                                                $personal_property_covenyance= !empty($_POST['personal_property_covenyance'])? (is_array($_POST['personal_property_covenyance']) ? json_encode($_POST['personal_property_covenyance']) : $_POST['personal_property_covenyance']):0;
                                                $other_inclusion=!empty($_POST['other_inclusion'])? (is_array($_POST['other_inclusion']) ? json_encode($_POST['other_inclusion']) : $_POST['other_inclusion']) :0;
                                                $parking_storage = !empty($_POST['parking_storage'])? (is_array($_POST['parking_storage']) ? json_encode($_POST['parking_storage']) : $_POST['parking_storage']) :0;
                                                $exclusion_details = !empty($_POST['exclusion_details'])? (is_array($_POST['exclusion_details']) ? json_encode($_POST['exclusion_details']) : $_POST['exclusion_details']) :0;
                                                $deeded_water_rights_details = !empty($_POST['deeded_water_rights_details']) ? (is_array($_POST['deeded_water_rights_details']) ? json_encode($_POST['deeded_water_rights_details']) : $_POST['deeded_water_rights_details']) :0;
                                                $other_water_rights_details= !empty($_POST['other_water_rights_details']) ? (is_array($_POST['other_water_rights_details']) ? json_encode($_POST['other_water_rights_details']) : $_POST['other_water_rights_details']) :0;
                                                $well_rights_details=!empty($_POST['well_rights_details']) ? (is_array($_POST['well_rights_details']) ? json_encode($_POST['well_rights_details']) : $_POST['well_rights_details']) :0;
                                                $water_stock_certificate_details=!empty($_POST['water_stock_certificate_details']) ? (is_array($_POST['water_stock_certificate_details']) ? json_encode($_POST['water_stock_certificate_details']) : $_POST['water_stock_certificate_details']) :0;
                                                $conveyance_details=!empty($_POST['conveyance_details']) ? (is_array($_POST['conveyance_details']) ? json_encode($_POST['conveyance_details']) : $_POST['conveyance_details']) :0;
                                                $parking_chk = !empty($_POST['parking_chk'])? (is_array($_POST['parking_chk']) ? json_encode($_POST['parking_chk']) : $_POST['parking_chk']) :'';
                                                $parking = !empty($_POST['parking'])? (is_array($_POST['parking']) ? json_encode($_POST['parking']) : $_POST['parking']) :'';
                                                $storage_chk = !empty($_POST['storage_chk'])? (is_array($_POST['storage_chk']) ? json_encode($_POST['storage_chk']) : $_POST['storage_chk']) :'';
                                                $storage = !empty($_POST['storage'])? (is_array($_POST['storage']) ? json_encode($_POST['storage']) : $_POST['storage']) :'';
                                                $water_right = !empty($_POST['water_right'])? (is_array($_POST['water_right']) ? json_encode($_POST['water_right']) : $_POST['water_right']) :'';
                                                $well_right = !empty($_POST['well_right'])? (is_array($_POST['well_right']) ? json_encode($_POST['well_right']) : $_POST['well_right']) :'';
                                                $growing_crops = !empty($_POST['growing_crops'])? (is_array($_POST['growing_crops']) ? json_encode($_POST['growing_crops']) : $_POST['growing_crops']) :'';
                                                $inclusion_fixture = !empty($_POST['inclusion_fixture'])? (is_array($_POST['inclusion_fixture']) ? json_encode($_POST['inclusion_fixture']) : $_POST['inclusion_fixture']) :'';
                                                $personal_property_txt = !empty($_POST['personal_property_txt'])? (is_array($_POST['personal_property_txt']) ? json_encode($_POST['personal_property_txt']) : $_POST['personal_property_txt']) :'';
                                                $personal_property_chk = !empty($_POST['personal_property_chk'])? (is_array($_POST['personal_property_chk']) ? json_encode($_POST['personal_property_chk']) : $_POST['personal_property_chk']) :'';
                                                $trade_fixture = !empty($_POST['trade_fixture'])? (is_array($_POST['trade_fixture']) ? json_encode($_POST['trade_fixture']) : $_POST['trade_fixture']) :'';
                                                $trade_fixture1 = !empty($_POST['trade_fixture1'])? (is_array($_POST['trade_fixture1']) ? json_encode($_POST['trade_fixture1']) : $_POST['trade_fixture1']) :'';
                                                $inclusion_other_fixture = !empty($_POST['inclusion_other_fixture'])? (is_array($_POST['inclusion_other_fixture']) ? json_encode($_POST['inclusion_other_fixture']) : $_POST['inclusion_other_fixture']) :'';
                                                $garage_remote= !empty($_POST['garage_remote'])? (is_array($_POST['garage_remote']) ? json_encode($_POST['garage_remote']) : $_POST['garage_remote']):0;
                                
                                                $data['contract_inclusion']=array(
                                                    "client_id"=>$client_id,
                                                    "contract_id"=>$contract_id,
                                                    "contract_pid"=>$insert_id,
                                                    "diligence_documents"=>$deligence_documents,
                                                    "personal_property_convoyance"=>$personal_property_covenyance,
                                                    "others_inclusion"=>$other_inclusion,
                                                    "parking_storage"=>$parking_storage,
                                                    "exclusion"=>$exclusion_details,
                                                    "deed_water_right"=>$deeded_water_rights_details,
                                                    "other_water_right"=>$other_water_rights_details,
                                                    "well_right"=>$well_rights_details,
                                                    "water_stock_certificate"=>$water_stock_certificate_details,
                                                    "conveyance"=>$conveyance_details,
                                                    "parking_chk"=>$parking_chk,
                                                    "parking"=>$parking,
                                                    "storage_chk"=>$storage_chk,
                                                    "storage"=>$storage,
                                                    "water_right"=>$water_right,
                                                    "well_right"=>$well_right,
                                                    "growing_crops"=>$growing_crops,
                                                    "inclusion_fixture"=>$inclusion_fixture,
                                                    "personal_property_txt"=>$personal_property_txt,
                                                    "personal_property_chk"=>$personal_property_chk,
                                                    "trade_fixture"=>$trade_fixture,
                                                    "trade_fixture1"=>$trade_fixture1,
                                                    "inclusion_other_fixture"=>$inclusion_other_fixture,
                                                    "garage_remote"=>$garage_remote,
                                 );
                                            }      
                                            if($contract_type == "buy and sell" || $contract_type == "Buy And Sell"){

            if(!empty($_POST['event']) && !empty($insert_id)){
            foreach($_POST['event'] as $date_key=>$date_value){
                $event=$_POST['event'][$date_key];
                $Itemno= !empty($_POST['Itemno'][$date_key])? $_POST['Itemno'][$date_key]:0;
                $reference= !empty($_POST['reference'][$date_key])? $_POST['reference'][$date_key]:0;
                if(trim($date_value) !='' ){
                    $data['contract_date_deadline'][$date_key]=array(
                                                                    "client_id"=>$client_id,
                                                                    "contract_id"=>$contract_id,
                                                                    "contract_pid"=>$insert_id,
                                                                    "Itemno"=>$Itemno,
                                                                    "Item_name"=>0,
                                                                    "reference"=>$reference,
                                                                    "event"=>$event
                                                                );
                }
            }
        }
                                    
                                                    
                                                //purchase_description
                                                    $seller_concession = isset($_POST['seller_concession']) ? (is_array($_POST['seller_concession']) ? json_encode($_POST['seller_concession']) : $_POST['seller_concession']):"";
                                                    $earnest_money_form = isset($_POST['earnest_money_form']) ? (is_array($_POST['earnest_money_form']) ? json_encode($_POST['earnest_money_form']) : $_POST['earnest_money_form']):"";
                                                    $earnest_money_held =isset($_POST['earnest_money_held']) ? (is_array($_POST['earnest_money_held']) ? json_encode($_POST['earnest_money_held']) : $_POST['earnest_money_held']):"";
                                                    $time_of_payment =isset($_POST['time_of_payment']) ? (is_array($_POST['time_of_payment']) ? json_encode($_POST['time_of_payment']) : $_POST['time_of_payment']):"";
                                                    $loan_limitations =isset($_POST['loan_limitations']) ? (is_array($_POST['loan_limitations']) ? json_encode($_POST['loan_limitations']) : $_POST['loan_limitations']):"";
                                    
                                                    $loan_limitations_other = isset($_POST['loan_limitations_other']) ? (is_array($_POST['loan_limitations_other']) ? json_encode($_POST['loan_limitations_other']) : $_POST['loan_limitations_other']):"";
                                                    $assumption_payable = isset($_POST['assumption_payable']) ? (is_array($_POST['assumption_payable']) ? json_encode($_POST['assumption_payable']) : $_POST['assumption_payable']):"";
                                                    $assumption_per =isset($_POST['assumption_per']) ? (is_array($_POST['assumption_per']) ? json_encode($_POST['assumption_per']) : $_POST['assumption_per']):"";
                                                    $assumption_anum_intrest =isset($_POST['assumption_anum_intrest']) ? (is_array($_POST['assumption_anum_intrest']) ? json_encode($_POST['assumption_anum_intrest']) : $_POST['assumption_anum_intrest']):"";
                                                    $escrow_for =isset($_POST['escrow_for']) ? (is_array($_POST['escrow_for']) ? json_encode($_POST['escrow_for']) : $_POST['escrow_for']):"";
                                    
                                                    $escrow_and = isset($_POST['escrow_and']) ? (is_array($_POST['escrow_and']) ? json_encode($_POST['escrow_and']) : $_POST['escrow_and']):"";
                                                    $escrow_and_txt = isset($_POST['escrow_and_txt']) ? (is_array($_POST['escrow_and_txt']) ? json_encode($_POST['escrow_and_txt']) : $_POST['escrow_and_txt']):"";
                                                    $loan_transfer_notexceed =isset($_POST['loan_transfer_notexceed']) ? (is_array($_POST['loan_transfer_notexceed']) ? json_encode($_POST['loan_transfer_notexceed']) : $_POST['loan_transfer_notexceed']):"";
                                                    $interest_notexceed =isset($_POST['interest_notexceed']) ? (is_array($_POST['interest_notexceed']) ? json_encode($_POST['interest_notexceed']) : $_POST['interest_notexceed']):"";
                                                    $new_payment_notexceed =isset($_POST['new_payment_notexceed']) ? (is_array($_POST['new_payment_notexceed']) ? json_encode($_POST['new_payment_notexceed']) : $_POST['new_payment_notexceed']):"";
                                    
                                                    $new_payment_notexceed_per = isset($_POST['new_payment_notexceed_per']) ? (is_array($_POST['new_payment_notexceed_per']) ? json_encode($_POST['new_payment_notexceed_per']) : $_POST['new_payment_notexceed_per']):"";
                                                    $assumption_balence_closing_exceed = isset($_POST['assumption_balence_closing_exceed']) ? (is_array($_POST['assumption_balence_closing_exceed']) ? json_encode($_POST['assumption_balence_closing_exceed']) : $_POST['assumption_balence_closing_exceed']):"";
                                                    $realeased_liability_loan =isset($_POST['realeased_liability_loan']) ? (is_array($_POST['realeased_liability_loan']) ? json_encode($_POST['realeased_liability_loan']) : $_POST['realeased_liability_loan']):"";
                                                    $evidence_by_delivery_on =isset($_POST['evidence_by_delivery_on']) ? (is_array($_POST['evidence_by_delivery_on']) ? json_encode($_POST['evidence_by_delivery_on']) : $_POST['evidence_by_delivery_on']):"";
                                                    $loan_transfer_approval_deadline =isset($_POST['loan_transfer_approval_deadline']) ? (is_array($_POST['loan_transfer_approval_deadline']) ? json_encode($_POST['loan_transfer_approval_deadline']) : $_POST['loan_transfer_approval_deadline']):"";
                                    
                                                    $release_liability_paid = isset($_POST['release_liability_paid']) ? (is_array($_POST['release_liability_paid']) ? json_encode($_POST['release_liability_paid']) : $_POST['release_liability_paid']):"";
                                                    $release_liability_exceed = isset($_POST['release_liability_exceed']) ? (is_array($_POST['release_liability_exceed']) ? json_encode($_POST['release_liability_exceed']) : $_POST['release_liability_exceed']):"";
                                                    $seller_financing =isset($_POST['seller_financing']) ? (is_array($_POST['seller_financing']) ? json_encode($_POST['seller_financing']) : $_POST['seller_financing']):"";
                                                    $private_financing_deadline =isset($_POST['private_financing_deadline']) ? (is_array($_POST['private_financing_deadline']) ? json_encode($_POST['private_financing_deadline']) : $_POST['private_financing_deadline']):"";
                                    
                                                   
                                                    $data['purchase_description']=array(
                                                        "client_id"=>$client_id,
                                                        "contract_id"=>$contract_id,
                                                        "contract_pid"=>$insert_id,
                                                       'seller_concession'=> $seller_concession ,
                                                       'earnest_money_form'=>$earnest_money_form ,
                                                       'earnest_money_held'=>$earnest_money_held ,
                                                       'time_of_payment'=> $time_of_payment ,
                                                       'loan_limitations'=>$loan_limitations ,
                                                       'loan_limitations_other'=> $loan_limitations_other ,
                                                       'assumption_payable'=> $assumption_payable, 
                                                       'assumption_per'=> $assumption_per, 
                                                       'assumption_anum_intrest'=>$assumption_anum_intrest, 
                                                       'escrow_for'=>$escrow_for, 
                                                       'escrow_and'=> $escrow_and, 
                                                       'escrow_and_txt'=>$escrow_and_txt,
                                                       'loan_transfer_notexceed'=> $loan_transfer_notexceed,
                                                       'interest_notexceed'=>$interest_notexceed,
                                                       'new_payment_notexceed'=>$new_payment_notexceed, 
                                                       'new_payment_notexceed_per'=>$new_payment_notexceed_per,  
                                                        'assumption_balence_closing_exceed'=>$assumption_balence_closing_exceed,
                                                        'realeased_liability_loan'=>$realeased_liability_loan, 
                                                        'evidence_by_delivery_on'=>$evidence_by_delivery_on, 
                                                        'loan_transfer_approval_deadline'=>$loan_transfer_approval_deadline,
                                                        'release_liability_paid'=>$release_liability_paid ,
                                                        'release_liability_exceed'=>$release_liability_exceed,
                                                        'seller_financing'=> $seller_financing, 
                                                        'private_financing_deadline'=>$private_financing_deadline
                                                    );  
//proration
$tax_for_calendar_year = isset($_POST['tax_for_calendar_year']) ? (is_array($_POST['tax_for_calendar_year']) ? json_encode($_POST['tax_for_calendar_year']) : $_POST['tax_for_calendar_year']):"";
$most_recent_mill_levy = isset($_POST['most_recent_mill_levy']) ? (is_array($_POST['most_recent_mill_levy']) ? json_encode($_POST['most_recent_mill_levy']) : $_POST['most_recent_mill_levy']):"";
$other_calendar_taxes =isset($_POST['other_calendar_taxes']) ? (is_array($_POST['other_calendar_taxes']) ? json_encode($_POST['other_calendar_taxes']) : $_POST['other_calendar_taxes']):"";
$rents_actually_received =isset($_POST['rents_actually_received']) ? (is_array($_POST['rents_actually_received']) ? json_encode($_POST['rents_actually_received']) : $_POST['rents_actually_received']):"";
$accrued =isset($_POST['accrued']) ? (is_array($_POST['accrued']) ? json_encode($_POST['accrued']) : $_POST['accrued']):"";

$association_obligation_of = isset($_POST['association_obligation_of']) ? (is_array($_POST['association_obligation_of']) ? json_encode($_POST['association_obligation_of']) : $_POST['association_obligation_of']):"";
$assessment_payable_approx = isset($_POST['assessment_payable_approx']) ? (is_array($_POST['assessment_payable_approx']) ? json_encode($_POST['assessment_payable_approx']) : $_POST['assessment_payable_approx']):"";
$assessment_payable_per =isset($_POST['assessment_payable_per']) ? (is_array($_POST['assessment_payable_per']) ? json_encode($_POST['assessment_payable_per']) : $_POST['assessment_payable_per']):"";
$regular_assessment_and =isset($_POST['regular_assessment_and']) ? (is_array($_POST['regular_assessment_and']) ? json_encode($_POST['regular_assessment_and']) : $_POST['regular_assessment_and']):"";
$other_prorations =isset($_POST['other_prorations']) ? (is_array($_POST['other_prorations']) ? json_encode($_POST['other_prorations']) : $_POST['other_prorations']):"";

$data['prorations']=array(
    "client_id"=>$client_id,
    "contract_id"=>$contract_id,
    "contract_pid"=>$insert_id,
    'tax_for_calendar_year'=>$tax_for_calendar_year,
        'most_recent_mill_levy'=>$most_recent_mill_levy,
        'other_calendar_taxes'=>$other_calendar_taxes,
        'rents_actually_received'=>$rents_actually_received,
        'accrued'=>$accrued,
        'association_obligation_of'=>$association_obligation_of,
        'assessment_payable_approx'=>$assessment_payable_approx,
        'assessment_payable_per'=>$assessment_payable_per,
        'regular_assessment_and'=>$regular_assessment_and,
        'other_prorations'=>$other_prorations
);                                                      //provisions
                                                        $apraised_property_value = isset($_POST['apraised_property_value']) ? (is_array($_POST['apraised_property_value']) ? json_encode($_POST['apraised_property_value']) : $_POST['apraised_property_value']):"";
                                                        $apraisal_paid_by = isset($_POST['apraisal_paid_by']) ? (is_array($_POST['apraisal_paid_by']) ? json_encode($_POST['apraisal_paid_by']) : $_POST['apraisal_paid_by']):"";
                                                        $closing_instruction =isset($_POST['closing_instruction']) ? (is_array($_POST['closing_instruction']) ? json_encode($_POST['closing_instruction']) : $_POST['closing_instruction']):"";
                                                        $closing_designated_by =isset($_POST['closing_designated_by']) ? (is_array($_POST['closing_designated_by']) ? json_encode($_POST['closing_designated_by']) : $_POST['closing_designated_by']):"";
                                                        $transfer_title_sufficient =isset($_POST['transfer_title_sufficient']) ? (is_array($_POST['transfer_title_sufficient']) ? json_encode($_POST['transfer_title_sufficient']) : $_POST['transfer_title_sufficient']):"";
                                    
                                                        $transfer_title_other = isset($_POST['transfer_title_other']) ? (is_array($_POST['transfer_title_other']) ? json_encode($_POST['transfer_title_other']) : $_POST['transfer_title_other']):"";
                                                        $occupy_principle_residence = isset($_POST['occupy_principle_residence']) ? (is_array($_POST['occupy_principle_residence']) ? json_encode($_POST['occupy_principle_residence']) : $_POST['occupy_principle_residence']):"";
                                                        $post_closing_occupancy_agreement =isset($_POST['post_closing_occupancy_agreement']) ? (is_array($_POST['post_closing_occupancy_agreement']) ? json_encode($_POST['post_closing_occupancy_agreement']) : $_POST['post_closing_occupancy_agreement']):"";
                                                        $fails_deliver_payment =isset($_POST['fails_deliver_payment']) ? (is_array($_POST['fails_deliver_payment']) ? json_encode($_POST['fails_deliver_payment']) : $_POST['fails_deliver_payment']):"";
                                                        $specific_performance =isset($_POST['specific_performance']) ? (is_array($_POST['specific_performance']) ? json_encode($_POST['specific_performance']) : $_POST['specific_performance']):"";
                                    
                                                        $data['provisions']=array(
                                                            "client_id"=>$client_id,
                                                            "contract_id"=>$contract_id,
                                                            "contract_pid"=>$insert_id,
                                                            'apraised_property_value'=> $apraised_property_value ,
                                                            'apraisal_paid_by'=>$apraisal_paid_by ,
                                                            'closing_instruction'=>$closing_instruction ,
                                                            'closing_designated_by'=> $closing_designated_by ,
                                                            'transfer_title_sufficient'=>$transfer_title_sufficient ,
                                                            'transfer_title_other'=> $transfer_title_other ,
                                                            'occupy_principle_residence'=> $occupy_principle_residence, 
                                                            'post_closing_occupancy_agreement'=> $post_closing_occupancy_agreement, 
                                                            'fails_deliver_payment'=>$fails_deliver_payment, 
                                                            'specific_performance'=>$specific_performance
                                                        );  
                                                       
                                                //record_title_insurance
                                                    $seller_select_title = isset($_POST['seller_select_title']) ? (is_array($_POST['seller_select_title']) ? json_encode($_POST['seller_select_title']) : $_POST['seller_select_title']):"";
                                                    $buyer_select_title = isset($_POST['buyer_select_title']) ? (is_array($_POST['buyer_select_title']) ? json_encode($_POST['buyer_select_title']) : $_POST['buyer_select_title']):"";
                                                    $seller_abstract_title =isset($_POST['seller_abstract_title']) ? (is_array($_POST['seller_abstract_title']) ? json_encode($_POST['seller_abstract_title']) : $_POST['seller_abstract_title']):"";
                                                    $owner_extend_coverage =isset($_POST['owner_extend_coverage']) ? (is_array($_POST['owner_extend_coverage']) ? json_encode($_POST['owner_extend_coverage']) : $_POST['owner_extend_coverage']):"";
                                                    $addition_premium_expense =isset($_POST['addition_premium_expense']) ? (is_array($_POST['addition_premium_expense']) ? json_encode($_POST['addition_premium_expense']) : $_POST['addition_premium_expense']):"";
                                                    $addition_premium_expense_other = isset($_POST['addition_premium_expense_other']) ? (is_array($_POST['addition_premium_expense_other']) ? json_encode($_POST['addition_premium_expense_other']) : $_POST['addition_premium_expense_other']):"";
                                    
                                                    $data['record_title_insurance']=array(
                                                        "client_id"=>$client_id,
                                                        "contract_id"=>$contract_id,
                                                        "contract_pid"=>$insert_id,
                                                        'seller_select_title'=> $seller_select_title ,
                                                        'buyer_select_title'=>$buyer_select_title ,
                                                        'seller_abstract_title'=>$seller_abstract_title ,
                                                        'owner_extend_coverage'=> $owner_extend_coverage ,
                                                        'addition_premium_expense'=>$addition_premium_expense ,
                                                        'addition_premium_expense_other'=> $addition_premium_expense_other
                                                    );  
                                      
                                                    
                                            //ilc_survey_details
                                            $new_ilc = isset($_POST['new_ilc']) ? (is_array($_POST['new_ilc']) ? json_encode($_POST['new_ilc']) : $_POST['new_ilc']):"";
                                            $new_survey = isset($_POST['new_survey']) ? (is_array($_POST['new_survey']) ? json_encode($_POST['new_survey']) : $_POST['new_survey']):"";
                                            $in_the_form =isset($_POST['in_the_form']) ? (is_array($_POST['in_the_form']) ? json_encode($_POST['in_the_form']) : $_POST['in_the_form']):"";
                                            $ordering_of =isset($_POST['ordering_of']) ? (is_array($_POST['ordering_of']) ? json_encode($_POST['ordering_of']) : $_POST['ordering_of']):"";
                                            $payment_of_chk =isset($_POST['payment_of_chk']) ? (is_array($_POST['payment_of_chk']) ? json_encode($_POST['payment_of_chk']) : $_POST['payment_of_chk']):"";
                                            $payment_of_txt = isset($_POST['payment_of_txt']) ? (is_array($_POST['payment_of_txt']) ? json_encode($_POST['payment_of_txt']) : $_POST['payment_of_txt']):"";
                                            $delivery_of = isset($_POST['delivery_of']) ? (is_array($_POST['delivery_of']) ? json_encode($_POST['delivery_of']) : $_POST['delivery_of']):"";
                                            
                                            $data['ilc_survey_details']=array(
                                                "client_id"=>$client_id,
                                                "contract_id"=>$contract_id,
                                                "contract_pid"=>$insert_id,
                                                'new_ilc'=> $new_ilc ,
                                                'new_survey'=>$new_survey ,
                                                'in_the_form'=>$in_the_form ,
                                                'ordering_of'=> $ordering_of ,
                                                'payment_of_chk'=>$payment_of_chk ,
                                                'payment_of_txt'=> $payment_of_txt,
                                                'delivery_of'=> $delivery_of
                                            );            
                                                    
                                            //closing_cost_fee
                                                    $closing_services_fee_chk = isset($_POST['closing_services_fee_chk']) ? (is_array($_POST['closing_services_fee_chk']) ? json_encode($_POST['closing_services_fee_chk']) : $_POST['closing_services_fee_chk']):"";
                                                    $closing_services_fee_txt = isset($_POST['closing_services_fee_txt']) ? (is_array($_POST['closing_services_fee_txt']) ? json_encode($_POST['closing_services_fee_txt']) : $_POST['closing_services_fee_txt']):"";
                                                    $status_letter_change_fee =isset($_POST['status_letter_change_fee']) ? (is_array($_POST['status_letter_change_fee']) ? json_encode($_POST['status_letter_change_fee']) : $_POST['status_letter_change_fee']):"";
                                                    $association_change_fee =isset($_POST['association_change_fee']) ? (is_array($_POST['association_change_fee']) ? json_encode($_POST['association_change_fee']) : $_POST['association_change_fee']):"";
                                                    $local_transfer_tax =isset($_POST['local_transfer_tax']) ? (is_array($_POST['local_transfer_tax']) ? json_encode($_POST['local_transfer_tax']) : $_POST['local_transfer_tax']):"";
                                                    $local_transfer_percentage = isset($_POST['local_transfer_percentage']) ? (is_array($_POST['local_transfer_percentage']) ? json_encode($_POST['local_transfer_percentage']) : $_POST['local_transfer_percentage']):"";
                                                    $paid_at_closing_by = isset($_POST['paid_at_closing_by']) ? (is_array($_POST['paid_at_closing_by']) ? json_encode($_POST['paid_at_closing_by']) : $_POST['paid_at_closing_by']):"";
                                    
                                                    $private_paid_at_closing = isset($_POST['private_paid_at_closing']) ? (is_array($_POST['private_paid_at_closing']) ? json_encode($_POST['private_paid_at_closing']) : $_POST['private_paid_at_closing']):"";
                                                    $transfer_fee_association =isset($_POST['transfer_fee_association']) ? (is_array($_POST['transfer_fee_association']) ? json_encode($_POST['transfer_fee_association']) : $_POST['transfer_fee_association']):"";
                                                    $total_amount =isset($_POST['total_amount']) ? (is_array($_POST['total_amount']) ? json_encode($_POST['total_amount']) : $_POST['total_amount']):"";
                                                    $purchase_price_dollar =isset($_POST['purchase_price_dollar']) ? (is_array($_POST['purchase_price_dollar']) ? json_encode($_POST['purchase_price_dollar']) : $_POST['purchase_price_dollar']):"";
                                                    $purchase_price_percentage = isset($_POST['purchase_price_percentage']) ? (is_array($_POST['purchase_price_percentage']) ? json_encode($_POST['purchase_price_percentage']) : $_POST['purchase_price_percentage']):"";
                                                    $water_transfer_fee = isset($_POST['water_transfer_fee']) ? (is_array($_POST['water_transfer_fee']) ? json_encode($_POST['water_transfer_fee']) : $_POST['water_transfer_fee']):"";
                                    
                                                    $water_transfer_for = isset($_POST['water_transfer_for']) ? (is_array($_POST['water_transfer_for']) ? json_encode($_POST['water_transfer_for']) : $_POST['water_transfer_for']):"";
                                                    $sale_used_tax = isset($_POST['sale_used_tax']) ? (is_array($_POST['sale_used_tax']) ? json_encode($_POST['sale_used_tax']) : $_POST['sale_used_tax']):"";
                                    
                                                    $data['closing_cost_fee']=array(
                                                        "client_id"=>$client_id,
                                                        "contract_id"=>$contract_id,
                                                        "contract_pid"=>$insert_id,
                                                        'closing_services_fee_chk'=> $closing_services_fee_chk ,
                                                        'closing_services_fee_txt'=>$closing_services_fee_txt ,
                                                        'status_letter_change_fee'=>$status_letter_change_fee ,
                                                        'association_change_fee'=> $association_change_fee ,
                                                        'local_transfer_tax'=>$local_transfer_tax ,
                                                        'local_transfer_percentage'=> $local_transfer_percentage,
                                                        'paid_at_closing_by'=> $paid_at_closing_by,
                                    
                                                        'private_paid_at_closing'=>$private_paid_at_closing ,
                                                        'transfer_fee_association'=> $transfer_fee_association ,
                                                        'total_amount'=>$total_amount ,
                                                        'purchase_price_dollar'=> $purchase_price_dollar,
                                                        'purchase_price_percentage'=> $purchase_price_percentage,
                                                        'water_transfer_fee'=> $water_transfer_fee,
                                    
                                                        'water_transfer_for'=> $water_transfer_for,
                                                        'sale_used_tax'=> $sale_used_tax
                                                    );                  
                                           
                                                                                                 
                                                //disclosure_inspection
                                                $due_diligence_doc_chk = isset($_POST['due_diligence_doc_chk']) ? (is_array($_POST['due_diligence_doc_chk']) ? json_encode($_POST['due_diligence_doc_chk']) : $_POST['due_diligence_doc_chk']):"";
                                                $due_diligence_doc_txt = isset($_POST['due_diligence_doc_txt']) ? (is_array($_POST['due_diligence_doc_txt']) ? json_encode($_POST['due_diligence_doc_txt']) : $_POST['due_diligence_doc_txt']):"";
                                                $other_doc_chk =isset($_POST['other_doc_chk']) ? (is_array($_POST['other_doc_chk']) ? json_encode($_POST['other_doc_chk']) : $_POST['other_doc_chk']):"";
                                                $other_doc_txt =isset($_POST['other_doc_txt']) ? (is_array($_POST['other_doc_txt']) ? json_encode($_POST['other_doc_txt']) : $_POST['other_doc_txt']):"";
                                                $conditional_sale_prop =isset($_POST['conditional_sale_prop']) ? (is_array($_POST['conditional_sale_prop']) ? json_encode($_POST['conditional_sale_prop']) : $_POST['conditional_sale_prop']):"";
                                                $source_portable_water = isset($_POST['source_portable_water']) ? (is_array($_POST['source_portable_water']) ? json_encode($_POST['source_portable_water']) : $_POST['source_portable_water']):"";
                                                $no_well = isset($_POST['no_well']) ? (is_array($_POST['no_well']) ? json_encode($_POST['no_well']) : $_POST['no_well']):"";
                                    
                                                $well_permit = isset($_POST['well_permit']) ? (is_array($_POST['well_permit']) ? json_encode($_POST['well_permit']) : $_POST['well_permit']):"";
                                                $data['disclosure_inspection']=array(
                                                    "client_id"=>$client_id,
                                                    "contract_id"=>$contract_id,
                                                    "contract_pid"=>$insert_id,
                                                    'due_diligence_doc_chk'=> $due_diligence_doc_chk ,
                                                    'due_diligence_doc_txt'=>$due_diligence_doc_txt ,
                                                    'other_doc_chk'=>$other_doc_chk ,
                                                    'other_doc_txt'=> $other_doc_txt ,
                                                    'conditional_sale_prop'=>$conditional_sale_prop ,
                                                    'source_portable_water'=> $source_portable_water,
                                                    'no_well'=> $no_well,
                                    
                                                    'well_permit'=>$well_permit 
                                                );                  
                                            }                                          
                                            
                                            
                                            //     echo "POSTED DATA=================<pre>";
// print_r($_POST);
// echo "</pre>Created DATA=================<pre>";
// print_r($data); 
        //similar_text("", "", $sim);
        $submitted = $this->client_model->updateagreement($data);
        //exit;
        if($insert_id){
            $this->session->set_flashdata('msg','Agreement updated successfully.');
            //$filename = $this->get_agreement_pdf($insert_id);
           // $this->client_model->saveagreement_rel(array('pdf_name'=>$filename,'id'=>$insert_id));
            //redirect('Agreement/newagreement/'.$client_id.'/'.$contract_id.'#contract_standard');
        }else{
            $this->session->set_flashdata('error','Something went wrong.');
            //redirect('Agreement/newagreement/'.$client_id.'/'.$contract_id.'#contract_standard');
        }
    }
}
        //$this->twig->render('framework/index.twig', array('agreement' => $agreement));
        if(!empty($agreement)){
        $contract_doc = $agreement->contract_file;
        $contract_doc = str_replace("{{ client.company }}", $clients->company, $contract_doc);
        $contract_doc = str_replace("{{ client.phone }}", $clients->phone, $contract_doc);
        $contract_doc = str_replace("{{ client.email }}", $clients->email, $contract_doc);

        $contract_doc = str_replace("{{ agent.company }}", $agent->company, $contract_doc);
        $contract_doc = str_replace("{{ agent.phone }}", $agent->phone, $contract_doc);
        $contract_doc = str_replace("{{ agent.email }}", $agent->email, $contract_doc);
        $agreement->contract_file = $contract_doc;
        }        
        $clause_data = array("user_id"=>$this->session->userdata('user_id'),"client_id"=>$clients->client_id,"contract_id"=>$contractid);
        $agreement_flow = $this->agent_model->get_agreement_flow($clause_data);
        $agreement_flow_val = "";
        if($agreement_flow){
            $agreement_flow_val = $agreement_flow->agreement_flow;
        }
        $id = $this->uri->segment(5); 
        $data = array(
            'session' => $_SESSION,
            'v' => "agreement_edit.twig",
            'agent' => $agent,
            'agreement_form' => $agreement,
            'agreement_id' => $id,
            'client' => $clients,
            'agreement_flow'=>$agreement_flow_val,
            'agreement_pdf'=>''
        );

            if(!empty($id)){
                $data['agreement'] =  $this->client_model->get_client_agreement($id);
                if(!empty($data['agreement'][0]->pdf_name)){
                    $data['agreement_pdf']= "/assets/contract_pdf/".$data['agreement'][0]->pdf_name;
                }
                $data['agreement_list'] =  $this->client_model->get_agreement_list($id);
                if(!empty($data['agreement_list'])){
                  $data['agreement_list'] =  $data['agreement_list'];
                }
                
                $data['agreement_parties'] =  $this->client_model->get_agreement_parties($id);
                $data['agreement_seller'] =  $this->client_model->get_agreement_seller($id);
                if(!empty($data['agreement_seller'])){
                  $data['agreement_seller'] =  $data['agreement_seller'];
                }
                $data['agreement_companies'] =  $this->client_model->get_agreement_companies($id);
                if(!empty($data['agreement_companies'])){
                  $data['agreement_companies'] =  $data['agreement_companies'];
                }
                $data['agreement_deadline'] =  $this->client_model->get_agreement_deadline($id);
                $data['agreement_inclusion'] =  $this->client_model->get_agreement_inclusion($id);
                if(!empty($data['agreement_inclusion'])){
                  $data['agreement_inclusion'] =  $data['agreement_inclusion'];
                }
                $data["recipient"] =$this->Message_model->get_contract_recipient($id);
              }
              //print_r($data); exit;
        $this->framework->init($data, false);
    }
public function updateAgreementJson(){

    if(isset($_POST)){
        print_r($_POST); exit;
            //Get agreement id
    $contractid = $_POST['contract_id'];
    //Get client data
    $client_id = $_POST['client_id'];
    $id = $_POST['id'];
    $clients = $this->client_model->get_client($client_id);
    //Get agent data
    $agent = $this->client_model->get_agent_client($this->session->userdata('user_id'));
    // Get new agreements from Admin with contract id
    $agreement = $this->client_model->get_agreement($contractid);
        $data=[];
        if(!empty($_POST)){
            $client_id      =   $_POST['client_id'];
            $contract_id    =   $_POST['contract_id'];
            if( !empty($_POST['contract_id'])){           
                                          if(empty($id)){
                                            $contract_rel = $this->client_model->get_client_agreement($id);
                                            $this->client_model->saveagreement_rel(
                                                array('client_id'=>$client_id,
                                            'contract_id'=>$contract_id,
                                            "user_id"=>$this->session->userdata("user_id")));
                                            $insert_id = $contract_rel[0]->id;
                                          }else{
                                            $contract_rel = $this->client_model->get_client_agreement($id);
                                            //$this->client_model->saveagreement_rel(array('id'=>$contract_rel[0]->id,'version'=>$contract_rel[0]->version +1));
                                            $insert_id = $contract_rel[0]->id;
                                          }
                                         
                                       }
            if( !empty($_POST['second_company_name'])){ 
                $data['contract_companies']=array(
                                                "client_id"=>$client_id,
                                                "contract_id"=>$contract_id,
                                                "contract_pid"=>$insert_id,
                                                "company_name"=>$_POST['second_company_name']
                                            );
            }
            if( !empty($_POST['seller_name'])){
                if(is_array($_POST['seller_name'])){
                    foreach($_POST['seller_name'] as $seller_name){
                        if(trim($seller_name)){
                            $data['contract_seller'][]=array(
                                                            "client_id"=>$client_id,
                                                            "contract_id"=>$contract_id,
                                                            "contract_pid"=>$insert_id,
                                                            "seller_name"=>$seller_name
                                                        );
                            }
                        }
                }else{
                    $seller_name = $_POST['seller_name'];
                    $data['contract_seller'][0]=array(
                        "client_id"=>$client_id,
                        "contract_id"=>$contract_id,
                        "contract_pid"=>$insert_id,
                        "seller_name"=>$seller_name
                    );
                }
    
            }
            if( !empty($_POST['contract_date'])){
            $data['contract_list']=array(
                                        "client_id"=>$client_id,
                                        "contract_id"=>$contract_id,
                                        "contract_pid"=>$insert_id,
                                        "party_affiliation"=>'test',
                                        "sent_date"=>'test',
                                        "contract_date"=>$_POST['contract_date'],
                                        "contract_status"=>'test',
                                        "property_type"=>'test',
                                        "property_address"=>'test',
                                        "property_MLS"=>'test',
                                        "property_original_price"=>'test',
                                        "property_contract_price"=>'test',
                                        "property_deadline"=>'test',
                                        "property_closing_date"=>'test',
                                        "property_staus"=>'test',
                                        "property_title_resolution"=>'test'
                                        );
           
        }
        if( !empty($_POST['fb_cn_fname'])){
        foreach($_POST['fb_cn_fname'] as $key=>$value){
            if(trim($value) !='' || trim($_POST['fb_cn_mname'][$key])!='' || trim($_POST['fb_cn_lname'][$key])!=''){
                $data['contract_parties'][]=array(
                                            "client_id"=>$client_id,
                                            "contract_id"=>$contract_id,
                                            "contract_pid"=>$insert_id,
                                            "first_name"=>$value,
                                            "middle_name"=>$_POST['fb_cn_mname'][$key],
                                            "last_name"=>$_POST['fb_cn_lname'][$key]
                                        );
            }
        }
    }
    if(!empty($_POST['fb_cdd_duedate'])){
        foreach($_POST['fb_cdd_duedate'] as $date_key=>$date_value){
            $deadline_value=$_POST['fb_cdd_deadline'][$date_key];
            $itemnumber= !empty($_POST['fb_cdd_itemnumber'][$date_key])? $_POST['fb_cdd_itemnumber'][$date_key]:0;
            $itemnumber= !empty($_POST['fb_cdd_itemnumber'][$date_key])? $_POST['fb_cdd_itemnumber'][$date_key]:0;
            $reference= !empty($_POST['fb_cdd_reference'][$date_key])? $_POST['fb_cdd_reference'][$date_key]:0;
            $event=!empty($_POST['fb_cdd_event'][$date_key])? $_POST['fb_cdd_event'][$date_key] :0;
            
            if(trim($date_value) !='' || trim($deadline_value)!=''){
                $data['contract_date_deadline'][$date_key]=array(
                                                                "client_id"=>$client_id,
                                                                "contract_id"=>$contract_id,
                                                                "contract_pid"=>$insert_id,
                                                                "Itemno"=>$itemnumber,
                                                                "Item_name"=>0,
                                                                "reference"=>$reference,
                                                                "event"=>$event,
                                                                "deadline_start_date"=>$date_value,
                                                                "deadline_date"=>$deadline_value
                                                            );
            }
        }
    }
    if(!empty($_POST['fb_cl_snumber']) || !empty($_POST['fb_cl_state']) || !empty($_POST['fb_cl_city']) || !empty($_POST['fb_cl_zipcode'])){
        foreach($_POST['fb_cl_snumber'] as $date_key=>$date_value){
            $fb_cl_sd=$_POST['fb_cl_sd'][$date_key];
            $fb_cl_sname= !empty($_POST['fb_cl_sname'][$date_key])? $_POST['fb_cl_sname'][$date_key]:'';
            $fb_cl_stype= !empty($_POST['fb_cl_stype'][$date_key])? $_POST['fb_cl_stype'][$date_key]:'';
            $fb_cl_sunittype= !empty($_POST['fb_cl_sunittype'][$date_key])? $_POST['fb_cl_sunittype'][$date_key]:'';
            $fb_cl_sunit=!empty($_POST['fb_cl_sunit'][$date_key])? $_POST['fb_cl_sunit'][$date_key] :'';
            $fb_cl_city=!empty($_POST['fb_cl_city'][$date_key])? $_POST['fb_cl_city'][$date_key] :'';
            $fb_cl_state=!empty($_POST['fb_cl_state'][$date_key])? $_POST['fb_cl_state'][$date_key] :'';
            $fb_cl_zipcode=!empty($_POST['fb_cl_zipcode'][$date_key])? $_POST['fb_cl_zipcode'][$date_key] :'';
            $fb_cl_location=!empty($_POST['fb_cl_location'][$date_key])? $_POST['fb_cl_location'][$date_key] :'';
    
                $data['contract_property'][$date_key]=array(
                                                                "client_id"=>$client_id,
                                                                "contract_id"=>$contract_id,
                                                                "contract_pid"=>$insert_id,
                                                                "property_street_number"=>$date_value,
                                                                "prooperty_sd"=>$fb_cl_sd,
                                                                "property_street_name"=>$fb_cl_sname,
                                                                "property_st_type"=>$fb_cl_stype,
                                                                "property_unit_type"=>$fb_cl_sunittype,
                                                                "property_unit"=>$fb_cl_sunit,
                                                                "property_location"=>'',
                                                                "property_city"=>$fb_cl_city,
                                                                "property_state"=>$fb_cl_state,
                                                                "property_zipcode"=>$fb_cl_zipcode
                                                            );
            
        }
    }
        if( !empty($_POST['deligence_documents'])){
            $deligence_documents= !empty($_POST['deligence_documents'])? $_POST['deligence_documents']:0;
            $personal_property_covenyance= !empty($_POST['personal_property_covenyance'])?$_POST['personal_property_covenyance']:0;
            $other_inclusion=!empty($_POST['other_inclusion'])? $_POST['other_inclusion'] :0;
            $parking_storage = !empty($_POST['parking_storage'])? $_POST['parking_storage'] :0;
            $exclusion_details = !empty($_POST['exclusion_details'])? $_POST['exclusion_details'] :0;
            $deeded_water_rights_details = !empty($_POST['deeded_water_rights_details']) ? $_POST['deeded_water_rights_details'] :0;
            $other_water_rights_details= !empty($_POST['other_water_rights_details']) ? $_POST['other_water_rights_details'] :0;
            $well_rights_details=!empty($_POST['well_rights_details']) ? $_POST['well_rights_details'] :0;
            $water_stock_certificate_details=!empty($_POST['water_stock_certificate_details']) ? $_POST['water_stock_certificate_details'] :0;
            $conveyance_details=!empty($_POST['conveyance_details']) ? $_POST['conveyance_details'] :0;
            $data['contract_inclusion']=array(
                "client_id"=>$client_id,
                "contract_id"=>$contract_id,
                "contract_pid"=>$insert_id,
                "diligence_documents"=>$deligence_documents,
                "personal_property_convoyance"=>$personal_property_covenyance,
                "others_inclusion"=>$other_inclusion,
                "parking_storage"=>$parking_storage,
                "exclusion"=>$exclusion_details,
                "deed_water_right"=>$deeded_water_rights_details,
                "other_water_right"=>$other_water_rights_details,
                "well_right"=>$well_rights_details,
                "water_stock_certificate"=>$water_stock_certificate_details,
                "conveyance"=>$conveyance_details,
    );
        }
    //     echo "POSTED DATA=================<pre>";
    // print_r($_POST);
    // echo "</pre>Created DATA=================<pre>";
    // print_r($data); 
            //similar_text("", "", $sim);
            $submitted = $this->client_model->updateagreement($data);
            //exit;
            if($insert_id){
                echo json_encode(array('id'=>$insert_id,'msg','Agreement updated successfully.'));
            }else{
                echo json_encode(array('error'=>'Something went wrong.'));
            }
        }
    }
}

    public function viewagreements() {

        if (!$this->ion_auth->logged_in()):
            // redirect them to the login page
            redirect(base_url());
        endif;

        //Get client data
        $client_id = $this->uri->segment(3);
        $clients = $this->client_model->get_client($client_id);
        //Get agent data
        $agent = $this->client_model->get_agent_client($this->session->userdata('user_id'));
        $filter_data=array('search_string'=>'');
		$where_clause=[];
		if(isset($_POST['search_string']) || !empty($this->uri->segment(4)))
		{
			if(isset($_POST['search_string']))
			{
				$filter_data['search_string']=$_POST['search_string'];
				$this->session->set_userdata('search_string',$filter_data);	
			}
			if($this->session->userdata('search_string'))
			{
				$filter_data['search_string']=$this->session->userdata('search_string')['search_string'];
			}
			
		}
		else
		{
			$this->session->set_userdata('search_string',$filter_data);	
		}
		if(!empty($filter_data['search_string']))
		{
				$where_clause=$filter_data['search_string'];		
		}
        $user_id =$this->session->userdata("user_id");
        
 		$config = array();
        $config["base_url"] = base_url() . "Agreement/viewagreements/".$this->uri->segment(3);
        $total_row =  $this->client_model->count_contracts($where_clause);
        $config["total_rows"] = $total_row; 
        $config["per_page"] = 10;
        $config['use_page_numbers'] = TRUE;
        $config['num_links'] = 10;
        $config['cur_tag_open'] = '&nbsp;<a class="current">';
        $config['cur_tag_close'] = '</a>';
        $config['next_link'] = 'Next';
        $config['prev_link'] = 'Previous';
        $config["uri_segment"] = 4;
    
        $this->pagination->initialize($config);
        if($this->uri->segment(4))
        {
            $offset = ($this->uri->segment(4));
        }
        else
        {
            $offset = 1;
        }				

       
        // Get new agreements from Admin
        $agreement = $this->client_model->get_contracts($where_clause,$config["per_page"], ($offset-1)*$config["per_page"]);

        $data = array(
            'session' => $_SESSION,
            'v' => "viewagreements.twig",
            'agent' => $agent,
            'agreement' => $agreement,
            'client' => $clients
        );
        $data["pagination"] =$this->pagination->create_links();
       
        $this->framework->init($data, false);
    }
    
    public function get_formjson(){
        $row_data=$this->Admin_login->view_contract($this->input->post('contractid'));
        //header('Content-Type: application/json');
            if(!empty($row_data)){
                echo $row_data->contract_file; exit;
            }
        
        }
    public function simple() {

        if (!$this->ion_auth->logged_in()):
            // redirect them to the login page
            redirect(base_url());
        endif;

        //Get client data
        $client_id = $this->uri->segment(3);
        $clients = $this->client_model->get_client($client_id);
        //Get agent data
        $agent = $this->client_model->get_agent_client($this->session->userdata('user_id'));

        $id = $this->uri->segment(4); 

    
        $data = array(
            'session' => $_SESSION,
            'v' => "simpleagreement.twig",
            'agent' => $agent,
            'agreement_id' => $id,
            'client' => $clients,
            'agreement_pdf'=>''
        );

            if(!empty($id)){
                $data['agreement'] =  $this->client_model->get_client_agreement($id);
                if(!empty($data['agreement'][0]->pdf_name)){
                    $data['agreement_pdf']= "/assets/contract_pdf/".$data['agreement'][0]->pdf_name;
                }
                $data['agreement_form'] = $this->Admin_login->get_contract_file_version($data['agreement'][0]->contract_id);

                $data['agreement_list'] =  $this->client_model->get_agreement_list($id);
                if(!empty($data['agreement_list'])){
                  $data['agreement_list'] =  $data['agreement_list'];
                }
                
                $data['agreement_parties'] =  $this->client_model->get_agreement_parties($id);
                $data['agreement_seller'] =  $this->client_model->get_agreement_seller($id);
                if(!empty($data['agreement_seller'])){
                  $data['agreement_seller'] =  $data['agreement_seller'];
                }
                $data['agreement_companies'] =  $this->client_model->get_agreement_companies($id);
                if(!empty($data['agreement_companies'])){
                  $data['agreement_companies'] =  $data['agreement_companies'];
                }
                $data['agreement_deadline'] =  $this->client_model->get_agreement_deadline($id);
                $data['agreement_inclusion'] =  $this->client_model->get_agreement_inclusion($id);
                if(!empty($data['agreement_inclusion'])){
                  $data['agreement_inclusion'] =  $data['agreement_inclusion'];
                }
                $data["recipient"] =$this->Message_model->get_contract_recipient($id);

                $clause_data = array("user_id"=>$this->session->userdata('user_id'),"client_id"=>$clients->client_id,"contract_id"=>$data['agreement'][0]->contract_id);
                $agreement_flow = $this->agent_model->get_agreement_flow($clause_data);
                $agreement_flow_val = "";
                if($agreement_flow){
                    $agreement_flow_val = $agreement_flow->agreement_flow;
                }
                $data['agreement_flow'] =  $agreement_flow_val;
              }
            //   if(empty($this->client_model->check_agreement_info($id))){
            //     $data["agreement"] = "";
            // }
        $this->framework->init($data, false);
    }

    public function simple2() {

        if (!$this->ion_auth->logged_in()):
            // redirect them to the login page
            redirect(base_url());
        endif;

        //Get client data
        $client_id = $this->uri->segment(3);
        $clients = $this->client_model->get_client($client_id);
        //Get agent data
        $agent = $this->client_model->get_agent_client($this->session->userdata('user_id'));

        $id = $this->uri->segment(4); 
        $data = array(
            'session' => $_SESSION,
            'v' => "simpleagreement2.twig",
            'agent' => $agent,
            'agreement_id' => $id,
            'client' => $clients,
            'agreement_pdf'=>''
        );

            if(!empty($id)){
                $data['agreement'] =  $this->client_model->get_client_agreement($id);
                if(!empty($data['agreement'][0]->pdf_name)){
                    $data['agreement_pdf']= "/assets/contract_pdf/".$data['agreement'][0]->pdf_name;
                }
                $data['agreement_form'] = $this->Admin_login->get_contract_file_version($data['agreement'][0]->contract_id);

                $data['agreement_list'] =  $this->client_model->get_agreement_list($id);
                if(!empty($data['agreement_list'])){
                  $data['agreement_list'] =  $data['agreement_list'];
                }
                
                $data['agreement_parties'] =  $this->client_model->get_agreement_parties($id);
                $data['agreement_seller'] =  $this->client_model->get_agreement_seller($id);
                if(!empty($data['agreement_seller'])){
                  $data['agreement_seller'] =  $data['agreement_seller'];
                }
                $data['agreement_companies'] =  $this->client_model->get_agreement_companies($id);
                if(!empty($data['agreement_companies'])){
                  $data['agreement_companies'] =  $data['agreement_companies'];
                }
                $data['agreement_deadline'] =  $this->client_model->get_agreement_deadline($id);
                $data['agreement_inclusion'] =  $this->client_model->get_agreement_inclusion($id);
                if(!empty($data['agreement_inclusion'])){
                  $data['agreement_inclusion'] =  $data['agreement_inclusion'];
                }
                $data["recipient"] =$this->Message_model->get_contract_recipient($id);
              }
            //   if(empty($this->client_model->check_agreement_info($id))){
            //     $data["agreement"] = "";
            // }

        $this->framework->init($data, false);
    }

    public function simple3() {

        if (!$this->ion_auth->logged_in()):
            // redirect them to the login page
            redirect(base_url());
        endif;

        //Get client data
        $client_id = $this->uri->segment(3);
        $clients = $this->client_model->get_client($client_id);
        //Get agent data
        $agent = $this->client_model->get_agent_client($this->session->userdata('user_id'));

        $id = $this->uri->segment(4); 
        $data = array(
            'session' => $_SESSION,
            'v' => "simpleagreement3.twig",
            'agent' => $agent,
            'agreement_id' => $id,
            'client' => $clients,
            'agreement_pdf'=>''
        );

            if(!empty($id)){
                $data['agreement'] =  $this->client_model->get_client_agreement($id);
                if(!empty($data['agreement'][0]->pdf_name)){
                    $data['agreement_pdf']= "/assets/contract_pdf/".$data['agreement'][0]->pdf_name;
                }
                if($data['agreement'][0]->type == "buy"){
                    $data['buyer_compensation']= $this->client_model->get_contract_attach_detail("buyer_compensation",array("contract_pid"=>$id));
                }
                if($data['agreement'][0]->type == "sell"){
                    $data['sell_compensation']= $this->client_model->get_contract_attach_detail("sell_compensation",array("contract_pid"=>$id));
                    $data['sell_price_term']= $this->client_model->get_contract_attach_detail("sell_price_term",array("contract_pid"=>$id));
                }
                if($data['agreement'][0]->type == "tenant"){
                    $data['tenant_compensation']= $this->client_model->get_contract_attach_detail("sell_compensation",array("contract_pid"=>$id));
                }
                if($data['agreement'][0]->type == "lease"){
                    $data['lease_compensation']= $this->client_model->get_contract_attach_detail("sell_compensation",array("contract_pid"=>$id));
                }
                $data['agreement_form'] = $this->Admin_login->get_contract_file_version($data['agreement'][0]->contract_id);

                $data['agreement_list'] =  $this->client_model->get_agreement_list($id);
                if(!empty($data['agreement_list'])){
                  $data['agreement_list'] =  $data['agreement_list'];
                }
                
                $data['agreement_parties'] =  $this->client_model->get_agreement_parties($id);
                $data['agreement_seller'] =  $this->client_model->get_agreement_seller($id);
                if(!empty($data['agreement_seller'])){
                  $data['agreement_seller'] =  $data['agreement_seller'];
                }
                $data['agreement_companies'] =  $this->client_model->get_agreement_companies($id);
                if(!empty($data['agreement_companies'])){
                  $data['agreement_companies'] =  $data['agreement_companies'];
                }
                $data['agreement_deadline'] =  $this->client_model->get_agreement_deadline($id);
                $data['agreement_inclusion'] =  $this->client_model->get_agreement_inclusion($id);
                if(!empty($data['agreement_inclusion'])){
                  $data['agreement_inclusion'] =  $data['agreement_inclusion'];
                }
                $data["recipient"] =$this->Message_model->get_contract_recipient($id);
              }
            //   if(empty($this->client_model->check_agreement_info($id))){
            //     $data["agreement"] = "";
            // }

        $this->framework->init($data, false);
    }
    /**---save batch agreement data----**/
    public function saveagreement(){
        $data=[];
        
        if(!empty($_POST)){
            
            $client_id      =   $_POST['client_id'];
            $contract_id    =   $_POST['contract_id'];
            $contract_type    =  isset($_POST['contract_type']) ? $_POST['contract_type']:"" ;
            $contract_file =  $_POST['contract_file'];
            $xml_file = $this->print_r_xml($_POST);
            $contract_date = isset($_POST['contract_date']) ? $_POST['contract_date']:"0000-00-00";
            $additional_provisions = isset($_POST['additional_provisions']) ? (is_array($_POST['additional_provisions']) ? json_encode($_POST['additional_provisions']) : $_POST['additional_provisions']):"";
            $attachments =isset($_POST['attachments']) ? (is_array($_POST['attachments']) ? json_encode($_POST['attachments']) : $_POST['attachments']):"";
            $not_attachments_part =isset($_POST['not_attachments_part']) ? (is_array($_POST['not_attachments_part']) ? json_encode($_POST['not_attachments_part']) : $_POST['not_attachments_part']):"";
            $electronic_deliver =isset($_POST['electronic_deliver']) ? (is_array($_POST['electronic_deliver']) ? json_encode($_POST['electronic_deliver']) : $_POST['electronic_deliver']):"";
            $listing_period_start =isset($_POST['listing_period_start']) ? (is_array($_POST['listing_period_start']) ? json_encode($_POST['listing_period_start']) : $_POST['listing_period_start']):"";
            $listing_period_end =isset($_POST['listing_period_end']) ? (is_array($_POST['listing_period_end']) ? json_encode($_POST['listing_period_end']) : $_POST['listing_period_end']):"";
            $authorize_broker_negotiation =isset($_POST['authorize_broker_negotiation']) ? (is_array($_POST['authorize_broker_negotiation']) ? json_encode($_POST['authorize_broker_negotiation']) : $_POST['authorize_broker_negotiation']):"";
            $computation_deadline_period =isset($_POST['computation_deadline_period']) ? (is_array($_POST['computation_deadline_period']) ? json_encode($_POST['computation_deadline_period']) : $_POST['computation_deadline_period']):"";
            $agency_unless_brokerage_relationship =isset($_POST['agency_unless_brokerage_relationship']) ? (is_array($_POST['agency_unless_brokerage_relationship']) ? json_encode($_POST['agency_unless_brokerage_relationship']) : $_POST['agency_unless_brokerage_relationship']):"";
            $obligations_to_broker_diclosurers =isset($_POST['obligations_to_broker_diclosurers']) ? (is_array($_POST['obligations_to_broker_diclosurers']) ? json_encode($_POST['obligations_to_broker_diclosurers']) : $_POST['obligations_to_broker_diclosurers']):"";
            $holdover_period_days =isset($_POST['holdover_period_days']) ? (is_array($_POST['holdover_period_days']) ? json_encode($_POST['holdover_period_days']) : $_POST['holdover_period_days']):"";
            $holdover_period_check =isset($_POST['holdover_period_check']) ? (is_array($_POST['holdover_period_check']) ? json_encode($_POST['holdover_period_check']) :$_POST['holdover_period_check']):"";
            $agency_or_transaction_brokerage =isset($_POST['agency_or_transaction_brokerage']) ? (is_array($_POST['agency_or_transaction_brokerage']) ? json_encode($_POST['agency_or_transaction_brokerage']) : $_POST['agency_or_transaction_brokerage']):"";
            $broker_and_brokerage_firm =isset($_POST['broker_and_brokerage_firm']) ? (is_array($_POST['broker_and_brokerage_firm']) ? json_encode($_POST['broker_and_brokerage_firm']) : $_POST['broker_and_brokerage_firm']):"";
            $party_detail = isset($_POST['party_detail']) ? (is_array($_POST['party_detail']) ? json_encode($_POST['party_detail']) : $_POST['party_detail']) :'';
            $party_seller_detail = isset($_POST['party_seller_detail']) ? (is_array($_POST['party_seller_detail']) ? json_encode($_POST['party_seller_detail']) : $_POST['party_seller_detail']) :'';            
            $broker_detail = isset($_POST['broker_detail']) ? (is_array($_POST['broker_detail']) ? json_encode($_POST['broker_detail']) : $_POST['broker_detail']) :'';
            $brokerage_firm_detail = isset($_POST['brokerage_firm_detail']) ? (is_array($_POST['brokerage_firm_detail']) ? json_encode($_POST['brokerage_firm_detail']) : $_POST['brokerage_firm_detail']) :'';
            $possesion = isset($_POST['possesion']) ? (is_array($_POST['possesion']) ? json_encode($_POST['possesion']) : $_POST['possesion']) :'';
            if( !empty($_POST['contract_id'])){
                $data['contract_rel']=array(
                                           "client_id"=>$client_id,
                                           "contract_id"=>$contract_id,
                                           "user_id"=>$this->session->userdata('user_id'),
                                           "contract_file"=>$contract_file,
                                           "contract_date"=>$contract_date,
                                           "xml_file"=>$xml_file,
                                           "type"=>$contract_type,
                                           "additional_provisions" =>$additional_provisions,
                                           "attachments" => $attachments,
                                           "not_attachments_part" => $not_attachments_part,
                                           "electronic_deliver" =>$electronic_deliver,
                                           "listing_period_start" =>$listing_period_start,
                                           "listing_period_end" =>$listing_period_end,
                                           "authorize_broker_negotiation" => $authorize_broker_negotiation,
                                           "computation_deadline_period" => $computation_deadline_period,
                                           "agency_unless_brokerage_relationship" =>$agency_unless_brokerage_relationship,
                                           "obligations_to_broker_diclosurers" =>$obligations_to_broker_diclosurers,
                                           "holdover_period_days" =>$holdover_period_days,
                                           "holdover_period_check" => $holdover_period_check,
                                           "agency_or_transaction_brokerage" => $agency_or_transaction_brokerage,
                                           "broker_and_brokerage_firm" =>$broker_and_brokerage_firm,
                                           "party_detail"=>$party_detail,
                                           "party_seller_detail"=>$party_seller_detail,
                                           "broker_detail"=>$broker_detail,
                                            "brokerage_firm_detail"=>$brokerage_firm_detail,
                                            "possesion"=>$possesion
                                           );
                                           $insert_id = $this->client_model->saveagreement_rel($data);
                                       }
                                      
                if($contract_type == "buy" || $contract_type == "Buy"){
    $brokerage_firm_fees_check = isset($_POST['brokerage_firm_fees_check']) ? (is_array($_POST['brokerage_firm_fees_check']) ? json_encode($_POST['brokerage_firm_fees_check']) : $_POST['brokerage_firm_fees_check']):"";
    $fees_percentage_price = isset($_POST['fees_percentage_price']) ? (is_array($_POST['fees_percentage_price']) ? json_encode($_POST['fees_percentage_price']) : $_POST['fees_percentage_price']):"";
    $fees_us_dollar =isset($_POST['fees_us_dollar']) ? (is_array($_POST['fees_us_dollar']) ? json_encode($_POST['fees_us_dollar']) : $_POST['fees_us_dollar']):"";
    $adjusted_amount =isset($_POST['adjusted_amount']) ? (is_array($_POST['adjusted_amount']) ? json_encode($_POST['adjusted_amount']) : $_POST['adjusted_amount']):"";
    $adjusted_amount_other =isset($_POST['adjusted_amount_other']) ? (is_array($_POST['adjusted_amount_other']) ? json_encode($_POST['adjusted_amount_other']) : $_POST['adjusted_amount_other']):"";
    $adjusted_amount_other_chk =isset($_POST['adjusted_amount_other_chk']) ? (is_array($_POST['adjusted_amount_other_chk']) ? json_encode($_POST['adjusted_amount_other_chk']) : $_POST['adjusted_amount_other_chk']):"";
    $hourly_fee_check =isset($_POST['hourly_fee_check']) ? (is_array($_POST['hourly_fee_check']) ? json_encode($_POST['hourly_fee_check']) : $_POST['hourly_fee_check']):"";
    $hourly_fee_per_hour =isset($_POST['hourly_fee_per_hour']) ? (is_array($_POST['hourly_fee_per_hour']) ? json_encode($_POST['hourly_fee_per_hour']) : $_POST['hourly_fee_per_hour']):"";
    $hourly_fee_maximum_total =isset($_POST['hourly_fee_maximum_total']) ? (is_array($_POST['hourly_fee_maximum_total']) ? json_encode($_POST['hourly_fee_maximum_total']) : $_POST['hourly_fee_maximum_total']):"";
    $retainer_fee_check =isset($_POST['retainer_fee_check']) ? (is_array($_POST['retainer_fee_check']) ? json_encode($_POST['retainer_fee_check']) : $_POST['retainer_fee_check']):"";
    $retainer_fee_due =isset($_POST['retainer_fee_due']) ? (is_array($_POST['retainer_fee_due']) ? json_encode($_POST['retainer_fee_due']) : $_POST['retainer_fee_due']):"";
    $retainer_fee_will_check =isset($_POST['retainer_fee_will_check']) ? (is_array($_POST['retainer_fee_will_check']) ? json_encode($_POST['retainer_fee_will_check']) : $_POST['retainer_fee_will_check']):"";
    $other_compensation_check =isset($_POST['other_compensation_check']) ? (is_array($_POST['other_compensation_check']) ? json_encode($_POST['other_compensation_check']) : $_POST['other_compensation_check']):"";
    $other_compensation =isset($_POST['other_compensation']) ? (is_array($_POST['other_compensation']) ? json_encode($_POST['other_compensation']) : $_POST['other_compensation']):"";
    $firm_fee_lease_amt =isset($_POST['firm_fee_lease_amt']) ? (is_array($_POST['firm_fee_lease_amt']) ? json_encode($_POST['firm_fee_lease_amt']) : $_POST['firm_fee_lease_amt']):"";
            
    
    $firm_fee_lease_amt_per =isset($_POST['firm_fee_lease_amt_per']) ? (is_array($_POST['firm_fee_lease_amt_per']) ? json_encode($_POST['firm_fee_lease_amt_per']) : $_POST['firm_fee_lease_amt_per']):"";
    $firm_fee_lease_amt_or =isset($_POST['firm_fee_lease_amt_or']) ? (is_array($_POST['firm_fee_lease_amt_or']) ? json_encode($_POST['firm_fee_lease_amt_or']) : $_POST['firm_fee_lease_amt_or']):"";
    $firm_fee_lease_adj_amt_check =isset($_POST['firm_fee_lease_adj_amt_check']) ? (is_array($_POST['firm_fee_lease_adj_amt_check']) ? json_encode($_POST['firm_fee_lease_adj_amt_check']) : $_POST['firm_fee_lease_adj_amt_check']):"";
    $firm_fee_lease_adj_amt_other =isset($_POST['firm_fee_lease_adj_amt_other']) ? (is_array($_POST['firm_fee_lease_adj_amt_other']) ? json_encode($_POST['firm_fee_lease_adj_amt_other']) : $_POST['firm_fee_lease_adj_amt_other']):"";
    $firm_fee_lease_adj_amt_other_chk =isset($_POST['firm_fee_lease_adj_amt_other_chk']) ? (is_array($_POST['firm_fee_lease_adj_amt_other_chk']) ? json_encode($_POST['firm_fee_lease_adj_amt_other_chk']) : $_POST['firm_fee_lease_adj_amt_other_chk']):"";
    $firm_fee_lease_adj_amt_other1 =isset($_POST['firm_fee_lease_adj_amt_other1']) ? (is_array($_POST['firm_fee_lease_adj_amt_other1']) ? json_encode($_POST['firm_fee_lease_adj_amt_other1']) : $_POST['firm_fee_lease_adj_amt_other1']):"";
    $when_earned_when_payable_lease_txt =isset($_POST['when_earned_when_payable_lease_txt']) ? (is_array($_POST['when_earned_when_payable_lease_txt']) ? json_encode($_POST['when_earned_when_payable_lease_txt']) : $_POST['when_earned_when_payable_lease_txt']):"";
    $when_earned_when_payable_lease_chk =isset($_POST['when_earned_when_payable_lease_chk']) ? (is_array($_POST['when_earned_when_payable_lease_chk']) ? json_encode($_POST['when_earned_when_payable_lease_chk']) : $_POST['when_earned_when_payable_lease_chk']):"";
    
    $when_earned_when_payable_lease_txt1 =isset($_POST['when_earned_when_payable_lease_txt1']) ? (is_array($_POST['when_earned_when_payable_lease_txt1']) ? json_encode($_POST['when_earned_when_payable_lease_txt1']) : $_POST['when_earned_when_payable_lease_txt1']):"";
    $who_will_pay_firm_fee =isset($_POST['who_will_pay_firm_fee']) ? (is_array($_POST['who_will_pay_firm_fee']) ? json_encode($_POST['who_will_pay_firm_fee']) : $_POST['who_will_pay_firm_fee']):"";


                    $data['buyer_compensation']=array(
                        "client_id"=>$client_id,
                        "contract_id"=>$contract_id,
                        "contract_pid"=>$insert_id,
                        "brokerage_firm_fees_check"=>$brokerage_firm_fees_check,
                        "fees_percentage_price"=>$fees_percentage_price,
                        "fees_us_dollar"=>$fees_us_dollar,
                        "adjusted_amount" =>$adjusted_amount,
                        "adjusted_amount_other" => $adjusted_amount_other,
                        "hourly_fee_check" =>$hourly_fee_check,
                        "hourly_fee_per_hour" =>$hourly_fee_per_hour,
                        "hourly_fee_maximum_total" =>$hourly_fee_maximum_total,
                        "retainer_fee_check" => $retainer_fee_check,
                        "retainer_fee_due" => $computation_deadline_period,
                        "retainer_fee_will_check" =>$agency_unless_brokerage_relationship,
                        "other_compensation_check" =>$other_compensation_check,
                        "other_compensation" =>$other_compensation,
                        "firm_fee_lease_amt" => $firm_fee_lease_amt,
                        "firm_fee_lease_amt_or" => $firm_fee_lease_amt_or,
                        "firm_fee_lease_amt_per" =>$firm_fee_lease_amt_per,

                        "firm_fee_lease_adj_amt_check" =>$firm_fee_lease_adj_amt_check,
                        "firm_fee_lease_adj_amt_other" =>$firm_fee_lease_adj_amt_other,
                        "firm_fee_lease_adj_amt_other1" => $firm_fee_lease_adj_amt_other1,
                        "when_earned_when_payable_lease_txt" => $when_earned_when_payable_lease_txt,
                        "when_earned_when_payable_lease_chk" =>$when_earned_when_payable_lease_chk,
                        "when_earned_when_payable_lease_txt1" => $when_earned_when_payable_lease_txt1,
                        "who_will_pay_firm_fee" =>$who_will_pay_firm_fee
                        );
            }
            if($contract_type == "sell" || $contract_type == "Sell"){
                $lease_commision_percentage_gross = isset($_POST['lease_commision_percentage_gross']) ? (is_array($_POST['lease_commision_percentage_gross']) ? json_encode($_POST['lease_commision_percentage_gross']) : $_POST['lease_commision_percentage_gross']):"";
                $lease_commision_dollar = isset($_POST['lease_commision_dollar']) ? (is_array($_POST['lease_commision_dollar']) ? json_encode($_POST['lease_commision_dollar']) : $_POST['lease_commision_dollar']):"";
                $lease_commision_payable = isset($_POST['lease_commision_payable']) ? (is_array($_POST['lease_commision_payable']) ? json_encode($_POST['lease_commision_payable']) : $_POST['lease_commision_payable']):"";
                $sales_commision_percentage_gross =isset($_POST['sales_commision_percentage_gross']) ? (is_array($_POST['sales_commision_percentage_gross']) ? json_encode($_POST['sales_commision_percentage_gross']) : $_POST['sales_commision_percentage_gross']):"";
                $sales_commision_dollar =isset($_POST['sales_commision_dollar']) ? (is_array($_POST['sales_commision_dollar']) ? json_encode($_POST['sales_commision_dollar']) : $_POST['sales_commision_dollar']):"";
                $tenant_agent_percentage_gross =isset($_POST['tenant_agent_percentage_gross']) ? (is_array($_POST['tenant_agent_percentage_gross']) ? json_encode($_POST['tenant_agent_percentage_gross']) : $_POST['tenant_agent_percentage_gross']):"";
                $tenant_agent_dollar =isset($_POST['tenant_agent_dollar']) ? (is_array($_POST['tenant_agent_dollar']) ? json_encode($_POST['tenant_agent_dollar']) : $_POST['tenant_agent_dollar']):"";
                $transaction_broker_gross =isset($_POST['transaction_broker_gross']) ? (is_array($_POST['transaction_broker_gross']) ? json_encode($_POST['transaction_broker_gross']) : $_POST['transaction_broker_gross']):"";
                $transaction_dollar =isset($_POST['transaction_dollar']) ? (is_array($_POST['transaction_dollar']) ? json_encode($_POST['transaction_dollar']) : $_POST['transaction_dollar']):"";
                $fee_for_expansion_renewal_chk =isset($_POST['fee_for_expansion_renewal_chk']) ? (is_array($_POST['fee_for_expansion_renewal_chk']) ? json_encode($_POST['fee_for_expansion_renewal_chk']) : $_POST['fee_for_expansion_renewal_chk']):"";
                $fee_for_expansion_renewal_chk1 =isset($_POST['fee_for_expansion_renewal_chk1']) ? (is_array($_POST['fee_for_expansion_renewal_chk1']) ? json_encode($_POST['fee_for_expansion_renewal_chk1']) : $_POST['fee_for_expansion_renewal_chk1']):"";
                $fee_for_expansion_renewal_chk2 =isset($_POST['fee_for_expansion_renewal_chk2']) ? (is_array($_POST['fee_for_expansion_renewal_chk2']) ? json_encode($_POST['fee_for_expansion_renewal_chk2']) : $_POST['fee_for_expansion_renewal_chk2']):"";
                $fee_for_expansion_renewal =isset($_POST['fee_for_expansion_renewal']) ? (is_array($_POST['fee_for_expansion_renewal']) ? json_encode($_POST['fee_for_expansion_renewal']) : $_POST['fee_for_expansion_renewal']):"";
                $fee_for_expansion_renewal_chk3 =isset($_POST['fee_for_expansion_renewal_chk3']) ? (is_array($_POST['fee_for_expansion_renewal_chk3']) ? json_encode($_POST['fee_for_expansion_renewal_chk3']) : $_POST['fee_for_expansion_renewal_chk3']):"";
                $fee_for_expansion_renewal_chk4 =isset($_POST['fee_for_expansion_renewal_chk4']) ? (is_array($_POST['fee_for_expansion_renewal_chk4']) ? json_encode($_POST['fee_for_expansion_renewal_chk4']) : $_POST['fee_for_expansion_renewal_chk4']):"";
                        
                
                $fee_for_expansion_renewal_chk5 =isset($_POST['fee_for_expansion_renewal_chk5']) ? (is_array($_POST['fee_for_expansion_renewal_chk5']) ? json_encode($_POST['fee_for_expansion_renewal_chk5']) : $_POST['fee_for_expansion_renewal_chk5']):"";
                $fee_for_expansion_renewal1 =isset($_POST['fee_for_expansion_renewal1']) ? (is_array($_POST['fee_for_expansion_renewal1']) ? json_encode($_POST['fee_for_expansion_renewal1']) : $_POST['fee_for_expansion_renewal1']):"";
                $other_compensation =isset($_POST['other_compensation']) ? (is_array($_POST['other_compensation']) ? json_encode($_POST['other_compensation']) : $_POST['other_compensation']):"";
                $when_earned_when_payable_lease_txt =isset($_POST['when_earned_when_payable_lease_txt']) ? (is_array($_POST['when_earned_when_payable_lease_txt']) ? json_encode($_POST['when_earned_when_payable_lease_txt']) : $_POST['when_earned_when_payable_lease_txt']):"";
                $when_applicable_payable =isset($_POST['when_applicable_payable']) ? (is_array($_POST['when_applicable_payable']) ? json_encode($_POST['when_applicable_payable']) : $_POST['when_applicable_payable']):"";
            
            
                                $data['sell_compensation']=array(
                                    "client_id"=>$client_id,
                                    "contract_id"=>$contract_id,
                                    "contract_pid"=>$insert_id,
                                    "lease_commision_percentage_gross"=>$lease_commision_percentage_gross,
                                    "lease_commision_dollar"=>$lease_commision_dollar,
                                    "lease_commision_payable"=>$lease_commision_payable,
                                    "sales_commision_percentage_gross"=>$sales_commision_percentage_gross,
                                    "sales_commision_dollar" =>$sales_commision_dollar,
                                    "tenant_agent_percentage_gross" => $tenant_agent_percentage_gross,
                                    "tenant_agent_dollar" =>$tenant_agent_dollar,
                                    "transaction_broker_gross" =>$transaction_broker_gross,
                                    "transaction_dollar" =>$transaction_dollar,
                                    "fee_for_expansion_renewal_chk" => $fee_for_expansion_renewal_chk,
                                    "fee_for_expansion_renewal_chk1" => $fee_for_expansion_renewal_chk1,
                                    "fee_for_expansion_renewal_chk2" =>$fee_for_expansion_renewal_chk2,
                                    "fee_for_expansion_renewal" =>$fee_for_expansion_renewal,
                                    "fee_for_expansion_renewal_chk3" =>$fee_for_expansion_renewal_chk3,
                                    "fee_for_expansion_renewal_chk4" => $fee_for_expansion_renewal_chk4,
                                    "fee_for_expansion_renewal_chk5" => $fee_for_expansion_renewal_chk5,
                                    "fee_for_expansion_renewal1" =>$fee_for_expansion_renewal1,
            
                                    "other_compensation" =>$other_compensation,
                                    "when_earned_when_payable_lease_txt" =>$when_earned_when_payable_lease_txt,
                                    "when_applicable_payable" => $when_applicable_payable,
                                    

                                    );
            
            }
            if($contract_type == "tenant" || $contract_type == "Tenant"){
                $firm_fees_check = isset($_POST['firm_fees_check']) ? (is_array($_POST['firm_fees_check']) ? json_encode($_POST['firm_fees_check']) : $_POST['firm_fees_check']):"";
                $fees_percentage_price = isset($_POST['fees_percentage_price']) ? (is_array($_POST['fees_percentage_price']) ? json_encode($_POST['fees_percentage_price']) : $_POST['fees_percentage_price']):"";
                $fees_us_dollar =isset($_POST['fees_us_dollar']) ? (is_array($_POST['fees_us_dollar']) ? json_encode($_POST['fees_us_dollar']) : $_POST['fees_us_dollar']):"";
                $hourly_fee_check =isset($_POST['hourly_fee_check']) ? (is_array($_POST['hourly_fee_check']) ? json_encode($_POST['hourly_fee_check']) : $_POST['hourly_fee_check']):"";
                $hourly_fee_maximum_total =isset($_POST['hourly_fee_maximum_total']) ? (is_array($_POST['hourly_fee_maximum_total']) ? json_encode($_POST['hourly_fee_maximum_total']) : $_POST['hourly_fee_maximum_total']):"";
                $retainer_fee_check =isset($_POST['retainer_fee_check']) ? (is_array($_POST['retainer_fee_check']) ? json_encode($_POST['retainer_fee_check']) : $_POST['retainer_fee_check']):"";
                $retainer_fee_due =isset($_POST['retainer_fee_due']) ? (is_array($_POST['retainer_fee_due']) ? json_encode($_POST['retainer_fee_due']) : $_POST['retainer_fee_due']):"";
                $retainer_fee_will_check =isset($_POST['retainer_fee_will_check']) ? (is_array($_POST['retainer_fee_will_check']) ? json_encode($_POST['retainer_fee_will_check']) : $_POST['retainer_fee_will_check']):"";
                $fee_for_expansion_renewal_chk =isset($_POST['fee_for_expansion_renewal_chk']) ? (is_array($_POST['fee_for_expansion_renewal_chk']) ? json_encode($_POST['fee_for_expansion_renewal_chk']) : $_POST['fee_for_expansion_renewal_chk']):"";
                $fee_for_expansion_renewal =isset($_POST['fee_for_expansion_renewal']) ? (is_array($_POST['fee_for_expansion_renewal']) ? json_encode($_POST['fee_for_expansion_renewal']) : $_POST['fee_for_expansion_renewal']):"";
                $other_compensation_check =isset($_POST['other_compensation_check']) ? (is_array($_POST['other_compensation_check']) ? json_encode($_POST['other_compensation_check']) : $_POST['other_compensation_check']):"";
                $other_compensation =isset($_POST['other_compensation']) ? (is_array($_POST['other_compensation']) ? json_encode($_POST['other_compensation']) : $_POST['other_compensation']):"";
                $firm_fee_lease_amt =isset($_POST['firm_fee_lease_amt']) ? (is_array($_POST['firm_fee_lease_amt']) ? json_encode($_POST['firm_fee_lease_amt']) : $_POST['firm_fee_lease_amt']):"";
                $firm_fee_lease_amt_per =isset($_POST['firm_fee_lease_amt_per']) ? (is_array($_POST['firm_fee_lease_amt_per']) ? json_encode($_POST['firm_fee_lease_amt_per']) : $_POST['firm_fee_lease_amt_per']):"";
                $firm_fee_lease_amt_or =isset($_POST['firm_fee_lease_amt_or']) ? (is_array($_POST['firm_fee_lease_amt_or']) ? json_encode($_POST['firm_fee_lease_amt_or']) : $_POST['firm_fee_lease_amt_or']):"";
                        
                
                $firm_fee_lease_adj_amt_check =isset($_POST['firm_fee_lease_adj_amt_check']) ? (is_array($_POST['firm_fee_lease_adj_amt_check']) ? json_encode($_POST['firm_fee_lease_adj_amt_check']) : $_POST['firm_fee_lease_adj_amt_check']):"";
                $firm_fee_lease_adj_amt_other =isset($_POST['firm_fee_lease_adj_amt_other']) ? (is_array($_POST['firm_fee_lease_adj_amt_other']) ? json_encode($_POST['firm_fee_lease_adj_amt_other']) : $_POST['firm_fee_lease_adj_amt_other']):"";
                $firm_fee_lease_adj_amt_other1 =isset($_POST['firm_fee_lease_adj_amt_other1']) ? (is_array($_POST['firm_fee_lease_adj_amt_other1']) ? json_encode($_POST['firm_fee_lease_adj_amt_other1']) : $_POST['firm_fee_lease_adj_amt_other1']):"";
                $when_earned_when_payable_lease_txt =isset($_POST['when_earned_when_payable_lease_txt']) ? (is_array($_POST['when_earned_when_payable_lease_txt']) ? json_encode($_POST['when_earned_when_payable_lease_txt']) : $_POST['when_earned_when_payable_lease_txt']):"";
                $who_will_pay_firm_fee =isset($_POST['who_will_pay_firm_fee']) ? (is_array($_POST['who_will_pay_firm_fee']) ? json_encode($_POST['who_will_pay_firm_fee']) : $_POST['who_will_pay_firm_fee']):"";
                $who_will_pay_firm_obligated =isset($_POST['who_will_pay_firm_obligated']) ? (is_array($_POST['who_will_pay_firm_obligated']) ? json_encode($_POST['who_will_pay_firm_obligated']) : $_POST['who_will_pay_firm_obligated']):"";
                $who_will_pay_firm_obligated_not =isset($_POST['who_will_pay_firm_obligated_not']) ? (is_array($_POST['who_will_pay_firm_obligated_not']) ? json_encode($_POST['who_will_pay_firm_obligated_not']) : $_POST['who_will_pay_firm_obligated_not']):"";

            
                                $data['tenant_compensation']=array(
                                    "client_id"=>$client_id,
                                    "contract_id"=>$contract_id,
                                    "contract_pid"=>$insert_id,
                                    "firm_fees_check"=>$firm_fees_check,
                                    "fees_percentage_price"=>$fees_percentage_price,
                                    "fees_us_dollar"=>$fees_us_dollar,
                                    "hourly_fee_check" =>$hourly_fee_check,
                                    "hourly_fee_maximum_total" => $hourly_fee_maximum_total,
                                    "retainer_fee_check" =>$retainer_fee_check,
                                    "retainer_fee_due" =>$retainer_fee_due,
                                    "retainer_fee_will_check" =>$retainer_fee_will_check,
                                    "fee_for_expansion_renewal_chk" => $fee_for_expansion_renewal_chk,
                                    "fee_for_expansion_renewal" => $fee_for_expansion_renewal,
                                    "other_compensation_check" =>$other_compensation_check,
                                    "other_compensation" =>$other_compensation,
                                    "firm_fee_lease_amt" =>$firm_fee_lease_amt,
                                    "firm_fee_lease_amt_per" => $firm_fee_lease_amt_per,
                                    "firm_fee_lease_amt_or" => $firm_fee_lease_amt_or,
                                    "firm_fee_lease_adj_amt_check" =>$firm_fee_lease_adj_amt_check,
            
                                    "firm_fee_lease_adj_amt_other" =>$firm_fee_lease_adj_amt_other,
                                    "firm_fee_lease_adj_amt_other1" =>$firm_fee_lease_adj_amt_other1,
                                    "when_earned_when_payable_lease_txt" => $when_earned_when_payable_lease_txt,

                                    "who_will_pay_firm_fee" =>$who_will_pay_firm_fee,
                                    "who_will_pay_firm_obligated" =>$who_will_pay_firm_obligated,
                                    "who_will_pay_firm_obligated_not" => $who_will_pay_firm_obligated_not

                                    );
            }
            if($contract_type == "lease" || $contract_type == "Lease"){
                $lease_commision_percentage_gross = isset($_POST['lease_commision_percentage_gross']) ? (is_array($_POST['lease_commision_percentage_gross']) ? json_encode($_POST['lease_commision_percentage_gross']) : $_POST['lease_commision_percentage_gross']):"";
                $lease_commision_dollar = isset($_POST['lease_commision_dollar']) ? (is_array($_POST['lease_commision_dollar']) ? json_encode($_POST['lease_commision_dollar']) : $_POST['lease_commision_dollar']):"";
                $sales_commision_percentage_gross =isset($_POST['sales_commision_percentage_gross']) ? (is_array($_POST['sales_commision_percentage_gross']) ? json_encode($_POST['sales_commision_percentage_gross']) : $_POST['sales_commision_percentage_gross']):"";
                $sales_commision_dollar =isset($_POST['sales_commision_dollar']) ? (is_array($_POST['sales_commision_dollar']) ? json_encode($_POST['sales_commision_dollar']) : $_POST['sales_commision_dollar']):"";
                $tenant_agent_percentage_gross =isset($_POST['tenant_agent_percentage_gross']) ? (is_array($_POST['tenant_agent_percentage_gross']) ? json_encode($_POST['tenant_agent_percentage_gross']) : $_POST['tenant_agent_percentage_gross']):"";
                $tenant_agent_dollar =isset($_POST['tenant_agent_dollar']) ? (is_array($_POST['tenant_agent_dollar']) ? json_encode($_POST['tenant_agent_dollar']) : $_POST['tenant_agent_dollar']):"";
                $transaction_broker_gross =isset($_POST['transaction_broker_gross']) ? (is_array($_POST['transaction_broker_gross']) ? json_encode($_POST['transaction_broker_gross']) : $_POST['transaction_broker_gross']):"";
                $transaction_dollar =isset($_POST['transaction_dollar']) ? (is_array($_POST['transaction_dollar']) ? json_encode($_POST['transaction_dollar']) : $_POST['transaction_dollar']):"";
                $fee_for_expansion_renewal =isset($_POST['fee_for_expansion_renewal']) ? (is_array($_POST['fee_for_expansion_renewal']) ? json_encode($_POST['fee_for_expansion_renewal']) : $_POST['fee_for_expansion_renewal']):"";
                $fee_for_expansion_renewal_chk =isset($_POST['fee_for_expansion_renewal_chk']) ? (is_array($_POST['fee_for_expansion_renewal_chk']) ? json_encode($_POST['fee_for_expansion_renewal_chk']) : $_POST['fee_for_expansion_renewal_chk']):"";
                $fee_for_expansion_renewal_chk1 =isset($_POST['fee_for_expansion_renewal_chk1']) ? (is_array($_POST['fee_for_expansion_renewal_chk1']) ? json_encode($_POST['fee_for_expansion_renewal_chk1']) : $_POST['fee_for_expansion_renewal_chk1']):"";
                $fee_for_expansion_renewal_chk2 =isset($_POST['fee_for_expansion_renewal_chk2']) ? (is_array($_POST['fee_for_expansion_renewal_chk2']) ? json_encode($_POST['fee_for_expansion_renewal_chk2']) : $_POST['fee_for_expansion_renewal_chk2']):"";
                $fee_for_expansion_renewal_chk3 =isset($_POST['fee_for_expansion_renewal_chk3']) ? (is_array($_POST['fee_for_expansion_renewal_chk3']) ? json_encode($_POST['fee_for_expansion_renewal_chk3']) : $_POST['fee_for_expansion_renewal_chk3']):"";
                $fee_for_expansion_renewal_chk4 =isset($_POST['fee_for_expansion_renewal_chk4']) ? (is_array($_POST['fee_for_expansion_renewal_chk4']) ? json_encode($_POST['fee_for_expansion_renewal_chk4']) : $_POST['fee_for_expansion_renewal_chk4']):"";
                        
                
                $fee_for_expansion_renewal_chk5 =isset($_POST['fee_for_expansion_renewal_chk5']) ? (is_array($_POST['fee_for_expansion_renewal_chk5']) ? json_encode($_POST['fee_for_expansion_renewal_chk5']) : $_POST['fee_for_expansion_renewal_chk5']):"";
                $fee_for_expansion_renewal1 =isset($_POST['fee_for_expansion_renewal1']) ? (is_array($_POST['fee_for_expansion_renewal1']) ? json_encode($_POST['fee_for_expansion_renewal1']) : $_POST['fee_for_expansion_renewal1']):"";
                $other_compensation =isset($_POST['other_compensation']) ? (is_array($_POST['other_compensation']) ? json_encode($_POST['other_compensation']) : $_POST['other_compensation']):"";
                $when_earned_when_payable_lease_txt =isset($_POST['when_earned_when_payable_lease_txt']) ? (is_array($_POST['when_earned_when_payable_lease_txt']) ? json_encode($_POST['when_earned_when_payable_lease_txt']) : $_POST['when_earned_when_payable_lease_txt']):"";
                $when_applicable_payable =isset($_POST['when_applicable_payable']) ? (is_array($_POST['when_applicable_payable']) ? json_encode($_POST['when_applicable_payable']) : $_POST['when_applicable_payable']):"";
                $tenant_agent_chk =isset($_POST['tenant_agent_chk']) ? (is_array($_POST['tenant_agent_chk']) ? json_encode($_POST['tenant_agent_chk']) : $_POST['tenant_agent_chk']):"";
                $transaction_chk =isset($_POST['transaction_chk']) ? (is_array($_POST['transaction_chk']) ? json_encode($_POST['transaction_chk']) : $_POST['transaction_chk']):"";

            
                                $data['lease_compensation']=array(
                                    "client_id"=>$client_id,
                                    "contract_id"=>$contract_id,
                                    "contract_pid"=>$insert_id,
                                    "lease_commision_percentage_gross"=>$lease_commision_percentage_gross,
                                    "lease_commision_dollar"=>$lease_commision_dollar,
                                    "sales_commision_percentage_gross"=>$sales_commision_percentage_gross,
                                    "sales_commision_dollar" =>$sales_commision_dollar,
                                    "tenant_agent_percentage_gross" => $tenant_agent_percentage_gross,
                                    "tenant_agent_dollar" =>$tenant_agent_dollar,
                                    "tenant_agent_chk" =>$tenant_agent_chk,
                                    "transaction_broker_gross" =>$transaction_broker_gross,
                                    "transaction_dollar" =>$transaction_dollar,
                                    "transaction_chk" =>$transaction_chk,
                                    "fee_for_expansion_renewal" => $fee_for_expansion_renewal,
                                    "fee_for_expansion_renewal_chk" => $fee_for_expansion_renewal_chk,
                                    
                                    "fee_for_expansion_renewal_chk1" =>$fee_for_expansion_renewal_chk1,
                                    "fee_for_expansion_renewal_chk2" =>$fee_for_expansion_renewal_chk2,
                                    "fee_for_expansion_renewal_chk3" =>$fee_for_expansion_renewal_chk3,
                                    "fee_for_expansion_renewal_chk4" => $fee_for_expansion_renewal_chk4,
                                    "fee_for_expansion_renewal_chk5" => $fee_for_expansion_renewal_chk5,
                                    "fee_for_expansion_renewal1" =>$fee_for_expansion_renewal1,
            
                                    "other_compensation" =>$other_compensation,
                                    "when_earned_when_payable_lease_txt" => $when_earned_when_payable_lease_txt,

                                    "when_applicable_payable" =>$when_applicable_payable,
                                    );
            }        
            if($contract_type == "lease" || $contract_type == "Lease" || $contract_type == "sell" || $contract_type == "Sell"){
                $mls_info_check = isset($_POST['mls_info_check']) ? (is_array($_POST['mls_info_check']) ? json_encode($_POST['mls_info_check']) : $_POST['mls_info_check']):"";
                $mls_info_check1 = isset($_POST['mls_info_check1']) ? (is_array($_POST['mls_info_check1']) ? json_encode($_POST['mls_info_check1']) : $_POST['mls_info_check1']):"";
                $mls_marketing_except =isset($_POST['mls_marketing_except']) ? (is_array($_POST['mls_marketing_except']) ? json_encode($_POST['mls_marketing_except']) : $_POST['mls_marketing_except']):"";
                $display_premise_address =isset($_POST['display_premise_address']) ? (is_array($_POST['display_premise_address']) ? json_encode($_POST['display_premise_address']) : $_POST['display_premise_address']):"";
                $property_access_check =isset($_POST['property_access_check']) ? (is_array($_POST['property_access_check']) ? json_encode($_POST['property_access_check']) : $_POST['property_access_check']):"";
                $prooperty_acess =isset($_POST['prooperty_acess']) ? (is_array($_POST['prooperty_acess']) ? json_encode($_POST['prooperty_acess']) : $_POST['prooperty_acess']):"";
                $broker_marketing =isset($_POST['broker_marketing']) ? (is_array($_POST['broker_marketing']) ? json_encode($_POST['broker_marketing']) : $_POST['broker_marketing']):"";
            
                                $data['mls_information']=array(
                                    "client_id"=>$client_id,
                                    "contract_id"=>$contract_id,
                                    "contract_pid"=>$insert_id,
                                    "mls_info_check"=>$mls_info_check,
                                    "mls_info_check1"=>$mls_info_check1,
                                    "mls_marketing_except"=>$mls_marketing_except,
                                    "display_premise_address" =>$display_premise_address,
                                    "property_access_check" => $property_access_check,
                                    "prooperty_acess" =>$prooperty_acess,
                                    "broker_marketing" =>$broker_marketing
                                    );

            }  
            if($contract_type == "sell" || $contract_type == "Sell"){
                $encumbrance = isset($_POST['encumbrance']) ? (is_array($_POST['encumbrance']) ? json_encode($_POST['encumbrance']) : $_POST['encumbrance']):"";
                $encumbrance1 = isset($_POST['encumbrance1']) ? (is_array($_POST['encumbrance1']) ? json_encode($_POST['encumbrance1']) : $_POST['encumbrance1']):"";
                $evidance_of_title_chk =isset($_POST['evidance_of_title_chk']) ? (is_array($_POST['evidance_of_title_chk']) ? json_encode($_POST['evidance_of_title_chk']) : $_POST['evidance_of_title_chk']):"";
                $association_aporx =isset($_POST['association_aporx']) ? (is_array($_POST['association_aporx']) ? json_encode($_POST['association_aporx']) : $_POST['association_aporx']):"";
                $association_aporx_per =isset($_POST['association_aporx_per']) ? (is_array($_POST['association_aporx_per']) ? json_encode($_POST['association_aporx_per']) : $_POST['association_aporx_per']):"";
                $association_aporx_except =isset($_POST['association_aporx_except']) ? (is_array($_POST['association_aporx_except']) ? json_encode($_POST['association_aporx_except']) : $_POST['association_aporx_except']):"";
                $forfeiture_of_chk =isset($_POST['forfeiture_of_chk']) ? (is_array($_POST['forfeiture_of_chk']) ? json_encode($_POST['forfeiture_of_chk']) : $_POST['forfeiture_of_chk']):"";
                $forfeiture_of_txt =isset($_POST['forfeiture_of_txt']) ? (is_array($_POST['forfeiture_of_txt']) ? json_encode($_POST['forfeiture_of_txt']) : $_POST['forfeiture_of_txt']):"";

                                $data['sell_encumbrances']=array(
                                    "client_id"=>$client_id,
                                    "contract_id"=>$contract_id,
                                    "contract_pid"=>$insert_id,
                                    "encumbrance"=>$encumbrance,
                                    "encumbrance1"=>$encumbrance1,
                                    "evidance_of_title_chk"=>$evidance_of_title_chk,
                                    "association_aporx" =>$association_aporx,
                                    "association_aporx_per" => $association_aporx_per,
                                    "association_aporx_except" =>$association_aporx_except,
                                    "forfeiture_of_chk" => $forfeiture_of_chk,
                                    "forfeiture_of_txt" =>$forfeiture_of_txt
                                    );

            }      
            if($contract_type == "sell" || $contract_type == "Sell"){
                $price = isset($_POST['price']) ? (is_array($_POST['price']) ? json_encode($_POST['price']) : $_POST['price']):"";
                $terms = isset($_POST['terms']) ? (is_array($_POST['terms']) ? json_encode($_POST['terms']) : $_POST['terms']):"";
                $other_terms =isset($_POST['other_terms']) ? (is_array($_POST['other_terms']) ? json_encode($_POST['other_terms']) : $_POST['other_terms']):"";
                $loan_discount_points =isset($_POST['loan_discount_points']) ? (is_array($_POST['loan_discount_points']) ? json_encode($_POST['loan_discount_points']) : $_POST['loan_discount_points']):"";
                $buyer_closing_cost =isset($_POST['buyer_closing_cost']) ? (is_array($_POST['buyer_closing_cost']) ? json_encode($_POST['buyer_closing_cost']) : $_POST['buyer_closing_cost']):"";
                $buyer_closing_cost1 =isset($_POST['buyer_closing_cost1']) ? (is_array($_POST['buyer_closing_cost1']) ? json_encode($_POST['buyer_closing_cost1']) : $_POST['buyer_closing_cost1']):"";
                $earnest_money =isset($_POST['earnest_money']) ? (is_array($_POST['earnest_money']) ? json_encode($_POST['earnest_money']) : $_POST['earnest_money']):"";
                $earnest_money_form =isset($_POST['earnest_money_form']) ? (is_array($_POST['earnest_money_form']) ? json_encode($_POST['earnest_money_form']) : $_POST['earnest_money_form']):"";
                $seller_proceed_idicated_chk =isset($_POST['seller_proceed_idicated_chk']) ? (is_array($_POST['seller_proceed_idicated_chk']) ? json_encode($_POST['seller_proceed_idicated_chk']) : $_POST['seller_proceed_idicated_chk']):"";

                                $data['sell_price_term']=array(
                                    "client_id"=>$client_id,
                                    "contract_id"=>$contract_id,
                                    "contract_pid"=>$insert_id,
                                    "price"=>$price,
                                    "terms"=>$terms,
                                    "other_terms"=>$other_terms,
                                    "loan_discount_points" =>$loan_discount_points,
                                    "buyer_closing_cost" => $buyer_closing_cost,
                                    "buyer_closing_cost1" =>$buyer_closing_cost1,
                                    "earnest_money" =>$earnest_money,
                                    "earnest_money_form" => $earnest_money_form,
                                    "seller_proceed_idicated_chk" =>$seller_proceed_idicated_chk,
                                    );

            }                 
            if($contract_type == "lease" || $contract_type == "Lease"){
                $rental_rate = isset($_POST['rental_rate']) ? (is_array($_POST['rental_rate']) ? json_encode($_POST['rental_rate']) : $_POST['rental_rate']):"";
                $min_security_deposit = isset($_POST['min_security_deposit']) ? (is_array($_POST['min_security_deposit']) ? json_encode($_POST['min_security_deposit']) : $_POST['min_security_deposit']):"";
                $mls_marketing_except =isset($_POST['mls_marketing_except']) ? (is_array($_POST['mls_marketing_except']) ? json_encode($_POST['mls_marketing_except']) : $_POST['mls_marketing_except']):"";
                $other_terms =isset($_POST['other_terms']) ? (is_array($_POST['other_terms']) ? json_encode($_POST['other_terms']) : $_POST['other_terms']):"";

                                $data['lease_rental_rate']=array(
                                    "client_id"=>$client_id,
                                    "contract_id"=>$contract_id,
                                    "contract_pid"=>$insert_id,
                                    "rental_rate"=>$rental_rate,
                                    "min_security_deposit"=>$min_security_deposit,
                                    "mls_marketing_except"=>$mls_marketing_except,
                                    "other_terms" =>$other_terms
                                                                        );

            }            
            if($contract_type == "buy" || $contract_type == "Buy" || $contract_type == "tenant" || $contract_type == "Tenant"){
                $broker_services = isset($_POST['broker_services']) ? (is_array($_POST['broker_services']) ? json_encode($_POST['broker_services']) : $_POST['broker_services']):"";
                $showing_properties = isset($_POST['showing_properties']) ? (is_array($_POST['showing_properties']) ? json_encode($_POST['showing_properties']) : $_POST['showing_properties']):"";
                $showing_properties1 =isset($_POST['showing_properties1']) ? (is_array($_POST['showing_properties1']) ? json_encode($_POST['showing_properties1']) : $_POST['showing_properties1']):"";

                                $data['buyer_broker_services']=array(
                                    "client_id"=>$client_id,
                                    "contract_id"=>$contract_id,
                                    "contract_pid"=>$insert_id,
                                    "broker_services"=>$broker_services,
                                    "showing_properties"=>$showing_properties,
                                    "showing_properties1"=>$showing_properties1,
                                                                        );

            }                        
            
            if( !empty($_POST['party']) && !empty($insert_id)){
                $broker = isset($_POST['broker']) ? (is_array($_POST['broker']) ? json_encode($_POST['broker']) : $_POST['broker']) :'';
                $broker_signature = isset($_POST['broker_signature']) ? (is_array($_POST['broker_signature']) ? json_encode($_POST['broker_signature']) : $_POST['broker_signature']) :'';
                $broker_date = isset($_POST['broker_date']) ? (is_array($_POST['broker_date']) ? json_encode($_POST['broker_date']) : $_POST['broker_date']) :'';
                $broker_address = isset($_POST['broker_address']) ? (is_array($_POST['broker_address']) ? json_encode($_POST['broker_address']) : $_POST['broker_address']) :'';
                $broker_phone = isset($_POST['broker_phone']) ? (is_array($_POST['broker_phone']) ? json_encode($_POST['broker_phone']) : $_POST['broker_phone']) :'';
                $broker_fax = isset($_POST['broker_fax']) ? (is_array($_POST['broker_fax']) ? json_encode($_POST['broker_fax']) : $_POST['broker_fax']) :'';
                $broker_electronic_address = isset($_POST['broker_electronic_address']) ? (is_array($_POST['broker_electronic_address']) ? json_encode($_POST['broker_electronic_address']) : $_POST['broker_electronic_address']) :'';
                //brokerage
                $brokerage = isset($_POST['brokerage']) ? (is_array($_POST['brokerage']) ? json_encode($_POST['brokerage']) : $_POST['brokerage']) :'';
                $brokerage_signature = isset($_POST['brokerage_signature']) ? (is_array($_POST['brokerage_signature']) ? json_encode($_POST['brokerage_signature']) : $_POST['brokerage_signature']) :'';
                $brokerage_date = isset($_POST['brokerage_date']) ? (is_array($_POST['brokerage_date']) ? json_encode($_POST['brokerage_date']) : $_POST['brokerage_date']) :'';
                $brokerage_address = isset($_POST['brokerage_address']) ? (is_array($_POST['brokerage_address']) ? json_encode($_POST['brokerage_address']) : $_POST['brokerage_address']) :'';
                $brokerage_phone = isset($_POST['brokerage_phone']) ? (is_array($_POST['brokerage_phone']) ? json_encode($_POST['brokerage_phone']) : $_POST['brokerage_phone']) :'';
                $brokerage_fax = isset($_POST['brokerage_fax']) ? (is_array($_POST['brokerage_fax']) ? json_encode($_POST['brokerage_fax']) : $_POST['brokerage_fax']) :'';
                $brokerage_electronic_address = isset($_POST['brokerage_electronic_address']) ? (is_array($_POST['brokerage_electronic_address']) ? json_encode($_POST['brokerage_electronic_address']) : $_POST['brokerage_electronic_address']) :'';
                //others
                $counter_rejection = isset($_POST['counter_rejection']) ? (is_array($_POST['counter_rejection']) ? json_encode($_POST['counter_rejection']) : $_POST['counter_rejection']) :'';
                $counter_rejection_by = isset($_POST['counter_rejection_by']) ? (is_array($_POST['counter_rejection_by']) ? json_encode($_POST['counter_rejection_by']) : $_POST['counter_rejection_by']) :'';
                $broker_acknowledge_receipt = isset($_POST['broker_acknowledge_receipt']) ? (is_array($_POST['broker_acknowledge_receipt']) ? json_encode($_POST['broker_acknowledge_receipt']) : $_POST['broker_acknowledge_receipt']) :'';;
                $broker_working_as = isset($_POST['broker_working_as']) ? (is_array($_POST['broker_working_as']) ? json_encode($_POST['broker_working_as']) : $_POST['broker_working_as']) :'';
                $change_of_satus = isset($_POST['change_of_satus']) ? (is_array($_POST['change_of_satus']) ? json_encode($_POST['change_of_satus']) : $_POST['change_of_satus']) :'';
                $compensation_commission_paid = isset($_POST['compensation_commission_paid']) ? (is_array($_POST['compensation_commission_paid']) ? json_encode($_POST['compensation_commission_paid']) : $_POST['compensation_commission_paid']) :'';
                $compensation_commission_paid_other = isset($_POST['compensation_commission_paid_other']) ? (is_array($_POST['compensation_commission_paid_other']) ? json_encode($_POST['compensation_commission_paid_other']) : $_POST['compensation_commission_paid_other']) :'';
  
                $party = isset($_POST['party']) ? (is_array($_POST['party']) ? json_encode($_POST['party']) : $_POST['party']) :'';
                $party_signature = isset($_POST['party_signature']) ? (is_array($_POST['party_signature']) ? json_encode($_POST['party_signature']) : $_POST['party_signature']) :'';
                $party_date = isset($_POST['party_date']) ? (is_array($_POST['party_date']) ? json_encode($_POST['party_date']) : $_POST['party_date']) :'';
                $party_address = isset($_POST['party_address']) ? (is_array($_POST['party_address']) ? json_encode($_POST['party_address']) : $_POST['party_address']) :'';
                $party_phone = isset($_POST['party_phone']) ? (is_array($_POST['party_phone']) ? json_encode($_POST['party_phone']) : $_POST['party_phone']) :'';
                $party_fax = isset($_POST['party_fax']) ? (is_array($_POST['party_fax']) ? json_encode($_POST['party_fax']) : $_POST['party_fax']) :'';
                $party_electronic_address = isset($_POST['party_electronic_address']) ? (is_array($_POST['party_electronic_address']) ? json_encode($_POST['party_electronic_address']) : $_POST['party_electronic_address']) :'';

                $party_seller = isset($_POST['party_seller']) ? (is_array($_POST['party_seller']) ? json_encode($_POST['party_seller']) : $_POST['party_seller']) :'';
                $party_seller_signature = isset($_POST['party_seller_signature']) ? (is_array($_POST['party_seller_signature']) ? json_encode($_POST['party_seller_signature']) : $_POST['party_seller_signature']) :'';
                $party_seller_date = isset($_POST['party_seller_date']) ? (is_array($_POST['party_seller_date']) ? json_encode($_POST['party_seller_date']) : $_POST['party_seller_date']) :'';
                $party_seller_address = isset($_POST['party_seller_address']) ? (is_array($_POST['party_seller_address']) ? json_encode($_POST['party_seller_address']) : $_POST['party_seller_address']) :'';
                $party_seller_phone = isset($_POST['party_seller_phone']) ? (is_array($_POST['party_seller_phone']) ? json_encode($_POST['party_seller_phone']) : $_POST['party_seller_phone']) :'';
                $party_seller_fax = isset($_POST['party_seller_fax']) ? (is_array($_POST['party_seller_fax']) ? json_encode($_POST['party_seller_fax']) : $_POST['party_seller_fax']) :'';
                $party_seller_electronic_address = isset($_POST['party_seller_electronic_address']) ? (is_array($_POST['party_seller_electronic_address']) ? json_encode($_POST['party_seller_electronic_address']) : $_POST['party_seller_electronic_address']) :'';
                
                $data['contract_parties']=array(
                    "client_id"=>$client_id,
                    "contract_id"=>$contract_id,
                    "contract_pid"=>$insert_id,
                    "party"=>$party,
                    "party_signature"=>$party_signature,
                    "party_date"=>$party_date,
                    "party_address"=>$party_address,
                    "party_phone"=>$party_phone,
                    "party_fax"=>$party_fax,
                    "party_electronic_address"=>$party_electronic_address,
                    "party_seller"=>$party_seller,
                    "party_seller_signature"=>$party_seller_signature,
                    "party_seller_date"=>$party_seller_date,
                    "party_seller_address"=>$party_seller_address,
                    "party_seller_phone"=>$party_seller_phone,
                    "party_seller_fax"=>$party_seller_fax,
                    "party_seller_electronic_address"=>$party_seller_electronic_address,
                    "broker"=>$broker,
                    "broker_signature"=>$broker_signature,
                    "broker_date"=>$broker_date,
                    "broker_address"=>$broker_address,
                    "broker_phone"=>$broker_phone,
                    "broker_fax"=>$broker_fax,
                    "broker_electronic_address"=>$broker_electronic_address,
                    "brokerage"=>$brokerage,
                    "brokerage_signature"=>$brokerage_signature,
                    "brokerage_date"=>$brokerage_date,
                    "brokerage_address"=>$brokerage_address,
                    "brokerage_phone"=>$brokerage_phone,
                    "brokerage_fax"=>$brokerage_fax,
                    "brokerage_electronic_address"=>$brokerage_electronic_address,
                    'counter_rejection'=>$counter_rejection  ,
                    'counter_rejection_by' =>$counter_rejection_by,
                    'broker_acknowledge_receipt'=>$broker_acknowledge_receipt ,
                    'broker_working_as' => $broker_working_as,
                    'change_of_satus' =>$change_of_satus,
                    'compensation_commission_paid' =>$compensation_commission_paid,
                    'compensation_commission_paid_other'=>$compensation_commission_paid_other
                );
                
            }
            if( !empty($_POST['contract_date']) && !empty($insert_id)){
            $data['contract_list']=array(
                                        "client_id"=>$client_id,
                                        "contract_id"=>$contract_id,
                                        "contract_pid"=>$insert_id,
                                        "party_affiliation"=>'test',
                                        "sent_date"=>'test',
                                        "contract_date"=>$_POST['contract_date'],
                                        "contract_status"=>'test',
                                        "property_type"=>'test',
                                        "property_address"=>'test',
                                        "property_MLS"=>'test',
                                        "property_original_price"=>'test',
                                        "property_contract_price"=>'test',
                                        "property_deadline"=>'test',
                                        "property_closing_date"=>'test',
                                        "property_staus"=>'test',
                                        "property_title_resolution"=>'test'
                                        );
           
        }

            if(!empty($_POST['event']) && !empty($insert_id)){
            foreach($_POST['event'] as $date_key=>$date_value){
                $event=$_POST['event'][$date_key];
                $deadline_date= !empty($_POST['deadline_date'][$date_key])? date("Y-m-d H:i:s",strtotime($_POST['deadline_date'][$date_key])):0;
                $Itemno= !empty($_POST['Itemno'][$date_key])? $_POST['Itemno'][$date_key]:0;
                $reference= !empty($_POST['reference'][$date_key])? $_POST['reference'][$date_key]:0;
                if(trim($date_value) !='' || trim($deadline_value)!=''){
                    $data['contract_date_deadline'][$date_key]=array(
                                                                    "client_id"=>$client_id,
                                                                    "contract_id"=>$contract_id,
                                                                    "contract_pid"=>$insert_id,
                                                                    "Itemno"=>$Itemno,
                                                                    "Item_name"=>0,
                                                                    "reference"=>$reference,
                                                                    "event"=>$event,
                                                                    "deadline_date"=>$deadline_date
                                                                );
                }
            }
        }
        if(!empty($_POST['property_detail']) && !empty($insert_id)){
    
            $property_street=!empty($_POST['property_street'])? (is_array($_POST['property_street']) ? json_encode($_POST['property_street']) : $_POST['property_street']) :''; 
            $type=!empty($_POST['type'])? (is_array($_POST['type']) ? json_encode($_POST['type']) : $_POST['type']) :''; 
            $property_city=!empty($_POST['property_city'])? (is_array($_POST['property_city']) ? json_encode($_POST['property_city']) : $_POST['property_city']) :'';
            $property_state=!empty($_POST['property_state'])? (is_array($_POST['property_state']) ? json_encode($_POST['property_state']) : $_POST['property_state']) :'';
            $property_zipcode=!empty($_POST['property_zipcode'])? (is_array($_POST['property_zipcode']) ? json_encode($_POST['property_zipcode']) : $_POST['property_zipcode']) :'';
            $property_county=!empty($_POST['property_county'])? (is_array($_POST['property_county']) ? json_encode($_POST['property_county']) : $_POST['property_county']) :'';
            $property_detail=!empty($_POST['property_detail'])? (is_array($_POST['property_detail']) ? json_encode($_POST['property_detail']) : $_POST['property_detail']) :'';
                $data['contract_property'][]=array(
                                                                "client_id"=>$client_id,
                                                                "contract_id"=>$contract_id,
                                                                "contract_pid"=>$insert_id,
                                                                "type"=>$type,
                                                                "property_street_name"=>$property_street,    
                                                                "property_city"=>$property_city,
                                                                "property_state"=>$property_state,
                                                                "property_zipcode"=>$property_zipcode,
                                                                "property_county"=>$property_county,
                                                                "property_detail"=>$property_detail
                                                            );
            
        }
            if(!empty($insert_id)){
                $deligence_documents= !empty($_POST['deligence_documents'])? (is_array($_POST['deligence_documents']) ? json_encode($_POST['deligence_documents']) : $_POST['deligence_documents']):0;
                $personal_property_covenyance= !empty($_POST['personal_property_covenyance'])? (is_array($_POST['personal_property_covenyance']) ? json_encode($_POST['personal_property_covenyance']) : $_POST['personal_property_covenyance']):0;
                $other_inclusion=!empty($_POST['other_inclusion'])? (is_array($_POST['other_inclusion']) ? json_encode($_POST['other_inclusion']) : $_POST['other_inclusion']) :0;
                $parking_storage = !empty($_POST['parking_storage'])? (is_array($_POST['parking_storage']) ? json_encode($_POST['parking_storage']) : $_POST['parking_storage']) :0;
                $exclusion_details = !empty($_POST['exclusion_details'])? (is_array($_POST['exclusion_details']) ? json_encode($_POST['exclusion_details']) : $_POST['exclusion_details']) :0;
                $deeded_water_rights_details = !empty($_POST['deeded_water_rights_details']) ? (is_array($_POST['deeded_water_rights_details']) ? json_encode($_POST['deeded_water_rights_details']) : $_POST['deeded_water_rights_details']) :0;
                $other_water_rights_details= !empty($_POST['other_water_rights_details']) ? (is_array($_POST['other_water_rights_details']) ? json_encode($_POST['other_water_rights_details']) : $_POST['other_water_rights_details']) :0;
                $well_rights_details=!empty($_POST['well_rights_details']) ? (is_array($_POST['well_rights_details']) ? json_encode($_POST['well_rights_details']) : $_POST['well_rights_details']) :0;
                $water_stock_certificate_details=!empty($_POST['water_stock_certificate_details']) ? (is_array($_POST['water_stock_certificate_details']) ? json_encode($_POST['water_stock_certificate_details']) : $_POST['water_stock_certificate_details']) :0;
                $conveyance_details=!empty($_POST['conveyance_details']) ? (is_array($_POST['conveyance_details']) ? json_encode($_POST['conveyance_details']) : $_POST['conveyance_details']) :0;
                $parking_chk = !empty($_POST['parking_chk'])? (is_array($_POST['parking_chk']) ? json_encode($_POST['parking_chk']) : $_POST['parking_chk']) :'';
                $parking = !empty($_POST['parking'])? (is_array($_POST['parking']) ? json_encode($_POST['parking']) : $_POST['parking']) :'';
                $storage_chk = !empty($_POST['storage_chk'])? (is_array($_POST['storage_chk']) ? json_encode($_POST['storage_chk']) : $_POST['storage_chk']) :'';
                $storage = !empty($_POST['storage'])? (is_array($_POST['storage']) ? json_encode($_POST['storage']) : $_POST['storage']) :'';
                $water_right = !empty($_POST['water_right'])? (is_array($_POST['water_right']) ? json_encode($_POST['water_right']) : $_POST['water_right']) :'';
                $well_right = !empty($_POST['well_right'])? (is_array($_POST['well_right']) ? json_encode($_POST['well_right']) : $_POST['well_right']) :'';
                $growing_crops = !empty($_POST['growing_crops'])? (is_array($_POST['growing_crops']) ? json_encode($_POST['growing_crops']) : $_POST['growing_crops']) :'';
                $inclusion_fixture = !empty($_POST['inclusion_fixture'])? (is_array($_POST['inclusion_fixture']) ? json_encode($_POST['inclusion_fixture']) : $_POST['inclusion_fixture']) :'';
                $personal_property_txt = !empty($_POST['personal_property_txt'])? (is_array($_POST['personal_property_txt']) ? json_encode($_POST['personal_property_txt']) : $_POST['personal_property_txt']) :'';
                $personal_property_chk = !empty($_POST['personal_property_chk'])? (is_array($_POST['personal_property_chk']) ? json_encode($_POST['personal_property_chk']) : $_POST['personal_property_chk']) :'';
                $trade_fixture = !empty($_POST['trade_fixture'])? (is_array($_POST['trade_fixture']) ? json_encode($_POST['trade_fixture']) : $_POST['trade_fixture']) :'';
                $trade_fixture1 = !empty($_POST['trade_fixture1'])? (is_array($_POST['trade_fixture1']) ? json_encode($_POST['trade_fixture1']) : $_POST['trade_fixture1']) :'';
                $inclusion_other_fixture = !empty($_POST['inclusion_other_fixture'])? (is_array($_POST['inclusion_other_fixture']) ? json_encode($_POST['inclusion_other_fixture']) : $_POST['inclusion_other_fixture']) :'';
                $garage_remote= !empty($_POST['garage_remote'])? (is_array($_POST['garage_remote']) ? json_encode($_POST['garage_remote']) : $_POST['garage_remote']):0;

                $data['contract_inclusion']=array(
                    "client_id"=>$client_id,
                    "contract_id"=>$contract_id,
                    "contract_pid"=>$insert_id,
                    "diligence_documents"=>$deligence_documents,
                    "personal_property_convoyance"=>$personal_property_covenyance,
                    "others_inclusion"=>$other_inclusion,
                    "parking_storage"=>$parking_storage,
                    "exclusion"=>$exclusion_details,
                    "deed_water_right"=>$deeded_water_rights_details,
                    "other_water_right"=>$other_water_rights_details,
                    "well_right"=>$well_rights_details,
                    "water_stock_certificate"=>$water_stock_certificate_details,
                    "conveyance"=>$conveyance_details,
                    "parking_chk"=>$parking_chk,
                    "parking"=>$parking,
                    "storage_chk"=>$storage_chk,
                    "storage"=>$storage,
                    "water_right"=>$water_right,
                    "well_right"=>$well_right,
                    "growing_crops"=>$growing_crops,
                    "inclusion_fixture"=>$inclusion_fixture,
                    "personal_property_txt"=>$personal_property_txt,
                    "personal_property_chk"=>$personal_property_chk,
                    "trade_fixture"=>$trade_fixture,
                    "trade_fixture1"=>$trade_fixture1,
                    "inclusion_other_fixture"=>$inclusion_other_fixture,
                    "garage_remote"=>$garage_remote,
 );
            }
            if($contract_type == "buy and sell" || $contract_type == "Buy And Sell"){

                if(!empty($_POST['item']) && !empty($insert_id)){
                    foreach($_POST['item'] as $date_key=>$date_value){
                        $item=$_POST['item'][$date_key];
                        $item_no= !empty($_POST['item_no'][$date_key])? $_POST['item_no'][$date_key]:0;
                        $reference= !empty($_POST['reference'][$date_key])? $_POST['reference'][$date_key]:0;
                        $amount= !empty($_POST['amount'][$date_key])? $_POST['amount'][$date_key]:0;
                        $amount1= !empty($_POST['amount1'][$date_key])? $_POST['amount1'][$date_key]:0;
                        if(trim($date_value) !=''){
                            $data['purchase_price_term'][$date_key]=array(
                                                                            "client_id"=>$client_id,
                                                                            "contract_id"=>$contract_id,
                                                                            "contract_pid"=>$insert_id,
                                                                            "item_no"=>$item_no,
                                                                            "item"=>$item,
                                                                            "reference"=>$reference,
                                                                            "amount"=>$amount,
                                                                            "amount1"=>$amount1
                                                                        );
                        }
                    }
                }
    
                    
                //purchase_description
                    $seller_concession = isset($_POST['seller_concession']) ? (is_array($_POST['seller_concession']) ? json_encode($_POST['seller_concession']) : $_POST['seller_concession']):"";
                    $earnest_money_form = isset($_POST['earnest_money_form']) ? (is_array($_POST['earnest_money_form']) ? json_encode($_POST['earnest_money_form']) : $_POST['earnest_money_form']):"";
                    $earnest_money_held =isset($_POST['earnest_money_held']) ? (is_array($_POST['earnest_money_held']) ? json_encode($_POST['earnest_money_held']) : $_POST['earnest_money_held']):"";
                    $time_of_payment =isset($_POST['time_of_payment']) ? (is_array($_POST['time_of_payment']) ? json_encode($_POST['time_of_payment']) : $_POST['time_of_payment']):"";
                    $loan_limitations =isset($_POST['loan_limitations']) ? (is_array($_POST['loan_limitations']) ? json_encode($_POST['loan_limitations']) : $_POST['loan_limitations']):"";
    
                    $loan_limitations_other = isset($_POST['loan_limitations_other']) ? (is_array($_POST['loan_limitations_other']) ? json_encode($_POST['loan_limitations_other']) : $_POST['loan_limitations_other']):"";
                    $assumption_payable = isset($_POST['assumption_payable']) ? (is_array($_POST['assumption_payable']) ? json_encode($_POST['assumption_payable']) : $_POST['assumption_payable']):"";
                    $assumption_per =isset($_POST['assumption_per']) ? (is_array($_POST['assumption_per']) ? json_encode($_POST['assumption_per']) : $_POST['assumption_per']):"";
                    $assumption_anum_intrest =isset($_POST['assumption_anum_intrest']) ? (is_array($_POST['assumption_anum_intrest']) ? json_encode($_POST['assumption_anum_intrest']) : $_POST['assumption_anum_intrest']):"";
                    $escrow_for =isset($_POST['escrow_for']) ? (is_array($_POST['escrow_for']) ? json_encode($_POST['escrow_for']) : $_POST['escrow_for']):"";
    
                    $escrow_and = isset($_POST['escrow_and']) ? (is_array($_POST['escrow_and']) ? json_encode($_POST['escrow_and']) : $_POST['escrow_and']):"";
                    $escrow_and_txt = isset($_POST['escrow_and_txt']) ? (is_array($_POST['escrow_and_txt']) ? json_encode($_POST['escrow_and_txt']) : $_POST['escrow_and_txt']):"";
                    $loan_transfer_notexceed =isset($_POST['loan_transfer_notexceed']) ? (is_array($_POST['loan_transfer_notexceed']) ? json_encode($_POST['loan_transfer_notexceed']) : $_POST['loan_transfer_notexceed']):"";
                    $interest_notexceed =isset($_POST['interest_notexceed']) ? (is_array($_POST['interest_notexceed']) ? json_encode($_POST['interest_notexceed']) : $_POST['interest_notexceed']):"";
                    $new_payment_notexceed =isset($_POST['new_payment_notexceed']) ? (is_array($_POST['new_payment_notexceed']) ? json_encode($_POST['new_payment_notexceed']) : $_POST['new_payment_notexceed']):"";
    
                    $new_payment_notexceed_per = isset($_POST['new_payment_notexceed_per']) ? (is_array($_POST['new_payment_notexceed_per']) ? json_encode($_POST['new_payment_notexceed_per']) : $_POST['new_payment_notexceed_per']):"";
                    $assumption_balence_closing_exceed = isset($_POST['assumption_balence_closing_exceed']) ? (is_array($_POST['assumption_balence_closing_exceed']) ? json_encode($_POST['assumption_balence_closing_exceed']) : $_POST['assumption_balence_closing_exceed']):"";
                    $realeased_liability_loan =isset($_POST['realeased_liability_loan']) ? (is_array($_POST['realeased_liability_loan']) ? json_encode($_POST['realeased_liability_loan']) : $_POST['realeased_liability_loan']):"";
                    $evidence_by_delivery_on =isset($_POST['evidence_by_delivery_on']) ? (is_array($_POST['evidence_by_delivery_on']) ? json_encode($_POST['evidence_by_delivery_on']) : $_POST['evidence_by_delivery_on']):"";
                    $loan_transfer_approval_deadline =isset($_POST['loan_transfer_approval_deadline']) ? (is_array($_POST['loan_transfer_approval_deadline']) ? json_encode($_POST['loan_transfer_approval_deadline']) : $_POST['loan_transfer_approval_deadline']):"";
    
                    $release_liability_paid = isset($_POST['release_liability_paid']) ? (is_array($_POST['release_liability_paid']) ? json_encode($_POST['release_liability_paid']) : $_POST['release_liability_paid']):"";
                    $release_liability_exceed = isset($_POST['release_liability_exceed']) ? (is_array($_POST['release_liability_exceed']) ? json_encode($_POST['release_liability_exceed']) : $_POST['release_liability_exceed']):"";
                    $seller_financing =isset($_POST['seller_financing']) ? (is_array($_POST['seller_financing']) ? json_encode($_POST['seller_financing']) : $_POST['seller_financing']):"";
                    $private_financing_deadline =isset($_POST['private_financing_deadline']) ? (is_array($_POST['private_financing_deadline']) ? json_encode($_POST['private_financing_deadline']) : $_POST['private_financing_deadline']):"";
    
                   
                    $data['purchase_description']=array(
                        "client_id"=>$client_id,
                        "contract_id"=>$contract_id,
                        "contract_pid"=>$insert_id,
                       'seller_concession'=> $seller_concession ,
                       'earnest_money_form'=>$earnest_money_form ,
                       'earnest_money_held'=>$earnest_money_held ,
                       'time_of_payment'=> $time_of_payment ,
                       'loan_limitations'=>$loan_limitations ,
                       'loan_limitations_other'=> $loan_limitations_other ,
                       'assumption_payable'=> $assumption_payable, 
                       'assumption_per'=> $assumption_per, 
                       'assumption_anum_intrest'=>$assumption_anum_intrest, 
                       'escrow_for'=>$escrow_for, 
                       'escrow_and'=> $escrow_and, 
                       'escrow_and_txt'=>$escrow_and_txt,
                       'loan_transfer_notexceed'=> $loan_transfer_notexceed,
                       'interest_notexceed'=>$interest_notexceed,
                       'new_payment_notexceed'=>$new_payment_notexceed, 
                       'new_payment_notexceed_per'=>$new_payment_notexceed_per,  
                        'assumption_balence_closing_exceed'=>$assumption_balence_closing_exceed,
                        'realeased_liability_loan'=>$realeased_liability_loan, 
                        'evidence_by_delivery_on'=>$evidence_by_delivery_on, 
                        'loan_transfer_approval_deadline'=>$loan_transfer_approval_deadline,
                        'release_liability_paid'=>$release_liability_paid ,
                        'release_liability_exceed'=>$release_liability_exceed,
                        'seller_financing'=> $seller_financing, 
                        'private_financing_deadline'=>$private_financing_deadline
                    );  
                    //proration
                    $tax_for_calendar_year = isset($_POST['tax_for_calendar_year']) ? (is_array($_POST['tax_for_calendar_year']) ? json_encode($_POST['tax_for_calendar_year']) : $_POST['tax_for_calendar_year']):"";
                    $most_recent_mill_levy = isset($_POST['most_recent_mill_levy']) ? (is_array($_POST['most_recent_mill_levy']) ? json_encode($_POST['most_recent_mill_levy']) : $_POST['most_recent_mill_levy']):"";
                    $other_calendar_taxes =isset($_POST['other_calendar_taxes']) ? (is_array($_POST['other_calendar_taxes']) ? json_encode($_POST['other_calendar_taxes']) : $_POST['other_calendar_taxes']):"";
                    $rents_actually_received =isset($_POST['rents_actually_received']) ? (is_array($_POST['rents_actually_received']) ? json_encode($_POST['rents_actually_received']) : $_POST['rents_actually_received']):"";
                    $accrued =isset($_POST['accrued']) ? (is_array($_POST['accrued']) ? json_encode($_POST['accrued']) : $_POST['accrued']):"";

                    $association_obligation_of = isset($_POST['association_obligation_of']) ? (is_array($_POST['association_obligation_of']) ? json_encode($_POST['association_obligation_of']) : $_POST['association_obligation_of']):"";
                    $assessment_payable_approx = isset($_POST['assessment_payable_approx']) ? (is_array($_POST['assessment_payable_approx']) ? json_encode($_POST['assessment_payable_approx']) : $_POST['assessment_payable_approx']):"";
                    $assessment_payable_per =isset($_POST['assessment_payable_per']) ? (is_array($_POST['assessment_payable_per']) ? json_encode($_POST['assessment_payable_per']) : $_POST['assessment_payable_per']):"";
                    $regular_assessment_and =isset($_POST['regular_assessment_and']) ? (is_array($_POST['regular_assessment_and']) ? json_encode($_POST['regular_assessment_and']) : $_POST['regular_assessment_and']):"";
                    $other_prorations =isset($_POST['other_prorations']) ? (is_array($_POST['other_prorations']) ? json_encode($_POST['other_prorations']) : $_POST['other_prorations']):"";

                    $data['prorations']=array(
                        "client_id"=>$client_id,
                        "contract_id"=>$contract_id,
                        "contract_pid"=>$insert_id,
                        'tax_for_calendar_year'=>$tax_for_calendar_year,
                            'most_recent_mill_levy'=>$most_recent_mill_levy,
                            'other_calendar_taxes'=>$other_calendar_taxes,
                            'rents_actually_received'=>$rents_actually_received,
                            'accrued'=>$accrued,
                            'association_obligation_of'=>$association_obligation_of,
                            'assessment_payable_approx'=>$assessment_payable_approx,
                            'assessment_payable_per'=>$assessment_payable_per,
                            'regular_assessment_and'=>$regular_assessment_and,
                            'other_prorations'=>$other_prorations
                    );  
                    //provisions
                        $apraised_property_value = isset($_POST['apraised_property_value']) ? (is_array($_POST['apraised_property_value']) ? json_encode($_POST['apraised_property_value']) : $_POST['apraised_property_value']):"";
                        $apraisal_paid_by = isset($_POST['apraisal_paid_by']) ? (is_array($_POST['apraisal_paid_by']) ? json_encode($_POST['apraisal_paid_by']) : $_POST['apraisal_paid_by']):"";
                        $closing_instruction =isset($_POST['closing_instruction']) ? (is_array($_POST['closing_instruction']) ? json_encode($_POST['closing_instruction']) : $_POST['closing_instruction']):"";
                        $closing_designated_by =isset($_POST['closing_designated_by']) ? (is_array($_POST['closing_designated_by']) ? json_encode($_POST['closing_designated_by']) : $_POST['closing_designated_by']):"";
                        $transfer_title_sufficient =isset($_POST['transfer_title_sufficient']) ? (is_array($_POST['transfer_title_sufficient']) ? json_encode($_POST['transfer_title_sufficient']) : $_POST['transfer_title_sufficient']):"";
    
                        $transfer_title_other = isset($_POST['transfer_title_other']) ? (is_array($_POST['transfer_title_other']) ? json_encode($_POST['transfer_title_other']) : $_POST['transfer_title_other']):"";
                        $occupy_principle_residence = isset($_POST['occupy_principle_residence']) ? (is_array($_POST['occupy_principle_residence']) ? json_encode($_POST['occupy_principle_residence']) : $_POST['occupy_principle_residence']):"";
                        $post_closing_occupancy_agreement =isset($_POST['post_closing_occupancy_agreement']) ? (is_array($_POST['post_closing_occupancy_agreement']) ? json_encode($_POST['post_closing_occupancy_agreement']) : $_POST['post_closing_occupancy_agreement']):"";
                        $fails_deliver_payment =isset($_POST['fails_deliver_payment']) ? (is_array($_POST['fails_deliver_payment']) ? json_encode($_POST['fails_deliver_payment']) : $_POST['fails_deliver_payment']):"";
                        $specific_performance =isset($_POST['specific_performance']) ? (is_array($_POST['specific_performance']) ? json_encode($_POST['specific_performance']) : $_POST['specific_performance']):"";
    
                        $data['provisions']=array(
                            "client_id"=>$client_id,
                            "contract_id"=>$contract_id,
                            "contract_pid"=>$insert_id,
                            'apraised_property_value'=> $apraised_property_value ,
                            'apraisal_paid_by'=>$apraisal_paid_by ,
                            'closing_instruction'=>$closing_instruction ,
                            'closing_designated_by'=> $closing_designated_by ,
                            'transfer_title_sufficient'=>$transfer_title_sufficient ,
                            'transfer_title_other'=> $transfer_title_other ,
                            'occupy_principle_residence'=> $occupy_principle_residence, 
                            'post_closing_occupancy_agreement'=> $post_closing_occupancy_agreement, 
                            'fails_deliver_payment'=>$fails_deliver_payment, 
                            'specific_performance'=>$specific_performance
                        );  
                       
                //record_title_insurance
                    $seller_select_title = isset($_POST['seller_select_title']) ? (is_array($_POST['seller_select_title']) ? json_encode($_POST['seller_select_title']) : $_POST['seller_select_title']):"";
                    $buyer_select_title = isset($_POST['buyer_select_title']) ? (is_array($_POST['buyer_select_title']) ? json_encode($_POST['buyer_select_title']) : $_POST['buyer_select_title']):"";
                    $seller_abstract_title =isset($_POST['seller_abstract_title']) ? (is_array($_POST['seller_abstract_title']) ? json_encode($_POST['seller_abstract_title']) : $_POST['seller_abstract_title']):"";
                    $owner_extend_coverage =isset($_POST['owner_extend_coverage']) ? (is_array($_POST['owner_extend_coverage']) ? json_encode($_POST['owner_extend_coverage']) : $_POST['owner_extend_coverage']):"";
                    $addition_premium_expense =isset($_POST['addition_premium_expense']) ? (is_array($_POST['addition_premium_expense']) ? json_encode($_POST['addition_premium_expense']) : $_POST['addition_premium_expense']):"";
                    $addition_premium_expense_other = isset($_POST['addition_premium_expense_other']) ? (is_array($_POST['addition_premium_expense_other']) ? json_encode($_POST['addition_premium_expense_other']) : $_POST['addition_premium_expense_other']):"";
    
                    $data['record_title_insurance']=array(
                        "client_id"=>$client_id,
                        "contract_id"=>$contract_id,
                        "contract_pid"=>$insert_id,
                        'seller_select_title'=> $seller_select_title ,
                        'buyer_select_title'=>$buyer_select_title ,
                        'seller_abstract_title'=>$seller_abstract_title ,
                        'owner_extend_coverage'=> $owner_extend_coverage ,
                        'addition_premium_expense'=>$addition_premium_expense ,
                        'addition_premium_expense_other'=> $addition_premium_expense_other
                    );  
      
                    
            //ilc_survey_details
            $new_ilc = isset($_POST['new_ilc']) ? (is_array($_POST['new_ilc']) ? json_encode($_POST['new_ilc']) : $_POST['new_ilc']):"";
            $new_survey = isset($_POST['new_survey']) ? (is_array($_POST['new_survey']) ? json_encode($_POST['new_survey']) : $_POST['new_survey']):"";
            $in_the_form =isset($_POST['in_the_form']) ? (is_array($_POST['in_the_form']) ? json_encode($_POST['in_the_form']) : $_POST['in_the_form']):"";
            $ordering_of =isset($_POST['ordering_of']) ? (is_array($_POST['ordering_of']) ? json_encode($_POST['ordering_of']) : $_POST['ordering_of']):"";
            $payment_of_chk =isset($_POST['payment_of_chk']) ? (is_array($_POST['payment_of_chk']) ? json_encode($_POST['payment_of_chk']) : $_POST['payment_of_chk']):"";
            $payment_of_txt = isset($_POST['payment_of_txt']) ? (is_array($_POST['payment_of_txt']) ? json_encode($_POST['payment_of_txt']) : $_POST['payment_of_txt']):"";
            $delivery_of = isset($_POST['delivery_of']) ? (is_array($_POST['delivery_of']) ? json_encode($_POST['delivery_of']) : $_POST['delivery_of']):"";
            
            $data['ilc_survey_details']=array(
                "client_id"=>$client_id,
                "contract_id"=>$contract_id,
                "contract_pid"=>$insert_id,
                'new_ilc'=> $new_ilc ,
                'new_survey'=>$new_survey ,
                'in_the_form'=>$in_the_form ,
                'ordering_of'=> $ordering_of ,
                'payment_of_chk'=>$payment_of_chk ,
                'payment_of_txt'=> $payment_of_txt,
                'delivery_of'=> $delivery_of
            );            
                    
            //closing_cost_fee
                    $closing_services_fee_chk = isset($_POST['closing_services_fee_chk']) ? (is_array($_POST['closing_services_fee_chk']) ? json_encode($_POST['closing_services_fee_chk']) : $_POST['closing_services_fee_chk']):"";
                    $closing_services_fee_txt = isset($_POST['closing_services_fee_txt']) ? (is_array($_POST['closing_services_fee_txt']) ? json_encode($_POST['closing_services_fee_txt']) : $_POST['closing_services_fee_txt']):"";
                    $status_letter_change_fee =isset($_POST['status_letter_change_fee']) ? (is_array($_POST['status_letter_change_fee']) ? json_encode($_POST['status_letter_change_fee']) : $_POST['status_letter_change_fee']):"";
                    $association_change_fee =isset($_POST['association_change_fee']) ? (is_array($_POST['association_change_fee']) ? json_encode($_POST['association_change_fee']) : $_POST['association_change_fee']):"";
                    $local_transfer_tax =isset($_POST['local_transfer_tax']) ? (is_array($_POST['local_transfer_tax']) ? json_encode($_POST['local_transfer_tax']) : $_POST['local_transfer_tax']):"";
                    $local_transfer_percentage = isset($_POST['local_transfer_percentage']) ? (is_array($_POST['local_transfer_percentage']) ? json_encode($_POST['local_transfer_percentage']) : $_POST['local_transfer_percentage']):"";
                    $paid_at_closing_by = isset($_POST['paid_at_closing_by']) ? (is_array($_POST['paid_at_closing_by']) ? json_encode($_POST['paid_at_closing_by']) : $_POST['paid_at_closing_by']):"";
    
                    $private_paid_at_closing = isset($_POST['private_paid_at_closing']) ? (is_array($_POST['private_paid_at_closing']) ? json_encode($_POST['private_paid_at_closing']) : $_POST['private_paid_at_closing']):"";
                    $transfer_fee_association =isset($_POST['transfer_fee_association']) ? (is_array($_POST['transfer_fee_association']) ? json_encode($_POST['transfer_fee_association']) : $_POST['transfer_fee_association']):"";
                    $total_amount =isset($_POST['total_amount']) ? (is_array($_POST['total_amount']) ? json_encode($_POST['total_amount']) : $_POST['total_amount']):"";
                    $purchase_price_dollar =isset($_POST['purchase_price_dollar']) ? (is_array($_POST['purchase_price_dollar']) ? json_encode($_POST['purchase_price_dollar']) : $_POST['purchase_price_dollar']):"";
                    $purchase_price_percentage = isset($_POST['purchase_price_percentage']) ? (is_array($_POST['purchase_price_percentage']) ? json_encode($_POST['purchase_price_percentage']) : $_POST['purchase_price_percentage']):"";
                    $water_transfer_fee = isset($_POST['water_transfer_fee']) ? (is_array($_POST['water_transfer_fee']) ? json_encode($_POST['water_transfer_fee']) : $_POST['water_transfer_fee']):"";
    
                    $water_transfer_for = isset($_POST['water_transfer_for']) ? (is_array($_POST['water_transfer_for']) ? json_encode($_POST['water_transfer_for']) : $_POST['water_transfer_for']):"";
                    $sale_used_tax = isset($_POST['sale_used_tax']) ? (is_array($_POST['sale_used_tax']) ? json_encode($_POST['sale_used_tax']) : $_POST['sale_used_tax']):"";
    
                    $data['closing_cost_fee']=array(
                        "client_id"=>$client_id,
                        "contract_id"=>$contract_id,
                        "contract_pid"=>$insert_id,
                        'closing_services_fee_chk'=> $closing_services_fee_chk ,
                        'closing_services_fee_txt'=>$closing_services_fee_txt ,
                        'status_letter_change_fee'=>$status_letter_change_fee ,
                        'association_change_fee'=> $association_change_fee ,
                        'local_transfer_tax'=>$local_transfer_tax ,
                        'local_transfer_percentage'=> $local_transfer_percentage,
                        'paid_at_closing_by'=> $paid_at_closing_by,
    
                        'private_paid_at_closing'=>$private_paid_at_closing ,
                        'transfer_fee_association'=> $transfer_fee_association ,
                        'total_amount'=>$total_amount ,
                        'purchase_price_dollar'=> $purchase_price_dollar,
                        'purchase_price_percentage'=> $purchase_price_percentage,
                        'water_transfer_fee'=> $water_transfer_fee,
    
                        'water_transfer_for'=> $water_transfer_for,
                        'sale_used_tax'=> $sale_used_tax
                    );                  
           
                                                                 
                //disclosure_inspection
                $due_diligence_doc_chk = isset($_POST['due_diligence_doc_chk']) ? (is_array($_POST['due_diligence_doc_chk']) ? json_encode($_POST['due_diligence_doc_chk']) : $_POST['due_diligence_doc_chk']):"";
                $due_diligence_doc_txt = isset($_POST['due_diligence_doc_txt']) ? (is_array($_POST['due_diligence_doc_txt']) ? json_encode($_POST['due_diligence_doc_txt']) : $_POST['due_diligence_doc_txt']):"";
                $other_doc_chk =isset($_POST['other_doc_chk']) ? (is_array($_POST['other_doc_chk']) ? json_encode($_POST['other_doc_chk']) : $_POST['other_doc_chk']):"";
                $other_doc_txt =isset($_POST['other_doc_txt']) ? (is_array($_POST['other_doc_txt']) ? json_encode($_POST['other_doc_txt']) : $_POST['other_doc_txt']):"";
                $conditional_sale_prop =isset($_POST['conditional_sale_prop']) ? (is_array($_POST['conditional_sale_prop']) ? json_encode($_POST['conditional_sale_prop']) : $_POST['conditional_sale_prop']):"";
                $source_portable_water = isset($_POST['source_portable_water']) ? (is_array($_POST['source_portable_water']) ? json_encode($_POST['source_portable_water']) : $_POST['source_portable_water']):"";
                $no_well = isset($_POST['no_well']) ? (is_array($_POST['no_well']) ? json_encode($_POST['no_well']) : $_POST['no_well']):"";
    
                $well_permit = isset($_POST['well_permit']) ? (is_array($_POST['well_permit']) ? json_encode($_POST['well_permit']) : $_POST['well_permit']):"";
                $data['disclosure_inspection']=array(
                    "client_id"=>$client_id,
                    "contract_id"=>$contract_id,
                    "contract_pid"=>$insert_id,
                    'due_diligence_doc_chk'=> $due_diligence_doc_chk ,
                    'due_diligence_doc_txt'=>$due_diligence_doc_txt ,
                    'other_doc_chk'=>$other_doc_chk ,
                    'other_doc_txt'=> $other_doc_txt ,
                    'conditional_sale_prop'=>$conditional_sale_prop ,
                    'source_portable_water'=> $source_portable_water,
                    'no_well'=> $no_well,
    
                    'well_permit'=>$well_permit 
                );                  
            }
//  echo "POSTED DATA=================<pre>";
//  print_r($_POST);
//  echo "</pre>Created DATA=================<pre>";
//    print_r($data["purchase_description"]); 
          //  similar_text("", "", $sim);
        //  exit;
            $submitted = $this->client_model->saveagreement($data);
            //exit;
            if($insert_id){
                $this->session->set_flashdata('msg','Agreement saved successfully.');
                //$filename = $this->get_agreement_pdf($insert_id);
                //$this->client_model->saveagreement_rel(array('pdf_name'=>$filename,'id'=>$insert_id));
                //redirect('Client/view/'.$client_id);
                redirect('Agreement/get_agreement_details/'.$insert_id.'/'.$contract_id.'/'.$client_id.'#contract_standard');
            }else{
                $this->session->set_flashdata('error','Something went wrong.');
                redirect('Agreement/newagreement/'.$client_id.'/'.$contract_id.'#contract_standard');
            }
        }
    }
    public function all_agreements(){       
        if (!$this->session->userdata('user_id')):
			// redirect them to the login page
			redirect(base_url());
		endif;
		$data = array(
			'session'   => $_SESSION,
			'v' => "all_agreements.twig"
		);
		
		$user_id = $this->session->userdata('user_id');
		$filter_data=array('search_string'=>'');
		$where_clause=[];
		if(isset($_POST['search_string']) || !empty($this->uri->segment(4)))
		{
			if(isset($_POST['search_string']))
			{
				$filter_data['search_string']=$_POST['search_string'];
				$this->session->set_userdata('search_string',$filter_data);	
			}
			if($this->session->userdata('search_string'))
			{
				$filter_data['search_string']=$this->session->userdata('search_string')['search_string'];
			}
			
		}
		else
		{
			$this->session->set_userdata('search_string',$filter_data);	
		}
		if(!empty($filter_data['search_string']))
		{
				$where_clause=$filter_data['search_string'];		
        }
        $where_clause['client_id'] = $this->uri->segment(3); 
		$config = array();
        $config["base_url"] = base_url() . "Agreement/all_agreements/".$this->uri->segment(3);
        $total_row =  $this->client_model->count_client_agreement($user_id,$where_clause);
        $config["total_rows"] = $total_row; 
        $config["per_page"] = 5;
        $config['use_page_numbers'] = TRUE;
        $config['num_links'] = 10;
        $config['cur_tag_open'] = '&nbsp;<a class="current">';
        $config['cur_tag_close'] = '</a>';
        $config['next_link'] = 'Next';
        $config['prev_link'] = 'Previous';
        $config["uri_segment"] = 4;
    
        $this->pagination->initialize($config);
        if($this->uri->segment(4))
        {
            $offset = ($this->uri->segment(4));
        }
        else
        {
            $offset = 1;
        }				
        $data["all_agreement"] = $this->client_model->get_client_agreements($user_id,$where_clause,$config["per_page"], ($offset-1)*$config["per_page"]);
        //print_r($data["all_agreement"]);
        $data["company"] = array();
        $data["seller"] = array();
        $data["contract_list"] = array();
        $data["admin_form"] = array();
        foreach($data["all_agreement"] as $key=>$val){
            $seller = $this->client_model->get_agreement_seller($val->id);
            $company = $this->client_model->get_agreement_companies($val->id);
            $contract_list = $this->client_model->get_agreement_list($val->id);
            // if($val->type == "buy"){
            //     $data['buyer_compensation']= $this->client_model->get_contract_attach_detail("buyer_compensation",array("contract_pid"=>$val->id));
            // }
            // if($val->type == "sell"){
            //     $data['sell_compensation']= $this->client_model->get_contract_attach_detail("sell_compensation",array("contract_pid"=>$val->id));
            //     $data['sell_price_term']= $this->client_model->get_contract_attach_detail("sell_price_term",array("contract_pid"=>$val->id));
            // }
            // if($val->type == "tenant"){
            //     $data['tenant_compensation']= $this->client_model->get_contract_attach_detail("sell_compensation",array("contract_pid"=>$val->id));
            // }
            // if($val->type == "lease"){
            //     $data['lease_compensation']= $this->client_model->get_contract_attach_detail("sell_compensation",array("contract_pid"=>$val->id));
            // }
            $data["admin_form"][]= $this->Admin_login->get_contract_file_version($val->contract_id);
            $data["company"][]= $company;
            $data["seller"][]= $seller;
            $data["contract_list"][]= $contract_list;
        }
        // echo '<pre>';
        // print_r($data);
        $data["pagination"] =$this->pagination->create_links();
        $this->framework->init($data,false);
    }
    public function list_contract(){
        if (!$this->session->userdata('user_id')):
			// redirect them to the login page
			echo json_encode(array("msg"=>"Something went wrong.")); exit;
        endif;
        if(!empty($_POST["client_email"])){
        $user_id = $this->session->userdata('user_id');
        $per_page = 10;
        if(isset($_POST["offset"]))
        {
            $offset = $_POST["offset"];
        }
        else
        {
            $offset = 1;
        }
        $where_clause=[]; 
        $data = array();
        $client_data = $this->client_model->get_client_byemail($_POST["client_email"])->row();
        if($client_data){
        $where_clause['client_id'] = $client_data->client_id; 
        $where_clause['pandadoc_id !='] = "";
        $where_clause['panda_status ='] = "document.uploaded";
        $data["all_agreement"] = $this->client_model->get_client_agreements($user_id,$where_clause,$per_page, ($offset-1)*$per_page);
        //print_r($data["all_agreement"]);
        $data["company"] = array();
        $data["seller"] = array();
        $data["contract_list"] = array();
        $data["admin_form"] = array();
        $data["agreements"] = array();
        $data["current_client"] = $client_data->client_id;
        $data["contract_parties"] = $this->client_model->get_client_parties(array("client_id"=>$client_data->client_id));
        foreach($data["all_agreement"] as $key=>$val){
            //if(file_exists("/home/egent/egent.uldev.co/assets/".$val->pdf_name))
            if($key ==1){ $data["current_contract"] = $val->id;}
            $data["agreements"][]= $this->client_model->get_client_agreement($val->id);
        }
        foreach($data["all_agreement"] as $key=>$val){
            // $seller = $this->client_model->get_agreement_seller($val->id);
            // $company = $this->client_model->get_agreement_companies($val->id);
            // $contract_list = $this->client_model->get_agreement_list($val->id);
            $data["admin_form"][]= $this->Admin_login->get_contract_file_version($val->contract_id);
            // $data["company"][]= $company;
            // $data["seller"][]= $seller;
            // $data["contract_list"][]= $contract_list;
        }
        echo json_encode($data);
    }else{
        echo json_encode(array("msg"=>"Client email is not valid")); exit;
    }
    }else{
        echo json_encode(array("msg"=>"Client email is empty")); exit;
    }
    }

    public function get_agreement($id=null){
        if (!$this->session->userdata('id')):
			// redirect them to the login page
			redirect(base_url(''));
        endif;
        if(!empty($id)){
          $agreement =  $this->client_model->get_client_agreement($id);
        }
        $this->load->view('agreement');
    }
    public function get_agreement_details_json($id=null){
        // instantiate and use the dompdf class
        if (!$this->session->userdata('user_id')):
			// redirect them to the login page
			redirect(base_url('Admin'));
        endif;
        if(isset($_POST['id'])){
$id=$_POST['id'];
        }
        $data = array();
        if(!empty($id)){
          $data['agreement'] =  $this->client_model->get_client_agreement($id);
          $data['agreement_list'] =  $this->client_model->get_agreement_list($id);
          if(!empty($data['agreement_list'])){
            $data['agreement_list'] =  $data['agreement_list'];
          }
          
          $data['agreement_parties'] =  $this->client_model->get_agreement_parties($id);
          $data['agreement_seller'] =  $this->client_model->get_agreement_seller($id);
          if(!empty($data['agreement_seller'])){
            $data['agreement_seller'] =  $data['agreement_seller'];
          }
          $data['agreement_companies'] =  $this->client_model->get_agreement_companies($id);
          if(!empty($data['agreement_companies'])){
            $data['agreement_companies'] =  $data['agreement_companies'];
          }
          $data['agreement_deadline'] =  $this->client_model->get_agreement_deadline($id);
          $data['agreement_property'] =  $this->client_model->get_agreement_property($id);
          $data['agreement_inclusion'] =  $this->client_model->get_agreement_inclusion($id);
          if(!empty($data['agreement_inclusion'])){
            $data['agreement_inclusion'] =  $data['agreement_inclusion'];
          }
        }
        echo json_encode($data); exit;
    }
    public function get_agreement_details($id=null){
        // instantiate and use the dompdf class
        if (!$this->session->userdata('user_id')):
			// redirect them to the login page
			redirect(base_url('Admin'));
        endif;
        //Get agreement id
        $contractid = $this->uri->segment(4);
        //Get client data
        $client_id = $this->uri->segment(5);
        $id = $this->uri->segment(3);
        $clients = $this->client_model->get_client($client_id);
        //Get agent data
        $agent = $this->client_model->get_agent_client($this->session->userdata('user_id'));
        // Get new agreements from Admin with contract id
        $agreement = $this->client_model->get_agreement_persisted($contractid);
        $data = array();

        //print_r($data); exit;
        $pdf_html =$this->load->view('agreement', $data, TRUE);
        // if($this->uri->segment(2)=='get_agreement_details'){
        //     //$this->load->view('agreement', $data);
            
        // }
        $contract_doc = $agreement->contract_file;
        $contract_doc = str_replace("{{ client.company }}", $clients->company, $contract_doc);
        $contract_doc = str_replace("{{ client.phone }}", $clients->phone, $contract_doc);
        $contract_doc = str_replace("{{ client.email }}", $clients->email, $contract_doc);

        $contract_doc = str_replace("{{ agent.company }}", $agent->company, $contract_doc);
        $contract_doc = str_replace("{{ agent.phone }}", $agent->phone, $contract_doc);
        $contract_doc = str_replace("{{ agent.email }}", $agent->email, $contract_doc);

        $agreement->contract_file = $contract_doc;
        $clause_data = array("user_id"=>$this->session->userdata('user_id'),"client_id"=>$clients->client_id,"contract_id"=>$agreement->contract_id);
        $agreement_flow = $this->agent_model->get_agreement_flow($clause_data);
        $agreement_flow_val = "";
        if($agreement_flow){
            $agreement_flow_val = $agreement_flow->agreement_flow;
        }
        $id = $this->uri->segment(3); 
        $data = array(
            'session' => $_SESSION,
            'v' => "agreement_details.twig",
            'agent' => $agent,
            'agreement_form' => $agreement,
            'agreement_id' => $id,
            'client' => $clients,
            'agreement_flow'=>$agreement_flow_val,
            'agreement_pdf'=>''
        );

            if(!empty($id)){
                $data['agreement'] =  $this->client_model->get_client_agreement($id);
                if(!empty($data['agreement'][0]->pdf_name)){
                    $data['agreement_pdf']= "/assets/contract_pdf/".$data['agreement'][0]->pdf_name;
                }
                
                $data['agreement_list'] =  $this->client_model->get_agreement_list($id);
                if(!empty($data['agreement_list'])){
                  $data['agreement_list'] =  $data['agreement_list'];
                }
                
                $data['agreement_parties'] =  $this->client_model->get_agreement_parties($id);
                $data['agreement_seller'] =  $this->client_model->get_agreement_seller($id);
                if(!empty($data['agreement_seller'])){
                  $data['agreement_seller'] =  $data['agreement_seller'];
                }
                $data['agreement_companies'] =  $this->client_model->get_agreement_companies($id);
                if(!empty($data['agreement_companies'])){
                  $data['agreement_companies'] =  $data['agreement_companies'];
                }
                $data['agreement_deadline'] =  $this->client_model->get_agreement_deadline($id);
                $data['agreement_inclusion'] =  $this->client_model->get_agreement_inclusion($id);
                if(!empty($data['agreement_inclusion'])){
                  $data['agreement_inclusion'] =  $data['agreement_inclusion'];
                }
                // $config = array();
				// $config["base_url"] = base_url() . "Agreement/get_agreement_details/".$id."/".$client_id."/".$contractid."/";
				// $total_row =  $this->Message_model->count_contract_recipient($client_id);
				// $config["total_rows"] = $total_row; 
				// $config["per_page"] = 5;
				// $config['use_page_numbers'] = TRUE;
				// $config['num_links'] = 10;
				// $config['cur_tag_open'] = '&nbsp;<a class="current">';
				// $config['cur_tag_close'] = '</a>';
				// $config['next_link'] = 'Next';
				// $config['prev_link'] = 'Previous';
				// $config["uri_segment"] = 6;
			
				// $this->pagination->initialize($config);
				// if($this->uri->segment(6))
				// {
				// 	$offset = ($this->uri->segment(6));
				// }
				// else
				// {
				// 	$offset = 1;
				// }

                $data["recipient"] =$this->Message_model->get_contract_recipient($id);
                //$data["pagination"] =$this->pagination->create_links();
            }
              if(empty($this->client_model->check_agreement_info($id))){
                $data["agreement"] = "";
            }
              //print_r($data); exit;
        $this->framework->init($data, false);
    }
    public function get_agreement_pdf($id){
        // instantiate and use the dompdf class
        if (!$this->session->userdata('user_id')):
			// redirect them to the login page
			redirect(base_url('Admin'));
        endif;
        $data = array();
        if(!empty($id)){
          $data['agreement'] =  $this->client_model->get_client_agreement($id);
          $data['agreement_list'] =  $this->client_model->get_agreement_list($id);
          if(!empty($data['agreement_list'])){
            $data['agreement_list'] =  $data['agreement_list'];
          }
          
          $data['agreement_parties'] =  $this->client_model->get_agreement_parties($id);
          $data['agreement_seller'] =  $this->client_model->get_agreement_seller($id);
          if(!empty($data['agreement_seller'])){
            $data['agreement_seller'] =  $data['agreement_seller'];
          }
          $data['agreement_companies'] =  $this->client_model->get_agreement_companies($id);
          if(!empty($data['agreement_companies'])){
            $data['agreement_companies'] =  $data['agreement_companies'];
          }
          $data['agreement_deadline'] =  $this->client_model->get_agreement_deadline($id);
          $data['agreement_property'] =  $this->client_model->get_agreement_property($id);
          $data['agreement_inclusion'] =  $this->client_model->get_agreement_inclusion($id);
          if(!empty($data['agreement_inclusion'])){
            $data['agreement_inclusion'] =  $data['agreement_inclusion'];
          }
        }
        
        //print_r($data); exit;
        $pdf_html =$this->load->view('agreement', $data, TRUE);
        //pdfcrowd
        try
{   
    // create an API client instance
    $client = new Pdfcrowd("raviclagtech", "fcba11d416bb695e149e0aa95c387e73");
    $pdf ="";
    // convert a web page and store the generated PDF into a $pdf variable
    // $pdf = $client->convertURI('http://www.google.com/');
    //$pdf = $client->convertURI('http://www.google.com/');
    $pdf = $client->convertHtml($pdf_html);
    // set HTTP response headers
    // header("Content-Type: application/pdf");
    // header("Cache-Control: max-age=0");
    // header("Accept-Ranges: none");
    // header("Content-Disposition: attachment; filename=\"google_com.pdf\"");

    // send the generated PDF 
    //echo $pdf;
}
catch(PdfcrowdException $why)
{
    echo "Pdfcrowd Error: " . $why;
}
        //end pdfcrowd
        //print_r( $pdf_html); exit;
        $dompdf = new Dompdf();
        $dompdf->loadHtml($pdf_html);
        // (Optional) Setup the paper size and orientation
        $dompdf->setPaper('A4', 'portrait');
        // Render the HTML as PDF
        $dompdf->render();
        // Output the generated PDF to Browser
        //$dompdf->stream();
        $output = $dompdf->output();
        $this->load->helper('string');
        $filename = random_string('alnum', 16);
file_put_contents(FCPATH.'assets/contract_pdf/'.$filename.'-'.$data['agreement'][0]->contract_id.'.pdf', $pdf);
return $filename.'-'.$data['agreement'][0]->contract_id.'.pdf';
    }
    public function pandaAuth($pdf_name=null){
        // $client_id = '396b0a09962299615e2f';
        // $client_secret = '2c686086130c14445120a3f387392e58333b821b';
        $client_id = '07ed0eae4e0fad35d057';
        $client_secret = '5f354335aa8bf2b0a0d8c10b01be2968d94f5010';
        $redirect_uri = base_url().'Agreement/testPandaAuth';
        //$this->session->unset_userdata('panda_bearer');
        if(isset($_GET['code']) && !empty($_GET['code'])){
             $this->session->set_userdata('panda_code',$_GET['code']);
             $ch = curl_init();
             $header = 'cache-control: no-cache'.'\r\n';
             $header .="Content-Type: application/x-www-form-urlencoded";
             $data =array('grant_type'=>'authorization_code',
             'client_id'=>$client_id,
             'client_secret'=>$client_secret,
             'code'=>$this->session->userdata('panda_code'),
             'scope'=>'read+write',
             'redirect_uri'=>$redirect_uri
        );
                $url_data = http_build_query($data);
             curl_setopt($ch, CURLOPT_HTTPHEADER, array( $header ));             
             curl_setopt($ch, CURLOPT_URL, 'https://api.pandadoc.com/oauth2/access_token'); 
             curl_setopt($ch, CURLOPT_POST, 1);
             curl_setopt($ch, CURLOPT_POSTFIELDS, $url_data);
             curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
             $curl_response = curl_exec($ch);
             $response_ar= json_decode($curl_response);
             $this->session->set_userdata('panda_bearer',$response_ar->access_token);
             //$this->agent_model->update_agent(array("panda_bearer"=>$response_ar->access_token));
             $this->agent_model->update_admin(array("panda_bearer"=>$response_ar->access_token));
              exit;
        }else{           
            $ch = curl_init();
            curl_setopt($ch, CURLOPT_URL, 'https://app.pandadoc.com/oauth2/authorize?client_id='.$client_id.'&redirect_uri='.$redirect_uri.'&scope=read+write&response_type=code
            ');    
            header('Location:'.'https://app.pandadoc.com/oauth2/authorize?client_id='.$client_id.'&redirect_uri='.$redirect_uri.'&scope=read+write&response_type=code');    
            $curl_response = curl_exec($ch);
            print_r($curl_response); 
            curl_close($ch);
        }
        //$this->load->view('panda');
    }
    public function updatePandaDoc($pdf_name=null,$contract_id=null,$recipient_list=null){
        // $client_id = '396b0a09962299615e2f';
        // $client_secret = '2c686086130c14445120a3f387392e58333b821b';
        $client_id = '07ed0eae4e0fad35d057';
        $client_secret = '5f354335aa8bf2b0a0d8c10b01be2968d94f5010';
        $redirect_uri = base_url().'Agreement/testPandaAuth';
        //$this->session->unset_userdata('panda_bearer');
if($this->session->userdata('panda_bearer')){
// Note that, on UNIX systems, realpath() will return false if a path
// does not exist, but an absolute non-existing path on Windows.
        $file_content='';
        $ch = curl_init();
        $filenames = array(FCPATH.'/assets/contract_pdf/'.$pdf_name);
        $file_path = FCPATH.'/assets/contract_pdf/';
        $file_content=file_get_contents(FCPATH.'/assets/contract_pdf/'.$pdf_name);
        $files = array(array('content'=>$file_content,'filename'=>$filenames[0],'name'=>'file'));

        // array(array("email"=>"tim.quickfix@gmai.com",
        // "first_name"=> "Jane","last_name"=>"Roe", "role"=>"user"))

    $act_data = array('data'=>json_encode(array(
"name"=>"Sample Document from PDF with Field Tags",
"recipients"=>$recipient_list,
"fields"=>array("name"=>array("value"=>"Tim","role"=>"user"),"like"=>array("value"=>true,"role"=>"user")),
"metadata"=>array("salesforce.opportunity_id"=>"123456","my_favorite_pet"=>"Panda"), 
 "parse_form_fields"=> false
    )
)); 
    $url_data = http_build_query($data);
        $boundary =md5(time());        
        $post_data = $this->build_data_files($boundary, $act_data, $files);
        $authorization = "'Authorization: Bearer ".$this->session->userdata('panda_bearer')."'";
        $panda_bearer = $this->session->userdata('panda_bearer');
        $authorization = "Authorization: Bearer ".$this->session->userdata('panda_bearer');
        curl_setopt_array($ch, array( CURLOPT_URL => "https://api.pandadoc.com/public/v1/documents", 
        CURLOPT_RETURNTRANSFER => true, 
        CURLOPT_ENCODING => "", 
        CURLOPT_MAXREDIRS => 10, 
        CURLOPT_TIMEOUT => 30,
        CURLINFO_HEADER_OUT=>TRUE,
         CURLOPT_HTTP_VERSION => CURL_HTTP_VERSION_1_1,
          CURLOPT_CUSTOMREQUEST => "POST",
          CURLOPT_POSTFIELDS => $post_data,
           CURLOPT_HTTPHEADER => array( "Authorization: Bearer ".$this->session->userdata('panda_bearer'), "Cache-Control: no-cache" , "content-type: multipart/form-data; boundary=".$boundary ), ));
           $response = curl_exec($ch);
           $header_info = curl_getinfo($ch,CURLINFO_HEADER_OUT);
          $err = curl_error($ch);
 //print_r($post_data);
curl_close($ch);
            if ($err) {
            echo "cURL Error #:" . $err;
            } else {
            //echo $response;
            $response_ar=json_decode($response);
            $set_data = array();
            $where_clause = array("id"=>$contract_id);
            $set_data["pandadoc_id"] =$response_ar->id;
            $set_data["panda_status"] =$response_ar->status;            
            $this->client_moedl->update_contract($set_data,$where_clause);
            }
        }else{
           
            $ch = curl_init();
            curl_setopt($ch, CURLOPT_URL, 'https://app.pandadoc.com/oauth2/authorize?client_id='.$client_id.'&redirect_uri='.$redirect_uri.'&scope=read+write&response_type=code
            ');    
            header('Location:'.'https://app.pandadoc.com/oauth2/authorize?client_id='.$client_id.'&redirect_uri='.$redirect_uri.'&scope=read+write&response_type=code');    
            $curl_response = curl_exec($ch);
            print_r($curl_response); 
            curl_close($ch);
        }
    }

function testPandaJson(){    
    $token = $this->session->userdata('panda_bearer');    
    
    $documents = new Documents($token);    
    // List all the documents.
    $data = $documents->list();    
    // Search for a document.
    $filter = [
        'q' => 'Search string here'
    ];    
    $data = $documents->list();    
    print_r($data); 

    // Show document details.
    //$data = $documents->details('documentID');    
    // Show document state.
    //$data = $documents->status('documentID');   
    // Download a document
    //$data = $documents->download('documentID', "destination-path");
    $this->load->view('panda');
}

function build_data_files($boundary, $fields, $files){
    $data = '';
    $eol = "\r\n";

    $delimiter = '--' . $boundary;
    foreach ($files as $name => $content) {
        $data .= $delimiter . $eol
            . "Content-Disposition: form-data; name=\"" . $content['name'] . "\"; filename=\"" .basename($content['filename']) . "\"" . $eol
             . "Content-Type: application/pdf".$eol.$eol;
        $data .= $eol;
        $data .= $content['content'] . $eol;
    }
    foreach ($fields as $name => $content) {
        $data .= $delimiter . $eol
            . "Content-Disposition: form-data; name=\"" . $name . "\"".$eol.$eol
            . $content . $eol;
    }
    $data .=  "--".$boundary."--";
    return $data;
}

function flow_check(){
    if(isset($_POST)){
        $data =array('user_id'=>$this->session->userdata('user_id'),'client_id'=>$_POST['client_id'],'contract_id'=>$_POST['contract_id'],'agreement_flow'=>1);
$res =$this->agent_model->update_client_flow($data);
echo json_encode(array('status'=>'success'));
    }
}

function savePdf(){
     // instantiate and use the dompdf class
     if (!$this->session->userdata('user_id')):
        // redirect them to the login page
       // redirect(base_url());
       echo json_encode(array('msg'=>'Session has been expired.','filename'=>'')); exit;
    endif;
    header("Content-type: application/json");
    if($this->client_model->check_agreement_info($this->uri->segment(3))===FALSE){
        echo json_encode(array('msg'=>'Proper data is not available to create pdf.','filename'=>''));
        exit;
    }
    $data = array();
    //print_r($data); exit;
    $pdf_html =$_POST['htmldom'];
    $pdf ="";
    //pdfcrowd
    try
{   
//create an API client instance
//$client = new Pdfcrowd("raviclagtech", "fcba11d416bb695e149e0aa95c387e73");
$client = new Pdfcrowd("qc11", "0090ec742f24de4245e5a5b0cca8970c");
//convert a web page and store the generated PDF into a $pdf variable
// $pdf = $client->convertURI('http://www.google.com/');
// $pdf = $client->convertURI('http://www.google.com/');
$pdf = $client->convertHtml($pdf_html);
//set HTTP response headers
// header("Content-Type: application/pdf");
// header("Cache-Control: max-age=0");
// header("Accept-Ranges: none");
// header("Content-Disposition: attachment; filename=\"google_com.pdf\"");

//send the generated PDF 
//echo $pdf;
}
catch(PdfcrowdException $why)
{
//echo "Pdfcrowd Error: " . $why;
echo json_encode(array('msg'=>'Something went wrong.','filename'=>'')); exit;
}
// $dompdf = new Dompdf();
// $dompdf->loadHtml($pdf_html);
// // (Optional) Setup the paper size and orientation
// $dompdf->setPaper('A4', 'portrait');
// // Render the HTML as PDF
// $dompdf->render();
// // Output the generated PDF to Browser
// //$dompdf->stream();
// $pdf = $dompdf->output();
if(empty($pdf)){
    //print_r($pdf);
    echo json_encode(array('msg'=>'Something went wrong.','filename'=>''));
}else{
    $this->load->helper('string');
    $filename = random_string('alnum', 16);
file_put_contents(FCPATH.'assets/contract_pdf/'.$filename.'-'.$this->uri->segment(4).'.pdf', $pdf);
$actual_file = $filename.'-'.$this->uri->segment(4).'.pdf';
$agreement =  $this->client_model->get_client_agreement($this->uri->segment(3));
$this->client_model->saveagreement_rel(array('id'=>$this->uri->segment(3),'pdf_name'=>$actual_file));
echo json_encode(array('msg'=>'Agreement saved on Panda Doc.','filename'=>$filename.'-'.$this->uri->segment(4).'.pdf','contract'=>$agreement[0]));
exit;
}
}
public function pandaverifyer(){
    $redirect_uri=$this->session->userdata("redirect_uri");
    $client_id = '07ed0eae4e0fad35d057';
    $client_secret = '5f354335aa8bf2b0a0d8c10b01be2968d94f5010';
    if(isset($_GET['code']) && !empty($_GET['code'])){
        $this->session->set_userdata('panda_code',$_GET['code']);
        $ch = curl_init();
        $header = 'cache-control: no-cache'.'\r\n';
        $header .="Content-Type: application/x-www-form-urlencoded";
        $data =array('grant_type'=>'authorization_code',
        'client_id'=>$client_id,
        'client_secret'=>$client_secret,
        'code'=>$this->session->userdata('panda_code'),
        'scope'=>'read+write',
        'redirect_uri'=>base_url(uri_string())
   );
        $url_data = http_build_query($data);
        curl_setopt($ch, CURLOPT_HTTPHEADER, array( $header ));             
        curl_setopt($ch, CURLOPT_URL, 'https://api.pandadoc.com/oauth2/access_token'); 
        curl_setopt($ch, CURLOPT_POST, 1);
        curl_setopt($ch, CURLOPT_POSTFIELDS, $url_data);
        curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
        $curl_response = curl_exec($ch);
        $response_ar= json_decode($curl_response);
        $this->session->set_userdata('panda_bearer',$response_ar->access_token);
        $this->agent_model->update_admin(array("panda_bearer"=>$response_ar->access_token));
        //$this->agent_model->update_agent(array("panda_bearer"=>$response_ar->access_token));
        header("Location:".$redirect_uri);
    }
    //$this->pandadoc->verifyPanda($redirect_uri);
}
public function sendToPandaDoc($contract_pid=null,$pdf_name=null){
        // $client_id = '396b0a09962299615e2f';
        // $client_secret = '2c686086130c14445120a3f387392e58333b821b';
        $client_id = '07ed0eae4e0fad35d057';
        $client_secret = '5f354335aa8bf2b0a0d8c10b01be2968d94f5010';
        $redirect_uri = base_url().'Agreement/pandaverifyer';
        $redirect_uri1 = base_url().'Agreement/sendToPandaDoc';
        if(!empty($contract_pid)){
            $this->session->set_userdata(array("contract_pid"=>$contract_pid,"pdf_name"=>$pdf_name,"redirect_uri"=>$redirect_uri1));
        }else{
            $contract_pid=$this->session->userdata("contract_pid");
            $pdf_name=$this->session->userdata("pdf_name");
        }        
       $recipient_res = $this->client_model->get_client_parties(array("contract_pid"=>$contract_pid));
       $contract_res = $this->client_model->get_client_agreement($contract_pid);
       $client_detail=$this->client_model->get_client($contract_res[0]->client_id); 
       if(!empty( $recipient_res)){
       $recipient_lists =array();
       $recipient_list =array();
       $party_ar=json_decode($recipient_res[0]->party);
       if(json_last_error() == JSON_ERROR_NONE && is_array($party_ar)){
           $party_electronic_ar=json_decode($recipient_res[0]->party_electronic_address);
           foreach($party_ar as $key=>$val){
               if (filter_var($party_electronic_ar[$key], FILTER_VALIDATE_EMAIL)) {
               $recipient_list["first_name"] =$val;
               $recipient_list["last_name"] ="";
               $recipient_list["email"] =  $party_electronic_ar[$key];
               $recipient_list["role"] = "party".$key;
               $recipient_lists[] = $recipient_list;
               }
           }
       }else{
           if (filter_var($recipient_res[0]->party_electronic_address, FILTER_VALIDATE_EMAIL)) {
           $recipient_list["first_name"] =$recipient_res[0]->party;
           $recipient_list["last_name"] ="";
           $recipient_list["email"] =  $recipient_res[0]->party_electronic_address;
           $recipient_list["role"] = "party";
           $recipient_lists[] = $recipient_list;
           }
       }
       
       $broker_ar=json_decode($recipient_res[0]->broker);
       if(json_last_error() == JSON_ERROR_NONE && is_array($broker_ar)){
           $broker_electronic_ar=json_decode($recipient_res[0]->broker_electronic_address);
           foreach($broker_ar as $key=>$val){
               if (filter_var($broker_electronic_ar[$key], FILTER_VALIDATE_EMAIL)) {
               $recipient_list["first_name"] =$val;
               $recipient_list["last_name"] ="";
               $recipient_list["email"] =  $broker_electronic_ar[$key];
               $recipient_list["role"] = "broker".$key;
               $recipient_lists[] = $recipient_list;
               }
           }
       }else{
           if (filter_var($recipient_res[0]->broker_electronic_address, FILTER_VALIDATE_EMAIL)) {
           $recipient_list["first_name"] =$recipient_res[0]->broker;
           $recipient_list["last_name"] ="";
           $recipient_list["email"] =  $recipient_res[0]->broker_electronic_address;
           $recipient_list["role"] = "broker";
           $recipient_lists[] = $recipient_list;
           }
       }
       
       $brokerage_ar=json_decode($recipient_res[0]->brokerage);
       if(json_last_error() == JSON_ERROR_NONE && is_array($brokerage_ar)){
           $brokerage_electronic_ar=json_decode($recipient_res[0]->brokerage_electronic_address);
           foreach($brokerage_ar as $key=>$val){
               if (filter_var($brokerage_electronic_ar[$key], FILTER_VALIDATE_EMAIL)) {
               $recipient_list["first_name"] =$val;
               $recipient_list["last_name"] ="";
               $recipient_list["email"] =  $brokerage_electronic_ar[$key];
               $recipient_list["role"] = "brokerage".$key;
               $recipient_lists[] = $recipient_list;
               }
           }
       }else{
           if (filter_var($recipient_res[0]->brokerage_electronic_address, FILTER_VALIDATE_EMAIL)) {
           $recipient_list["first_name"] =$recipient_res[0]->brokerage;
           $recipient_list["last_name"] ="";
           $recipient_list["email"] =  $recipient_res[0]->brokerage_electronic_address;
           $recipient_list["role"] = "brokerage";
           $recipient_lists[] = $recipient_list;
           }
       }
       
       $party_seller_ar=json_decode($recipient_res[0]->party_seller);
       if(json_last_error() == JSON_ERROR_NONE && is_array($party_seller_ar)){
           $party_seller_electronic_ar=json_decode($recipient_res[0]->party_seller_electronic_address);
           foreach($party_seller_ar as $key=>$val){
               if (filter_var($party_seller_electronic_ar[$key], FILTER_VALIDATE_EMAIL)) {
               $recipient_list["first_name"] =$val;
               $recipient_list["last_name"] ="";
               $recipient_list["email"] =  $party_seller_electronic_ar[$key];
               $recipient_list["role"] = "party_seller".$key;
               $recipient_lists[] = $recipient_list;
               }
           }
       }else{
           if (filter_var($recipient_res[0]->party_seller_electronic_address, FILTER_VALIDATE_EMAIL)) {
           $recipient_list["first_name"] =$recipient_res[0]->party_seller;
           $recipient_list["last_name"] ="";
           $recipient_list["email"] =  $recipient_res[0]->party_seller_electronic_address;
           $recipient_list["role"] = "party_seller";
           $recipient_lists[] = $recipient_list;
           }
       }       
      foreach($recipient_lists as $key=>$val){
          if($val["email"]==$client_detail->email){
              array_splice($recipient_lists,$key);
          }
      }
    }
      $recipient_list["first_name"] =$client_detail->first_name;
      $recipient_list["last_name"] =$client_detail->last_name;
      $recipient_list["email"] =  $client_detail->email;
      $recipient_list["role"] = "user";
      $recipient_lists[] = $recipient_list; 
      //print_r($recipient_lists);
      $recipient_lists=$this->unique_multidim_array($recipient_lists,"email");
      //print_r($recipient_lists); exit;
      $admin_file=$this->client_model->get_admin_file($contract_res[0]->contract_id);

try{
    $file_content='';
    $ch = curl_init();
    $filenames = array(FCPATH.'/assets/contract_pdf/'.$pdf_name);
    $file_path = FCPATH.'/assets/contract_pdf/';  
    $file_content=file_get_contents(FCPATH.'/assets/contract_pdf/'.$pdf_name);
    $files = array(array('content'=>$file_content,'filename'=>$filenames[0],'name'=>'file'));

    // array(array("email"=>"tim.quickfix@gmai.com",
    // "first_name"=> "Jane","last_name"=>"Roe", "role"=>"user"))

$act_data = array('data'=>json_encode(array(
"name"=>$admin_file->contractname,
"recipients"=>$recipient_lists,
"fields"=>array("contractSignature"=>array("value"=>"","role"=>"user"),"contractDate"=>array("value"=>"","role"=>"user")),
"metadata"=>array("salesforce.opportunity_id"=>"123456","my_favorite_pet"=>"Panda"), 
"parse_form_fields"=> true
)
));
//print_r($act_data);
    $boundary =md5(time());        
    $post_data = $this->build_data_files($boundary, $act_data, $files);
    $authorization = "'Authorization: Bearer ".$this->session->userdata('panda_bearer')."'";
    $panda_bearer = $this->session->userdata('panda_bearer');
    $authorization = "Authorization: Bearer ".$this->session->userdata('panda_bearer');
    curl_setopt_array($ch, array( CURLOPT_URL => "https://api.pandadoc.com/public/v1/documents", 
    CURLOPT_RETURNTRANSFER => true, 
    CURLOPT_ENCODING => "", 
    CURLOPT_MAXREDIRS => 10, 
    CURLOPT_TIMEOUT => 30,
    CURLINFO_HEADER_OUT=>TRUE,
     CURLOPT_HTTP_VERSION => CURL_HTTP_VERSION_1_1,
      CURLOPT_CUSTOMREQUEST => "POST",
      CURLOPT_POSTFIELDS => $post_data,
       CURLOPT_HTTPHEADER => array( "Authorization: Bearer ".$this->session->userdata('panda_bearer'), "Cache-Control: no-cache" , "content-type: multipart/form-data; boundary=".$boundary ), ));
       $response = curl_exec($ch);
       $header_info = curl_getinfo($ch,CURLINFO_HEADER_OUT);
      $err = curl_error($ch);
//print_r($post_data);
curl_close($ch);
        if ($err) {
            //print_r($err);
            throw new Exception("Curl is not connected");
        //echo "cURL Error #:" . $err;
        } else {
        //echo $response;
        $response_ar=json_decode($response);
        //print_r($response_ar); exit;
        $set_data = array();
        if(isset($response_ar->id) && $response_ar->id !=""){
        $where_clause = array("id"=>$contract_pid);
        $set_data["pandadoc_id"] =$response_ar->id;
        $set_data["panda_status"] =$response_ar->status;
        $this->session->unset_userdata(array("contract_pid","pdf_name","redirect_uri"));            
        $this->client_model->update_contract($set_data,$where_clause);
        $this->session->set_flashdata(array("msg"=>"Document is submitted."));
        header("Location:".base_url("Client/view/".$contract_res[0]->client_id));
        }elseif(isset($response_ar->type) && $response_ar->type =="validation_error"){
            //print_r($response_ar);
            throw new Exception("Validation error is found.");
        }else if(isset($response_ar->type) && $response_ar->type =="permissions_error"){    
            throw new Exception("Permission error is found.");
        }else if(isset($response_ar->type) && $response_ar->type == "authentication_error"){    
            //print_r('Location:https://app.pandadoc.com/oauth2/authorize?client_id='.$client_id.'&redirect_uri='.$redirect_uri.'&scope=read+write&response_type=code');exit;
            header('Location: https://app.pandadoc.com/oauth2/authorize?client_id='.$client_id.'&redirect_uri='.$redirect_uri.'&scope=read+write&response_type=code');    
        }        
        else{
            throw new Exception("Document is not submitted.");
        }
        }
        }catch(Exception $e){
$this->session->set_flashdata(array("msg"=>$e->getMessage()));
header("Location:".base_url("Client/view/".$contract_res[0]->client_id));
        }               
}
public function sendAgainToPandaDoc($contract_pid=null,$pdf_name=null){
    // $client_id = '396b0a09962299615e2f';
    // $client_secret = '2c686086130c14445120a3f387392e58333b821b';
    $client_id = '07ed0eae4e0fad35d057';
    $client_secret = '5f354335aa8bf2b0a0d8c10b01be2968d94f5010';
    $redirect_uri = base_url().'Agreement/pandaverifyer';
    $redirect_uri1 = base_url().'Agreement/sendAgainToPandaDoc';
    if(!empty($contract_pid)){
        $this->session->set_userdata(array("contract_pid"=>$contract_pid,"pdf_name"=>$pdf_name,"redirect_uri"=>$redirect_uri1));
    }else{
        $contract_pid=$this->session->userdata("contract_pid");
        $pdf_name=$this->session->userdata("pdf_name");
    }        
   $recipient_res = $this->client_model->get_client_parties(array("contract_pid"=>$contract_pid));
   $contract_res = $this->client_model->get_client_agreement($contract_pid);
   $client_detail=$this->client_model->get_client($contract_res[0]->client_id); 
   if(!empty( $recipient_res)){
   $recipient_lists =array();
   $recipient_list =array();
   $party_ar=json_decode($recipient_res[0]->party);
   if(json_last_error() == JSON_ERROR_NONE && is_array($party_ar)){
       $party_electronic_ar=json_decode($recipient_res[0]->party_electronic_address);
       foreach($party_ar as $key=>$val){
           if (filter_var($party_electronic_ar[$key], FILTER_VALIDATE_EMAIL)) {
           $recipient_list["first_name"] =$val;
           $recipient_list["last_name"] ="";
           $recipient_list["email"] =  $party_electronic_ar[$key];
           $recipient_lists[] = $recipient_list;
           }
       }
   }else{
       if (filter_var($recipient_res[0]->party_electronic_address, FILTER_VALIDATE_EMAIL)) {
       $recipient_list["first_name"] =$recipient_res[0]->party;
       $recipient_list["last_name"] ="";
       $recipient_list["email"] =  $recipient_res[0]->party_electronic_address;
       $recipient_lists[] = $recipient_list;
       }
   }
   
   $broker_ar=json_decode($recipient_res[0]->broker);
   if(json_last_error() == JSON_ERROR_NONE && is_array($broker_ar)){
       $broker_electronic_ar=json_decode($recipient_res[0]->broker_electronic_address);
       foreach($broker_ar as $key=>$val){
           if (filter_var($broker_electronic_ar[$key], FILTER_VALIDATE_EMAIL)) {
           $recipient_list["first_name"] =$val;
           $recipient_list["last_name"] ="";
           $recipient_list["email"] =  $broker_electronic_ar[$key];
           $recipient_lists[] = $recipient_list;
           }
       }
   }else{
       if (filter_var($recipient_res[0]->broker_electronic_address, FILTER_VALIDATE_EMAIL)) {
       $recipient_list["first_name"] =$recipient_res[0]->broker;
       $recipient_list["last_name"] ="";
       $recipient_list["email"] =  $recipient_res[0]->broker_electronic_address;
       $recipient_lists[] = $recipient_list;
       }
   }
   
   $brokerage_ar=json_decode($recipient_res[0]->brokerage);
   if(json_last_error() == JSON_ERROR_NONE && is_array($brokerage_ar)){
       $brokerage_electronic_ar=json_decode($recipient_res[0]->brokerage_electronic_address);
       foreach($brokerage_ar as $key=>$val){
           if (filter_var($brokerage_electronic_ar[$key], FILTER_VALIDATE_EMAIL)) {
           $recipient_list["first_name"] =$val;
           $recipient_list["last_name"] ="";
           $recipient_list["email"] =  $brokerage_electronic_ar[$key];
           $recipient_lists[] = $recipient_list;
           }
       }
   }else{
       if (filter_var($recipient_res[0]->brokerage_electronic_address, FILTER_VALIDATE_EMAIL)) {
       $recipient_list["first_name"] =$recipient_res[0]->brokerage;
       $recipient_list["last_name"] ="";
       $recipient_list["email"] =  $recipient_res[0]->brokerage_electronic_address;
       $recipient_lists[] = $recipient_list;
       }
   }
   
   $party_seller_ar=json_decode($recipient_res[0]->party_seller);
   if(json_last_error() == JSON_ERROR_NONE && is_array($party_seller_ar)){
       $party_seller_electronic_ar=json_decode($recipient_res[0]->party_seller_electronic_address);
       foreach($party_seller_ar as $key=>$val){
           if (filter_var($party_seller_electronic_ar[$key], FILTER_VALIDATE_EMAIL)) {
           $recipient_list["first_name"] =$val;
           $recipient_list["last_name"] ="";
           $recipient_list["email"] =  $party_seller_electronic_ar[$key];
           $recipient_lists[] = $recipient_list;
           }
       }
   }else{
       if (filter_var($recipient_res[0]->party_seller_electronic_address, FILTER_VALIDATE_EMAIL)) {
       $recipient_list["first_name"] =$recipient_res[0]->party_seller;
       $recipient_list["last_name"] ="";
       $recipient_list["email"] =  $recipient_res[0]->party_seller_electronic_address;
       $recipient_lists[] = $recipient_list;
       }
   }       
  foreach($recipient_lists as $key=>$val){
      if($val["email"]==$client_detail->email){
          array_splice($recipient_lists,$key);
      }
  }
}
  $recipient_list["first_name"] =$client_detail->first_name;
  $recipient_list["last_name"] =$client_detail->last_name;
  $recipient_list["email"] =  $client_detail->email;
  $recipient_lists[] = $recipient_list; 
  $admin_file=$this->client_model->get_admin_file($contract_res[0]->contract_id);

try{
$file_content='';
$ch = curl_init();
$filenames = array(FCPATH.'/assets/contract_pdf/'.$pdf_name);
$file_path = FCPATH.'/assets/contract_pdf/';  
$file_content=file_get_contents(FCPATH.'/assets/contract_pdf/'.$pdf_name);
$files = array(array('content'=>$file_content,'filename'=>$filenames[0],'name'=>'file'));

// array(array("email"=>"tim.quickfix@gmai.com",
// "first_name"=> "Jane","last_name"=>"Roe", "role"=>"user"))

$act_data = array('data'=>json_encode(array(
"name"=>$admin_file->contractname,
"recipients"=>$recipient_lists,
"fields"=>array("name"=>array("value"=>"Tim","role"=>"user"),"like"=>array("value"=>true,"role"=>"user")),
"metadata"=>array("salesforce.opportunity_id"=>"123456","my_favorite_pet"=>"Panda"), 
"parse_form_fields"=> true
)
));
//print_r($act_data);
$boundary =md5(time());        
$post_data = $this->build_data_files($boundary, $act_data, $files);
$authorization = "'Authorization: Bearer ".$this->session->userdata('panda_bearer')."'";
$panda_bearer = $this->session->userdata('panda_bearer');
$authorization = "Authorization: Bearer ".$this->session->userdata('panda_bearer');
curl_setopt_array($ch, array( CURLOPT_URL => "https://api.pandadoc.com/public/v1/documents", 
CURLOPT_RETURNTRANSFER => true, 
CURLOPT_ENCODING => "", 
CURLOPT_MAXREDIRS => 10, 
CURLOPT_TIMEOUT => 30,
CURLINFO_HEADER_OUT=>TRUE,
 CURLOPT_HTTP_VERSION => CURL_HTTP_VERSION_1_1,
  CURLOPT_CUSTOMREQUEST => "POST",
  CURLOPT_POSTFIELDS => $post_data,
   CURLOPT_HTTPHEADER => array( "Authorization: Bearer ".$this->session->userdata('panda_bearer'), "Cache-Control: no-cache" , "content-type: multipart/form-data; boundary=".$boundary ), ));
   $response = curl_exec($ch);
   $header_info = curl_getinfo($ch,CURLINFO_HEADER_OUT);
  $err = curl_error($ch);
//print_r($post_data);
curl_close($ch);
    if ($err) {
        //print_r($err);
        throw new Exception("Curl is not connected");
    //echo "cURL Error #:" . $err;
    } else {
    //echo $response;
    $response_ar=json_decode($response);
    //print_r($response_ar); exit;
    $set_data = array();
    if(isset($response_ar->id) && $response_ar->id !=""){
    $where_clause = array("id"=>$contract_pid);
    $set_data["pandadoc_id"] =$response_ar->id;
    $set_data["panda_status"] =$response_ar->status;
    $this->session->unset_userdata(array("contract_pid","pdf_name","redirect_uri"));            
    $this->client_model->update_contract($set_data,$where_clause);
    //$this->session->set_flashdata(array("msg"=>"Document is submitted."));
    header("Location:".base_url("Message/compose/contract/".$contract_res[0]->client_id."/".$contract_res[0]->id));
    }elseif(isset($response_ar->type) && $response_ar->type =="validation_error"){
        //print_r($response_ar);
        throw new Exception("Validation error is found.");
    }else if(isset($response_ar->type) && $response_ar->type =="permissions_error"){    
        throw new Exception("Permission error is found.");
    }else if(isset($response_ar->type) && $response_ar->type == "authentication_error"){    
        //print_r('Location:https://app.pandadoc.com/oauth2/authorize?client_id='.$client_id.'&redirect_uri='.$redirect_uri.'&scope=read+write&response_type=code');exit;
        header('Location: https://app.pandadoc.com/oauth2/authorize?client_id='.$client_id.'&redirect_uri='.$redirect_uri.'&scope=read+write&response_type=code');    
    }        
    else{
        throw new Exception("Document is not submitted.");
    }
    }
    }catch(Exception $e){
$this->session->set_flashdata(array("msg"=>$e->getMessage()));
header("Location:".base_url("Client/view/".$contract_res[0]->client_id));
    }               
}
function comment(){
    // instantiate and use the dompdf class
    if (!$this->session->userdata('user_id')):
       // redirect them to the login page
       redirect(base_url(''));
   endif;
   header("Content-type: application/json");
   $receiver_id ="";
   $sender_id =$this->session->userdata('user_id');
   $contract_id ="";
   $contract_pid ="";
   $comment ="";
   $title="Contract";
   $user_type="";
   if(!empty($this->uri->segment(4))){
    $receiver_id =$this->uri->segment(4);
   }
//    if(!empty($this->uri->segment(4))){
//     $contract_id =$this->uri->segment(4);
//    }
   if(!empty($this->uri->segment(3))){
    $contract_pid =$this->uri->segment(3);
    $contract_id =$this->client_model->get_client_agreement($contract_pid)[0]->contract_id;
   }
   if(!empty($_POST['comment'])){
    $comment =$_POST['comment'];
   }
   if(!empty($_POST['user_type'])){
    $user_type =$_POST['user_type'];
   }
if(!empty($comment)){
    if(!empty($user_type) && !empty($sender_id) && !empty($receiver_id) && !empty($contract_id) && !empty($contract_pid)){
        $set_data = array(
            "sender_id"=>$sender_id,
            "receiver_id"=>$receiver_id,
            "contract_id"=>$contract_id,
            "contract_pid"=>$contract_pid,
            "title"=>$title,
            "message"=>$comment,
            "receiver_type"=>$user_type
        );

        echo json_encode(array("msg"=>"Comment is created successfully.","data"=>$set_data));             
        $this->Message_model->creatMessages($set_data);
    }else{
        echo json_encode(array("msg"=>"Something went wrong."));             
    }
}else{
    echo json_encode(array("msg"=>"Comment field is empty.")); 
}
   
}
/* print the contents of a url */
function print_r_xml($arr,$wrapper = 'data',$cycle = 1)
{
	//useful vars
	$new_line = "\n";
    $output ='';
	//start building content
	if($cycle == 1) { $output = '<?xml version="1.0" encoding="UTF-8" ?>'.$new_line; }
	$output.= $this->tabify($cycle - 1).'<'.$wrapper.'>'.$new_line;
	foreach($arr as $key => $val)
	{
        if($key != 'contract_file'){
		if(!is_array($val))
		{
			$output.= $this->tabify($cycle).'<'.htmlspecialchars($key).'>'.$val.'</'.htmlspecialchars($key).'>'.$new_line;
		}
		else
		{
			$output.= $this->print_r_xml($val,$key,$cycle + 1).$new_line;
        }
    }
	}
	$output.= $this->tabify($cycle - 1).'</'.$wrapper.'>';

	//return the value
	return $output;
}

/* tabify */
function tabify($num_tabs)
{   $return="";
	for($x = 1; $x <= $num_tabs; $x++) { $return.= "\t"; }
	return $return;
}
function unique_multidim_array($array, $key) { 
    $temp_array = array(); 
    $i = 0; 
    $key_array = array(); 
    
    foreach($array as $val) { 
        if (!in_array($val[$key], $key_array)) { 
            $key_array[$i] = $val[$key]; 
            $temp_array[$i] = $val; 
        } 
        $i++; 
    } 
    return $temp_array; 
} 
}

 